( DISASM.FTH ver 1.0 )
( (C) Disassembler K.Peper 1994 )

( This disassembler follows the logic which is given )
( in the "One-Byte-Opcode-Map" by Intel Corporation  )


import( stdio )

var cpu       [ 0 ] ;          ( 0=8086, 2=80286, 4=80486 etc )
var A32       [ 0 ] ;          ( adress: off=16 on=32 bit )
var D32       [ 0 ] ;          ( datum:  off=16 on=32 bit )
var B/W       byte  ;          ( off= byte; on= word or double )   
var mod       byte  ;          ( mod from modR/M-byte )
var reg       byte  ;          ( reg from modR/M-byte )
var R/M       byte  ;          ( R/M from modR/M-byte )
var scale     byte  ;          ( scale in SIB-byte )
var index     byte  ;          ( index in SIB-byte )
var sbase     byte  ;          ( base  in SIB-byte )
var temp      byte  ;          ( temporate use  )
var segreg    byte  ;          ( stores segreg prefix )
var bytecount byte  ;          ( counts instruction bytes )
var DIsave    word  ;          ( stores DI pointer )
var spointer  word 2 ;         ( pointer ES:DI )
var instruction byte 16 ;      ( next 16 code-bytes )
var ipointer  word 2 ;         ( pointer DS:instruction )
var pflag     byte ;           ( prefixflag )

( diesen macros muss eine adresse in eckigen Klammern folgen: )
( Syntax:  al= [ pflag ]   ( mov B/ al,[pflag] )
macro AL= [ $B4 0 $A0 ] ;
macro AL-> [ $A2 ] ;


: nextbyte      ( fetch next code-byte )
[ $26 $8A $05 ] ( mov al,es:[di] )
[ $47 ]         ( inc di )
[ $FE $06 bytecount ] ( inc B/bytecount )
;

: nextword      ( fetch next 2 code-bytes )
[ $26 $8B $05 ] ( mov ax,es:[di] )
[ $47 $47 ]     ( inc di inc di )
[ $FE $06 bytecount ] ( inc B/bytecount )
[ $FE $06 bytecount ] ( inc B/bytecount )
;

: .instr  ( print code-bytes at tab 45 )
al= [ cout ] 44 umin  45 xab - a>b spaces
al= [ cpu ] nib.h  
pflag on? if 'i' else ',' endif emit
space
bytecount m>bl   
instruction
FOR
  [ $AC ] ( lods )
  byte.h
NEXT
;

macro .,    ( print komma )
',' emit
;

: .immB     ( print immediate byte )
nextbyte
byte.h
;

: .immW/D   ( print immediate word or double )
nextword
D32 on?
if apush nextword u.h 3 cpu bl>m apop endif
u.h
;

: .dispW/D  ( print displacement word or double )
nextword
a32 on?
if apush nextword u.h 3 cpu bl>m apop endif
u.h
;

: h.sbyte      ( print signed byte )
[ $89 $C2 ]    ( mov dx,ax )
[ $D0 $E2 ]    ( shl dl,1  )
if [ $F6 $D8 ] ( neg al )
   '-' else '+' endif emit
byte.h
;

: h.sword      ( print signed word )
[ $89 $C2 ]    ( mov dx,ax )
[ $D1 $E2 ]    ( shl dx,1  )
if [ $F7 $D8 ] ( neg ax )
   '-' else '+' endif emit
u.h
;


: .segreg    ( print segmentregister )
( al = reg )
al= [ segreg ]
[ $3C $05 ] ( cmp al,5 )
if- a exit endif
case
0 of " ES"  ;;
1 of " CS"  ;;
2 of " SS"  ;;
3 of " DS"  ;;
4 of " FS"  ;;
5 of " GS"  ;;
endcase $.
;

: .sreg      ( print segmentreg prefix )
( al = reg )
al= [ segreg ]
[ $3C $05 ] ( cmp al,5 )
if- a exit endif
case
0 of " es:"  ;;
1 of " cs:"  ;;
2 of " ss:"  ;;
3 of " ds:"  ;;
4 of " fs:"  ;;
5 of " gs:"  ;;
endcase $.
;


: .wregister   ( print word or double register )
( al = reg )
D32 on? if 'E' emit 3 cpu bl>m endif
[ $25 $07 $00 ] ( and ax,0007 )
ah0
case
0 of " AX" ;;
1 of " CX" ;;
2 of " DX" ;;
3 of " BX" ;;
4 of " SP" ;;
5 of " BP" ;;
6 of " SI" ;;
7 of " DI" ;;
endcase
$.
;

: .bregister    ( print byte register )
( al = reg )
[ $25 $07 $00 ] ( and ax,0007 )
case
0 of " AL" ;;
1 of " CL" ;;
2 of " DL" ;;
3 of " BL" ;;
4 of " AH" ;;
5 of " CH" ;;
6 of " DH" ;;
7 of " BH" ;;
endcase
$.
;

: .reg  ( print byte, word or double register )
( al = reg )
B/W on? if .wregister else .bregister endif
;




( *** memory operators for effective adr *** )

: .adrregister   ( print word or double addresreister )
( al = reg )
A32 on? if 'e' emit 3 cpu bl>m endif
[ $25 $07 $00 ] ( and ax,0007 )
ah0
case
0 of " ax" ;;
1 of " cx" ;;
2 of " dx" ;;
3 of " bx" ;;
4 of " sp" ;;
5 of " bp" ;;
6 of " si" ;;
7 of " di" ;;
endcase
$.
;

: crackSIB   ( fetch and decode SIB byte )
nextbyte 
[ $88 $C4 ]  ( al>ah, save )
[ $24 $07 ]  ( and al,07 )
sbase al>m
[ $88 $E0 ]  ( ah>al )
[ $D1 $E8 ]  ( shr ax,1 )
[ $D1 $E8 ]  ( shr ax,1 )
[ $D1 $E8 ]  ( shr ax,1 )
[ $24 $07 ]  ( and al,07 )
index al>m
[ $88 $E0 ]  ( ah>al )
[ $D1 $E8 ]  ( shr ax,1 )
[ $D1 $E8 ]  ( shr ax,1 )
[ $D1 $E8 ]  ( shr ax,1 )
[ $24 $03 ]  ( and al,03 )
scale al>m 
;

: .SIB  ( handle and print SIB byte )
crackSIB
al= [ sbase ] 
[ $80 $3E mod 0 ] ( cmp B/ mod,0 )
if- z
     [ $80 $3E sbase 5 ] ( cmp B/ sbase,5 )
     if- z .dispW/D  else  .adrregister endif
else .adrregister endif
al= [ index ] 
[ $3C $04 ] ( cmp al,04 )
if- nz
  '+' emit .adrregister '*' emit 
  al= [ scale ]
  case
  0 of '1' ;;
  1 of '2' ;;
  2 of '4' ;;
  3 of '8' ;;
  endcase emit 
endif
;

: .adr-op32    ( print double memory-operator )
3 cpu bl>m 
al= [ R/M ]
case
4 of .SIB ;;
else .adrregister
endcase
;

: .adr-op16   ( print word memory-operator )
al= [ R/M ]
case
0 of " bx+si" ;;
1 of " bx+di" ;;
2 of " bp+si" ;;
3 of " bp+di" ;;
4 of " si" ;;
5 of " di" ;;
6 of " bp" ;;
7 of " bx" ;;
endcase
$.
;

: .adr     ( print effective memory-addres )
.sreg '[' emit
al= [ mod ]
a32 on?
if ( adr= 32 bit )
   3 cpu bl>m 
   case
   0 of
     [ $80 $3E R/M $05 ] ( cmp R/M,05 )
     if- z  .dispW/D else .adr-op32 endif ;;
   1 of
     .adr-op32  '+' emit nextbyte byte.h ;;
   2 of  
     .adr-op32  '+' emit .dispW/D  ;;
   endcase
else ( adr= 16 bit )
 case
   0 of
     [ $80 $3E R/M $06 ] ( cmp R/M,06 )
     if- z  .dispW/D else .adr-op16 endif ;;
   1 of
     .adr-op16  '+' emit nextbyte byte.h ;;
   2 of  
     .adr-op16  '+' emit .dispW/D  ;;
   endcase
endif   
']' emit
;



( modregR/M-byte treatment: )

: crack      ( fetch and decode modR/M-byte )
nextbyte 
[ $88 $C4 ]  ( al>ah, save )
[ $24 $07 ]  ( and al,07 )
al-> [ R/M ]
[ $88 $E0 ]  ( ah>al )
[ $D1 $E8 ]  ( shr ax,1 )
[ $D1 $E8 ]  ( shr ax,1 )
[ $D1 $E8 ]  ( shr ax,1 )
[ $24 $07 ]  ( and al,07 )
al-> [ reg ]
[ $88 $E0 ]  ( ah>al )
[ $D1 $E8 ]  ( shr ax,1 )
[ $D1 $E8 ]  ( shr ax,1 )
[ $D1 $E8 ]  ( shr ax,1 )
[ $24 $03 ]  ( and al,03 )
al-> [ mod ]
;

: .G    ( print register )
al= [ reg ] .reg
;
: .E    ( print mem or register )
al= [ r/m ]
[ $80 $3E mod $03 ] ( cmp mod,3 )
if- nz .adr else .reg endif 
;

( print Data size: )
: .Db " B/ " $. B/W off ;
: .Dw " W/ " $. B/W on  ;
: .Dd " D/ " $. B/W on  3 cpu bl>m ;
: .Dv  d32 on? if .Dd else .Dw endif ;
: .OSb ( operand size byte, get modr/m )
  .Db crack ;
: .OSv ( operand size word or double, get modr/m )
  .Dv crack ;

: sepnib  ( separate nibbles in AL )
[ $D1 $E0 ]  ( shl ax,1  )
[ $D1 $E0 ]  ( shl ax,1  )
[ $D1 $E0 ]  ( shl ax,1  )
[ $D1 $E0 ]  ( shl ax,1  ; first nibble in ah )
[ $D0 $E8 ]  ( shr al,1  )
[ $D0 $E8 ]  ( shr al,1  )
[ $D0 $E8 ]  ( shr al,1  )
[ $D0 $E8 ]  ( shr al,1  ; second nibble in al )
;

: .Jcond  ( print Jumpconditions )
( al = value )
temp on
'J' emit
[ $D0 $E8 ] ( shr al,1 )
if 'N' emit temp off endif
ah0
case
0 of " O    "  ;;
1 of " B    "  ;;
2 of " Z    "  ;;
3 of " BE   "  ;;
4 of " S    "  ;;
5 of " P    "  ;;
6 of " L    "  ;;
7 of " LE   "  ;;
endcase $. temp on? if bl emit endif
;

: inv
" INVALID" $. ;

( subroutines for 2-byte escape: )
: .group6   ( *** ea drucken **** )
2 cpu bl>m 
crack
al= [ reg ]
case
0 of   Pflag on " SLDT"  ;;
1 of   Pflag on " STR"   ;;
2 of   Pflag on " LLDT"  ;;
3 of   Pflag on " LTR"   ;;
4 of   Pflag on " VERR"  ;;
5 of   Pflag on " VERW"  ;;
else " INVALID" 
endcase
$.
;

: .group7
2 cpu bl>m  ( *** ea drucken *** )
crack
al= [ reg ]
case
0 of   Pflag on " SGDT"  ;;
1 of   Pflag on " SIDT"  ;;
2 of   Pflag on " LGDT"  ;;
3 of   Pflag on " LIDT"  ;;
4 of   Pflag on " SMSW"  ;;
5 of " INVALID" ;;
6 of " LMSW i " ;;
7 of " INVALID" ;;
endcase
$.
;

: .group8
crack
al= [ reg ]
case
4 of " BT     " ;;
5 of " BTS    " ;;
6 of " BTR    " ;;
7 of " BTC    " ;;
else " INVALID" 
endcase
$.
;

(long)
: es0
case 
0 of .group6 ;;
1 of .group7 ;;
2 of " LAR    " $. .OSv .G ., .E "  (Ld Access Rights)" $.
     2 cpu bl>m   Pflag on ;; ( *** )
3 of " LSL    " $. .OSv .G ., .E "  (Ld segment Limit)" $.
     2 cpu bl>m   Pflag on ;; ( *** )
6 of " CLTS   (Clr task switched Flag)" $.  2 cpu bl>m   Pflag on ;;
8 of " INVD   (invalidate Cache)" $. 4 cpu bl>m ;;
9 of " WBINVD (Writeback and inval. Cache)" $. 4 cpu bl>m ;;
else inv
endcase
;

: es1
case
1 of " INVPLG " $. crack ( **** ) ;;
else inv
endcase
;
(long)
: es2  ( regnumbers unclear! **** )
case
 0 of " MOV    D/ CR" $. crack reg m>al nib.h .,
                    D32 on R/M m>al .wregister 3 cpu bl>m ;;
 1 of " MOV    D/ DR" $. crack reg m>al nib.h .,
                   D32 on R/M m>al .wregister 3 cpu bl>m ;;
 2 of " MOV    D/ " $. crack  D32 on R/M m>al .wregister " ,CR" $.
                   reg m>al nib.h 3 cpu bl>m ;; 
 3 of " MOV    D/ " $. crack  D32 on R/M m>al .wregister " ,DR" $.
                   reg m>al nib.h 3 cpu bl>m ;;
 4 of " MOV    D/ TR" $. crack reg m>al nib.h .,
                    D32 on R/M m>al .wregister 3 cpu bl>m ;;
 6 of " MOV    D/ " $. crack  D32 on R/M m>al .wregister " ,TR" $.
                   reg m>al nib.h 3 cpu bl>m ;;                                                                                               
else inv
endcase
;

: es8
.Jcond D32 off .Dv
nextword h.sword 
3 cpu bl>m
;

: es9
;

: esA
case
0 of " PUSH   W/ FS" $. ;;
1 of " POP    W/ FS" $. ;;
8 of " PUSH   W/ GS" $. ;;
9 of " POP    W/ GS" $. ;;
endcase
;

: esB
;

(long)
: esC
 4 cpu bl>m 
case
 0 of " XADD  " $. .OSb .E ., .G  ;;
 1 of " XADD  " $. .OSv .E ., .G  ;;
 8 of " BSWAP   EAX" $. ;;
 9 of " BSWAP   ECX" $. ;;
10 of " BSWAP   EDX" $. ;;
11 of " BSWAP   EBX" $. ;;
12 of " BSWAP   ESP" $. ;;
13 of " BSWAP   EBP" $. ;;
14 of " BSWAP   ESI" $. ;;
15 of " BSWAP   EDI" $. ;;
endcase
;

var call0F ( call table for two byte escape routines )
 [ es0 inv es2 inv inv inv inv inv 
   es8 es9 esA esB esC inv inv inv ] ;

: byte0F ( two byte escape )
nextbyte sepnib
( prepare for jump: )
[ $88 $E3 ]  ( mov bl,ah )
ah0
[ $B7 $00 ]  ( mov bh,00 )
[ $D1 $E3 ]  ( shl bx,1  ; word adjust )
call0F       ( calltable base adr to si )
[ $8B $10 ]  ( mov dx,[si+bx] )
[ $FF $D2 ]  ( call dx   )
;



( *** routines for high nibbles : *** )
( *** low nibble in AL            *** )

(long)
: modR/M0-3    ( handle modR/M of high nibbles 0-3 )
al= [ temp ]   ( get code-byte )
[ $25 $07 $00 ] ( and ax,0007 )
case
0 of .OSb .E ., .G ;;
1 of .OSv .E ., .G ;;
2 of .OSb .G ., .E ;;
3 of .OSv .G ., .E ;;
4 of " B/ AL," $. .immB    ;;
5 of .Dv , 0 .reg ., .immW/D  ;;
endcase
;

: nib0
case
 6 of   " PUSH   ES" $. ;;
 7 of   " POP    ES" $. ;;
14 of   " PUSH   CS" $. ;;
15 of   byte0F ;;
 8 <of  " ADD    " $. modR/M0-3 ;;
else    " OR     " $. modR/M0-3
endcase 
;

: nib1
case
 6 of   " PUSH   SS" $. ;;
 7 of   " POP    SS" $. ;;
14 of   " PUSH   DS" $. ;;
15 of   " POP    DS" $. ;;
 8 <of  " ADC    " $. modR/M0-3 ;;
else    " SBB    " $. modR/M0-3
endcase 
;

: nib2
case
 7 of   " DAA" $. ;;
15 of   " DAS" $. ;;
 8 <of  " AND    " $. modR/M0-3 ;;
else    " SUB    " $. modR/M0-3
endcase 
;

: nib3
case
 7 of   " AAA" $. ;;
15 of   " AAS" $. ;;
 8 <of  " XOR    " $. modR/M0-3 ;;
else    " CMP    " $. modR/M0-3
endcase 
;

: nib4
apush
[ $3C $08 ] ( cmp al,08 )
if- b " INC    " else " DEC    " endif $.
.Dv apop .reg
;

: nib5
apush
[ $3C $08 ] ( cmp al,08 )
if- b " PUSH   " else " POP    " endif $.
.Dv apop .reg
;

(long)
: nib6
case
 0 of " PUSHA  " $. ;;
 1 of " POPA   " $. ;;
 2 of " BOUND  " $. .OSv .G ., .dispW/D .dispW/D ;;
 3 of " ARPL   " $. ( ***** )  ;;
 8 of " PUSH   " $. nextword u.h  ;;
 9 of " IMUL   " $. ( ***** ) ;;
10 of " PUSH   B/ " $. .immB  ;;
11 of " IMUL   " $. ( ***** ) ;;
12 of " INS    B/ " $. B/W off  ;;
13 of " INS    " $. .Dv  ;;
14 of " OUTS   B/ " $. B/W off  ;;
15 of " OUTS   " $. .Dv ;;
endcase
;
(short)


: nib7
.Jcond .Db
nextbyte
h.sbyte
;

: .group1    ( sub for nib8 )
crack
al= [ reg ]
case
0 of " ADD    " ;;
1 of " OR     " ;;
2 of " ADC    " ;;
3 of " SBB    " ;;
4 of " AND    " ;;
5 of " SUB    " ;;
6 of " XOR    " ;;
7 of " CMP    " ;;
endcase
$.
;

(long)
: nib8
case
 0 of  .group1 .Db .E ., .immB ;;
 1 of  .group1 .Dv .E ., .immW/D ;;
 2 of " MOV    B/ AL," $. nextbyte h.sbyte ;;
 3 of  .group1 .Db .E ., nextbyte h.sbyte  ;;     
 4 of " TEST   " $. .OSb .E ., .G ;;  
 5 of " TEST   " $. .OSv .E ., .G ;;  
 6 of " EXCHG  " $. .OSb .E ., .G ;;
 7 of " EXCHG  " $. .OSv .E ., .G ;;
 8 of " MOV    " $. .OSb .E ., .G ;;
 9 of " MOV    " $. .OSv .E ., .G ;;
10 of " MOV    " $. .OSb .G ., .E ;;
11 of " MOV    " $. .OSv .G ., .E ;;
12 of " MOV    " $. .OSv D32 off .E ., al= [ reg ] .segreg ;;
13 of " LEA    " $. .OSv .G ., .E ;;
14 of " MOV    " $. .OSv D32 off al= [ reg ] .sreg ., .E ;;
15 of " POP    " $. .OSv .E ;;
endcase
;

: nib9
[ $3C $00 ] ( cmp al,00 )
if- z
   " NOP " $. 
   exit  endif 

[ $3C $08 ] ( cmp al,08 )
if- b
   apush
   " XCHG   " $. .Dv , 0 .reg .,
   apop
   .reg  
   exit endif 
ah0
[ $3C $0A ] ( cmp al,0A )
if- z  " CALL   FAR" $.  exit endif

case
 8 of " CBW" $. ;;
 9 of " CWD" $. ;;
11 of " WAIT" $. ;;
12 of " PUSHF  " $. .Dv ;;
13 of " POPF   " $. .Dv ;;
14 of " SAHF" $. ;;
15 of " LAHF" $. ;;
endcase 
;


(long)
: nibA
case
 0 of " MOV    B/ AL,[" $. .dispW/D ']' emit ;;
 1 of " MOV    " $. .Dv  , 0 .wregister ., '[' emit .dispW/D ']' emit ;;
 2 of " MOV    B/[" $. .dispW/D ']' emit " ,AL " $. ;;
 3 of " MOV    " $. .Dv  '[' emit .dispW/D ']' emit .,  , 0 .wregister ;;
 4 of " MOVS   B/ ( es:[di],ds:[si] )" $. ;;
 5 of " MOVS   " $. .Dv " ( es:[di],ds:[si] )" $. ;;
 6 of " CMPS   B/ ( es:[di],ds:[si] )" $. ;;
 7 of " CMPS   " $. .Dv " ( es:[di],ds:[si] )" $. ;;
 8 of " TEST   B/ AL," $. .immB ;;
 9 of " TEST   " $. .Dv  , 0 .wregister ., .immW/D ;;
10 of " STOS   B/ ( es:[di],AL )" $. ;;
11 of " STOS   " $. .Dv " ( es:[di]," $. , 0 .wregister " )" $. ;;
12 of " LODS   B/ ( AL,ds:[si] )" $. ;;
13 of " LODS   " $. .Dv  " ( " $. , 0 .wregister " ,ds:[si] )" $. ;;
14 of " SCAS   B/ ( AL,ds:[si] )" $. ;;
15 of " SCAS   " $. .Dv  " ( " $. , 0 .wregister " ,ds:[si] )" $. ;;
endcase
;

: nibB
apush
" MOV    " $.
apop apush
[ $3C $08 ] ( cmp al,08 )
if- b
     .Db apop .bregister .,  nextbyte byte.h     
else .Dv apop .wregister .,  nextword u.h
endif
;


: .group2  ( sub for nibC + nibD )
crack
al= [ reg ]
case
0 of " ROL    " ;;
1 of " ROR    " ;;
2 of " RCL    " ;;
3 of " RCR    " ;;
4 of " SHL    " ;;
5 of " SHR    " ;;
6 of " SHL    " ;;
7 of " SAR    " ;;
endcase
$.
;

(long)
: nibC
case
 0 of  .group2 .Db .E ., .immB ;;
 1 of  .group2 .Dv .E ., .immB ;;
 2 of " RET    " $. nextword u.h ;;
 3 of " RET    " $.  ;;     
 4 of " LES    " $. .OSv .G ., .E ;;  
 5 of " LDS    " $. .OSv .G ., .E ;;  
 6 of " MOV    " $. .OSb .E ., .immB ;;
 7 of " MOV    " $. .OSv .E ., .immW/D ;;
 8 of " ENTER  " $. nextword u.h ., .immB ;;
 9 of " LEAVE  " $. ;;
10 of " RETfar " $. nextword u.h ;;
11 of " RETfar " $. ;;
12 of " INT 3  " $.  ;;
13 of " INT    " $. .immB ;;
14 of " INT0   " $. ;;
15 of " IRET   " $. ;;
endcase
;

(long)
: nibD
case
 0 of  .group2 .Db .E  " ,1" $. ;;
 1 of  .group2 .Dv .E  " ,1" $. ;;
 2 of  .group2 .Db .E  " ,cl" $. ;;
 3 of  .group2 .Db .E  " ,cl" $. ;;     
 4 of " AAM    " $. .immB ;;  
 5 of " AAD    " $. .immB ;;  
 6 of " INVALID" $. ;;
 7 of " XLAT   B/ (AL,ds:[bx+al] )" $.  ;;
else  " ESC    " $.
endcase
;

(long)
: nibE
case
 0 of " LOOPNE " $. nextbyte h.sbyte ;;
 1 of " LOOPE  " $. nextbyte h.sbyte ;;
 2 of " LOOP   " $. nextbyte h.sbyte ;;
 3 of " JCXZ   " $. nextbyte h.sbyte ;;     
 4 of " IN     B/ AL," $. .immB ;;  
 5 of " IN     " $. .Dv ., , 0 .reg ;;  
 6 of " OUT    B/ " $. .immB " ,AL" ;;
 7 of " OUT    " $. .OSv .immB , 0 .reg ;;
 8 of " CALLr  " $. nextword u.h a32 on? if nextword u.h endif ;;
 9 of " JMPr   " $. nextword u.h a32 on? if nextword u.h endif ;;
10 of " JMPp   " $. nextword u.h ( **** ) ;;
11 of " JMPs   " $. nextbyte h.sbyte ;;
12 of " IN     B/ AL,DX" $.  ;;
13 of " IN     " $. .Dv , 0 .reg " ,DX" $. ;;
14 of " OUT    B/ DX,AL" $. ;;
15 of " OUT    " $. .Dv " DX," $. , 0 .reg ;;
endcase
;


: .group3    ( sub for nibF )
crack
al= [ reg ]
case
0 of " TEST   " ;;
1 of " TEST   " ;;
2 of " NOT    " ;;
3 of " NEG    " ;;
4 of " MUL    " ;;
5 of " IMUL   " ;;
6 of " DIV    " ;;
7 of " IDIV   " ;;
endcase
$.
;


: .group4   ( sub for nibF )
crack
al= [ reg ]
case
0 of " INC  B/" $. .E ;;
1 of " DEC  B/" $. .E ;;
else " INVALID" $.
endcase
;

(long)
: .group5 ( sub for nibF )
crack
al= [ reg ]
case
0 of " INC    " $. B/W on .E ;;
1 of " DEC    " $. B/W on .E ;;
2 of " CALL   " $. B/W on .E ;;
3 of " CALL2  " $. ( ***** ) ;;
4 of " JMP    " $. B/W on .E ;;
5 of " JMP2    " $. ( **** ) ;;
6 of " PUSH   " $. B/W on .E ;;
7 of " INVALID" $. ;;
endcase
;


(long)
: nibF
case
 1 of " INVALID" $. nextbyte h.sbyte ;;
 4 of " HLT" $. ;;  
 5 of " CMC" $. ;;  
 6 of .group3 .Db ;;
 7 of .group3 .Dv ;;
 8 of " CLC" $. ;;
 9 of " STC" $. ;;
10 of " CLI" $. ;;
11 of " STI" $. ;;
12 of " CLD" $. ;;
13 of " STD" $. ;;
14 of .group4 ;;
15 of .group5 ;;
endcase
;


var callnib   ( call routine according to first nibble )
 [ nib0 nib1 nib2 nib3 nib4 nib5 nib6 nib7
   nib8 nib9 nibA nibB nibC nibD nibE nibF   ] ;
   

: getinstr   ( separate nibbles and call high nibble routine: )
sepnib
( prepare for jump: )
[ $88 $E3 ]  ( mov bl,ah )
[ $B7 $00 ]  ( mov bh,00 )
ah0
[ $D1 $E3 ]  ( shl bx,1  ; word adjust )
callnib      ( calltable base adr to si )
[ $8B $10 ]  ( mov dx,[si+bx] )
[ $FF $D2 ]  ( call dx   )
;

(long)
: prefix   
( check for prefixes: )
-1 segreg bl>m pflag off
 BEGIN
nextbyte  ah0   ( get byte ) 
al-> [ temp ]
case
$26 of   0 segreg bl>m ;;
$2E of   1 segreg bl>m ;;
$36 of   2 segreg bl>m ;;
$3E of   3 segreg bl>m ;;
$64 of   4 segreg bl>m 3 cpu bl>m ;;
$65 of   5 segreg bl>m 3 cpu bl>m ;;
$66 of   D32 toggle    3 cpu bl>m ;;
$67 of   A32 toggle    3 cpu bl>m ;;
$F0 of " LOCK: " $.  pflag on  ;;
$F2 of " REPNE: " $. pflag on   ;;
$67 of " REPE: " $.  pflag on   ;;
else  exit
endcase
AGAIN
;
  

: disasm
( disassemble next byte(s) of instruction at es:di )
( on exit, es:di points to next instruction byte   )
( BX: 0=16bit version, 1=32bit version )

[ $D1 $EB ]  ( shr  bx,1 )
if  A32 on D32 on   else  A32 off D32 off endif
bytecount off cout off cpu off
DIsave d>m
m>a u.h ':' emit bl emit
spointer ed>m
instruction to ipointer dsptr 
spointer to ipointer , 16 memcpy
DIsave m>d 
prefix
pflag on? if cr  6 spaces endif
pflag off
al= [ temp ]
getinstr 
.instr
DIsave m>b  bytecount m>al  + a>d 
cr
;


proc test [  $0f $02 $07  $77 $FD $0F $89 $Fe $7f
$0f $09 0 0
$66 $67 $A0 $90 $90
 $BE $12 $34 $CC $FB $F2
  08 $10 $90
 $a4 $a5 $a6 $66 $a7  $44  $aa $66 $ab $ac $ad
 $26  $67 02 $0c $85 $ec   $08  $10 $90  ( add ebx,es:[eax+disp32] )
 $3E  $67 02 $4c $83 $ec   $08  $10 $90 
 $90
  $b2 $90
   08 $10 $90
$01 $ca         ( add dx,cx )
$03 $16 $34 $12 ( add dx,[adr] )
$01 $16 $34 $12 ( add [adr],dx )
$01 $10         ( add [bx+si],dx )
$03 $10         ( add dx,[bx+si] )
$90

( $67 $83 $48 $00 $00 $10 $EF $FD0 ( add [eax+ecx*2],-3 )
  $83 $81 $EF $10 $FD              ( add [bx+di+10ef],-3 )
  $90
  $64 $66 $01 $16 $34 $12          ( add D/ FS:[1234],EDX )
( $6B $D2 $88   IMUL )
( $69 $D2 $FE   IMUL )
$72 3 $73 3 $76 $FE $77 3
  $66 $05 $01 $75 $90 $90        ( add eAX,iv )
  $66 $4A             ( DEC eDX )
      $59             ( POP eCX )

$9A $92 $79 $1A $7A $EE $7B $0E
$7C $55 $7D $88 $7E $7F $7F $80
 ] ;



: main init 
[ $0E $07 ] ( push cs pop es )
d= test
23 for 0 disasm  next wait
;