	( *** Naxos System-Vocabulary Version 2.11 *** )

	( Name:     macro.fth         )
	( Version:  2.11              )
	( Revision: 11.01             )
	( Datum:    14.03.93          ) 
	( Autoren:  Klaus Peper       )
	(           Alexandros Zissis )


	( --------------------------------------- )
	( NAXOS V2.xx                             )
	( basiert auf MCC, FCC sowie NAXOS V1.xx  )
	( --------------------------------------- )

	( register_notations:                     )
	( AL=al, AH=ah, BL=bl, BH=bh              )
	( AX=a,  BX=b,  DI=d,  ES=e,  SI=adr      )
	( BX:AX=ba,     ES:DI=ed                  )

	( prefixes:                               )
	( u/  unsigned                            )
	( b/  byteoperation                       )
	( d/  doubleoperation                     )

	( c   := char,Byte        8 Bit           )
	( n   := word, signed    16 Bit           )
	( u   := word, unsigned  16 bit           )
	( i   := index, unsigned 16 bit           )
	( d   := doubleword      32 Bit           )
	( adr := adress          16 Bit           )
	( str := adr of countbyte of string       )



	( ********************************* )
	( **     System - Adresses       ** )
	( ********************************* )

	( ** Codesegment ** )

	aconst  entry    $102 ( Main           ) ;
 	aconst  HEAPPARA $10A ( Heapsize in paragraphs ) ;
	aconst  DSEG     $10C ( Datensegment   ) ;
	aconst  SSEG     $10E ( Stacksegment   ) ;
	aconst  exitcode $17A ( Exitcodeadr    ) ;

	( ** Datensegment ** )


	aconst  UpperLoopLimit $0014 ;
	aconst  Conditionstack $0016 ;
	aconst  Exit-Byte      $0018 ;    
	aconst  Break-Byte     $0019 ;    
	aconst  Video-Byte     $001A ;    
	aconst  Mouse-Byte     $001B ;    
	( aconst Old-Int0-ofs  $001C )
	( aconst Old-Int0-seg  $001E )
	aconst  NPUStat        $0020 ;     
	aconst  HEAPSEG        $0022 ;    
	( aconst @SELF-PTR  $0024 )
	( frei $0026..$002F )
	( Start of Vars at $0030 )



	( ******************************* )
	( * Words, Functions, Operators * )
	( ******************************* )

	const TRUE  1 ;
	const FALSE 0 ;


	       MACRO ### 
	( **   Set breakpoint    ** )
	( BR-routine must be active )
	( ************************* )
	( arg: -                    )
	( out: -                    )
	( chg: -                    )
	( ************************* )
	[ $CC ]
	;


	( *** register to register *** )


		 MACRO a>b 
	( ****  copy AX to BX  **** )
	( ************************* )
	( arg: AX = value n         )
	( out: BX:= n               )
	( chg: BX                   )
	( ************************* )
	[ $89 $C3 ]     ( mov bx,ax )
	;

		 MACRO a>d 
	( ****  copy AX to DI  **** )
	( ************************* )
	( arg: AX = value n         )
	( out: DI:= n               )
	( chg: DI                   )
	( ************************* )
	[ $89 $C7 ]     ( mov di,ax )
	;

		 MACRO a>e 
	( ****  copy AX to ES  **** )
	( ************************* )
	( arg: AX = value n         )
	( out: ES:= n               )
	( chg: ES                   )
	( ************************* )
	[ $8E $C0 ]     ( mov es,ax )
	;

		MACRO a>adr 
	( ****  copy AX to SI  **** )
	( ************************* )
	( arg: AX = value n         )
	( out: SI:= n               )
	( chg: SI                   )
	( ************************* )
	[ $89 $C6 ]     ( mov si,ax )
	;

		 MACRO b>a 
	( ****  copy BX to AX  **** )
	( ************************* )
	( arg: BX = value n         )
	( out: AX:= n               )
	( chg: AX                   )
	( ************************* )
	[ $89 $D8 ]     ( mov ax,bx )
	;

		 MACRO b>d 
	( ****  copy BX to DI  **** )
	( ************************* )
	( arg: BX = value n         )
	( out: DI:= n               )
	( chg: DI                   )
	( ************************* )
	[ $89 $DF ]     ( mov di,bx )
	;

		 MACRO b>e 
	( ****  copy BX to ES  **** )
	( ************************* )
	( arg: BX = value n         )
	( out: ES:= n               )
	( chg: ES                   )
	( ************************* )
	[ $8E $C3 ]     ( mov es,bx )
	;

		 MACRO b>adr 
	( ****  copy BX to SI  **** )
	( ************************* )
	( arg: BX = value n         )
	( out: SI:= n               )
	( chg: SI                   )
	( ************************* )
	[ $89 $DE ]     ( mov si,bx )
	;

		 MACRO d>a 
	( ****  copy DI to AX  **** )
	( ************************* )
	( arg: DI = value n         )
	( out: AX:= n               )
	( chg: AX                   )
	( ************************* )
	[ $89 $F8 ]     ( mov ax,di )
	;

		 MACRO d>b 
	( ****  copy DI to BX  **** )
	( ************************* )
	( arg: DI = value n         )
	( out: BX:= n               )
	( chg: BX                   )
	( ************************* )
	[ $89 $FB ]     ( mov bx,di )
	;

		 MACRO d>e 
	( ****  copy DI to ES  **** )
	( ************************* )
	( arg: DI = value n         )
	( out: ES:= n               )
	( chg: ES                   )
	( ************************* )
	[ $8E $C7 ]     ( mov es,di )
	;

		 MACRO d>adr 
	( ****  copy DI to SI  **** )
	( ************************* )
	( arg: DI = value n         )
	( out: SI:= n               )
	( chg: SI                   )
	( ************************* )
	[ $89 $FE ]     ( mov si,di )
	;

		 MACRO e>a 
	( ****  copy ES to AX  **** )
	( ************************* )
	( arg: ES = value n         )
	( out: AX:= n               )
	( chg: AX                   )
	( ************************* )
	[ $8C $C0 ]     ( mov ax,es )
	;

		 MACRO e>b 
	( ****  copy ES to BX  **** )
	( ************************* )
	( arg: ES = value n         )
	( out: BX:= n               )
	( chg: BX                   )
	( ************************* )
	[ $8C $C3 ]     ( mov bx,es )
	;

		 MACRO e>d 
	( ****  copy ES to DI  **** )
	( ************************* )
	( arg: ES = value n         )
	( out: DI:= n               )
	( chg: DI                   )
	( ************************* )
	[ $8C $C7 ]     ( mov di,es )
	;

		 MACRO e>adr 
	( ****  copy ES to SI  **** )
	( ************************* )
	( arg: ES = value n         )
	( out: SI:= n               )
	( chg: SI                   )
	( ************************* )
	[ $8C $C6 ]     ( mov si,es )
	;

		 MACRO adr>a 
	( ****  copy SI to AX  **** )
	( ************************* )
	( arg: SI = value n         )
	( out: AX:= n               )
	( chg: AX                   )
	( ************************* )
	[ $89 $F0 ]     ( mov ax,si )
	;

		 MACRO adr>b 
	( ****  copy SI to BX  **** )
	( ************************* )
	( arg: SI = value n         )
	( out: BX:= n               )
	( chg: BX                   )
	( ************************* )
	[ $89 $F3 ]     ( mov bx,si )
	;

		 MACRO adr>d 
	( ****  copy SI to DI  **** )
	( ************************* )
	( arg: SI = value n         )
	( out: DI:= n               )
	( chg: DI                   )
	( ************************* )
	[ $89 $F7 ]     ( mov di,si )
	;

		 MACRO adr>e 
	( ****  copy SI to ES  **** )
	( ************************* )
	( arg: SI = value n         )
	( out: ES:= n               )
	( chg: ES                   )
	( ************************* )
	[ $8E $C6 ]     ( mov es,si )
	;


		MACRO ba>ed 
	( ** copy BX:AX to ES:DI ** )
	( ************************* )
	( arg: BX:AX = value d      )
	( out: ES:DI:= d            )
	( chg: ES DI                )
	( ************************* )
	[ $89 $C7 ]     ( mov di,ax )
	[ $8E $C3 ]     ( mov es,bx )
	;

		MACRO ed>ba 
	( ** copy ES:DI to BX:AX ** )
	( ************************* )
	( arg: ES:DI value d        )
	( out: BX:AX:= d            )
	( chg: BX AX                )
	( ************************* )
	[ $89 $F8 ]     ( mov ax,di )
	[ $8C $C3 ]     ( mov bx,es )
	;

 
		 MACRO apush 
	( *** push AX to stack **** )
	( ************************* )
	( arg: AX = value n         )
	( out: -                    )
	( chg: -  stack             )
	( ************************* )
	[ $50 ]           ( push ax )
	;
 
		 MACRO bpush 
	( *** push BX to stack **** )
	( ************************* )
	( arg: BX = value n         )
	( out: -                    )
	( chg: -  stack             )
	( ************************* )
	[ $53 ]           ( push bx )
	;
	
		 MACRO cpush 
	( *** push CX to stack **** )
	( ************************* )
	( arg: -                    )
	( out: -                    )
	( chg: -  stack             )
	( ************************* )
	[ $51 ]           ( push cx )
	;
		 MACRO dpush 
	( *** push DI to stack **** )
	( ************************* )
	( arg: DI = value n         )
	( out: -                    )
	( chg: -  stack             )
	( ************************* )
	[ $57 ]           ( push di )
	;
 
		 MACRO epush 
	( *** push ES to stack **** )
	( ************************* )
	( arg: ES = value n         )
	( out: -                    )
	( chg: -  stack             )
	( ************************* )
	[ $06 ]           ( push es )
	;
 
		MACRO adrpush 
	( *** push SI to stack **** )
	( ************************* )
	( arg: SI = value n         )
	( out: -                    )
	( chg: -  stack             )
	( ************************* )
	[ $56 ]           ( push si )
	;

		MACRO bapush 
	( ** push BX:AX to stack ** )
	( ************************* )
	( arg: BX:AX = value d      )
	( out: -                    )
	( chg: -  stack             )
	( ************************* )
	apush bpush
	;
	
		MACRO edpush 
	( ** push BX:AX to stack ** )
	( ************************* )
	( arg: ES:DI = value d      )
	( out: -                    )
	( chg: -  stack             )
	( ************************* )
	dpush epush
	;
 
		 MACRO apop 
	( *** pop AX from stack *** )
	( ************************* )
	( arg: -                    )
	( out: AX:= n               )
	( chg: AX, stack            )
	( ************************* )
	[ $58 ]           ( pop  ax )
	;
 
		  MACRO bpop 
	( *** pop BX from stack *** )
	( ************************* )
	( arg: -                    )
	( out: BX:= n               )
	( chg: BX, stack            )
	( ************************* )
	[ $5B ]           ( pop  bx )
	;
  
		 MACRO cpop 
	( *** pop CX from stack *** )
	( ************************* )
	( arg: -                    )
	( out: -                    )
	( chg: stack                )
	( ************************* )
	[ $59 ]           ( pop  cx )
	;
 
		  MACRO dpop 
	( *** pop DI from stack *** )
	( ************************* )
	( arg: -                    )
	( out: DI:= n               )
	( chg: DI, stack            )
	( ************************* )
	[ $5F ]           ( pop  di )
	;
 
		  MACRO epop 
	( *** pop ES from stack *** )
	( ************************* )
	( arg: -                    )
	( out: ES:= n               )
	( chg: ES, stack            )
	( ************************* )
	[ $07 ]           ( pop  es )
	;
 
		MACRO adrpop 
	( *** pop SI from stack *** )
	( ************************* )
	( arg: -                    )
	( out: SI:= n               )
	( chg: SI, stack            )
	( ************************* )
	[ $5E ]           ( pop  si )
	;

		 MACRO bapop 
	( ** pop BX:AX from stack * )
	( ************************* )
	( arg: -                    )
	( out: BX:AX:= d            )
	( chg: stack   	            )
	( ************************* )
	bpop apop
	;
		 MACRO edpop 
	( * pop ES:DI from stack ** )
	( ************************* )
	( arg: -                    )
	( out: ES:DI:= d            )
	( chg: stack         	    )
	( ************************* )
	epop dpop
	;

		 MACRO a+adr 
	( ****  add SI to AX  ***** )
	( ************************* )
	( arg: AX = value n         )
	(      SI = value adr       )
	( out: AX:= n+adr           )
	( chg: AX                   )
	( ************************* )
	[ $01 $F0 ]    ( add  ax,si )
	;

		 MACRO 1+ 
	( ****  increment AX  ***** )
	( ************************* )
	( arg: AX = value n         )
	( out: AX:= n+1             )
	( chg: AX                   )
	( ************************* )
	[ $40 ]           ( inc  ax )
	;

		MACRO 2+ 
	( *** increment AX by 2 *** )
	( ************************* )
	( arg: AX = value n         )
	( out: AX:= n+2             )
	( chg: AX                   )
	( ************************* )
	[ $40 $40 ] ( inc ax inc ax )
	;

		 MACRO b+ 
	( ****  Increment BX  ***** )
	( ************************* )
	( arg: BX = value n         )
	( out: BX:= n+1             )
	( chg: BX                   )
	( ************************* )
	[ $43 ]           ( inc  bx )
	;

		 MACRO cinc 
	( ****  Increment CX  ***** )
	( ************************* )
	( arg: -                    )
	( out: -                    )
	( chg: -                    )
	( ************************* )
	[ $41 ]           ( inc  cx )
	;
		 MACRO d+ 
	( ****  increment DI  ***** )
	( ************************* )
	( arg: DI = value n         )
	( out: DI:= n+1             )
	( chg: DI                   )
	( ************************* )
	[ $47 ]           ( inc  di )
	;

		MACRO adr+ 
	( ****  increment SI  ***** )
	( ************************* )
	( arg: SI = value n         )
	( out: SI:= n+1             )
	( chg: SI                   )
	( ************************* )
	[ $46 ]           ( inc  si )
	;

		MACRO adr2+ 
	( *** increment SI by 2 *** )
	( ************************* )
	( arg: SI = value n         )
	( out: SI:= n+2             )
	( chg: SI                   )
	( ************************* )
	[ $46 $46 ] ( inc si inc si )
	;

		MACRO adrn+ 
	( ***  change SI by n  **** )
	( ************************* )
	( arg: AX = value n         )
	(      SI = value adr       )
	( out: SI:= adr+n           )
	( chg: SI                   )
	( ************************* )
	[ $01 $C6 ]    ( add  si,ax )
	;

		 MACRO 1- 
	( ****  decrement AX  ***** )
	( ************************* )
	( arg: AX = value n         )
	( out: AX:= n-1             )
	( chg: AX                   )
	( ************************* )
	[ $48 ]           ( dec  ax )
	;

		 MACRO 2- 
	( **  decrement AX by 2  ** )
	( ************************* )
	( arg: AX = value n         )
	( out: AX:= n-2             )
	( chg: AX                   )
	( ************************* )
	[ $48 $48 ] ( dec ax dec ax )
	;

		  MACRO b- 
	( ****  decrement BX  ***** )
	( ************************* )
	( arg: BX = value n         )
	( out: BX:= n-1             )
	( chg: BX                   )
	( ************************* )
	[ $4B ]           ( dec  bx )
	;

		  MACRO d- 
	( ****  decrement DI  ***** )
	( ************************* )
	( arg: DI = value n         )
	( out: DI:= n-1             )
	( chg: DI                   )
	( ************************* )
	[ $4F ]           ( dec  di )
	;

		 MACRO adr- 
	( ****  decrement SI  ***** )
	( ************************* )
	( arg: SI = value n         )
	( out: SI:= n-1             )
	( chg: SI                   )
	( ************************* )
	[ $4E ]           ( dec  si )
	;

		 MACRO adr2- 
	( **  decrement SI by 2  ** )
	( ************************* )
	( arg: SI = value n         )
	( out: SI:= n-2             )
	( chg: SI                   )
	( ************************* )
	[ $4E $4E ] ( dec si dec si )
	;
	
		 MACRO ah0 
	( **    set AH:= 00      ** )
	( ************************* )
	( arg: -                    )
	( out: AH:= 00              )
	( chg: AH                   )
	( ************************* )
	[ $30 $E4 ]     ( xor ah,ah )
	;
	macro LO ( arg: ax, out: ax=$00AL, chg: ah )
	  ah0 
	; 
	macro HI ( arg: ax, out ax=$00AH, chg: ax )
	  [ $88 $E0   ( mov al,ah )
	  $30 $E4 ]   ( xor ah,ah )
	;
	
		 MACRO bh0 
	( **    set BH:= 00      ** )
	( ************************* )
	( arg: -                    )
	( out: BH:= 00              )
	( chg: BH                   )
	( ************************* )
	[ $30 $FF ]     ( xor bh,bh )
	;       

	
		 MACRO xab 
	( ** exchange AX and BX  ** )
	( ************************* )
	( arg: AX = n1 BX = n2      )
	( out: AX:= n2 BX:= n1      )
	( chg: AX,BX                )
	( ************************* )
	[ $93 ]        ( xchg ax,bx )
	;

		 MACRO xad 
	( ** exchange AX and DI  ** )
	( ************************* )
	( arg: AX = n1 DI = n2      )
	( out: AX:= n2 DI:= n1      )
	( chg: AX,DI                )
	( ************************* )
	[ $97 ]        ( xchg ax,di )
	;

		 MACRO ds>e 
	( ***** set ES to DS  ***** )
	( ************************* )
	( arg: -                    )
	( out: ES:= dataseg         )
	( chg: ES                   )
	( ************************* )
	[ $8C $DA ]    ( mov  dx,ds )
	[ $8E $C2 ]    ( mov  es,dx )
	;

	 MACRO cs>e 
	( ***** set ES to CS  ***** )
	( ************************* )
	( arg: -                    )
	( out: ES:= codeseg         )
	( chg: ES                   )
	( ************************* )
	[ $8C $CA ]    ( mov  dx,cs )
	[ $8E $C2 ]    ( mov  es,dx )
	;



	( *** simple arithmetic *** )


		  MACRO + 
	( ****  add BX to AX  ***** )
	( ************************* )
	( arg: AX = n1              )
	(      BX = n2              )
	( out: AX:= n1+n2           )
	( chg: AX                   )
	( ************************* )
	[ $01 $D8 ]    ( add  ax,bx )
	;


		  MACRO - 
	( ***  reduce AX by BX  *** )
	( ************************* )
	( arg: AX = n1              )
	(      BX = n2              )
	( out: AX:= n1-n2           )
	( chg: AX                   )
	( ************************* )
	[ $29 $D8 ]    ( sub  ax,bx )
	;


		 MACRO 2* 
	( ** multiplication by 2 ** )
	( ************************* )
	( arg: AX = value n         )
	( out: AX:= n*2             )
	( chg: AX                   )
	( ************************* )
	[ $01 $C0 ]    ( add  ax,ax )
	;


		 MACRO 10* 
	( *  multiplication by 10 * )
	( ************************* )
	( arg: AX = n               )
	( out: AX:= n*10            )
	( chg: AX                   )
	( ************************* )
	[ $D1 $E0 ]    ( shl  ax,1  )
	[ $89 $C2 ]    ( mov  dx,ax )
	[ $D1 $E0 ]    ( shl  ax,1  )
	[ $D1 $E0 ]    ( shl  ax,1  )
	[ $01 $D0 ]    ( add  ax,dx )
	;

		MACRO 16* 
	( *  multiplication by 16 * )
	( ************************* )
	( arg: AX = n               )
	( out: AX:= n*16            )
	( chg: AX                   )
	( ************************* )
	[ $D1 $E0 ]     ( shl  ax,1 )
	[ $D1 $E0 ]     ( shl  ax,1 )
	[ $D1 $E0 ]     ( shl  ax,1 )
	[ $D1 $E0 ]     ( shl  ax,1 )
	;

		  MACRO / 
	( divide AX by BX with rest )
	( ***  signed division  *** )
	( ************************* )
	( arg: AX = n               )
	(      BX = n1              )
	( out: AX:= n/n1            )
	(      BX:= rest            )
	( chg: AX                   )
	( ************************* )
	[ $99 ]        ( cwd        )
	[ $F7 $FB ]    ( idiv bx    )
	[ $89 $D3 ]    ( mov  bx,dx )
	;

		  MACRO u/ 
	( divide AX by BX with rest )
	( ***  unsigned division ** )
	( ************************* )
	( arg: AX = n               )
	(      BX = n1              )
	( out: AX:= n/n1            )
	(      BX:= rest            )
	( chg: AX                   )
	( ************************* )
	[ $99 ]        ( cwd        )
	[ $F7 $F3 ]    ( div bx    )
	[ $89 $D3 ]    ( mov  bx,dx )
	;


		 MACRO u/2 
	( * unsigned division by 2  )
	( ************************* )
	( arg: AX = i               )
	( out: AX:= i/2             )
	( chg: AX                   )
	( ************************* )
	[ $D1 $E8 ]     ( shr  ax,1 )
	;


		 MACRO u/16 
	(  unsigned division by 16  )
	( ************************* )
	( arg: AX = i               )
	( out: AX:= i/16            )
	( chg: AX                   )
	( ************************* )
	[ $D1 $E8 ]     ( shr  ax,1 )
	[ $D1 $E8 ]     ( shr  ax,1 )
	[ $D1 $E8 ]     ( shr  ax,1 )
	[ $D1 $E8 ]     ( shr  ax,1 )
	;


	( ** mixed arithmetic ** )
	
		 MACRO * 
	( **  multiply AX by BX  ** )
	( * signed multiplication * )
	( ************************* )
	( arg: AX = n1              )
	(      BX = n2              )
	( out: BX:AX:= n1*n2        )
	( chg: AX,BX                )
	( ************************* )
	[ $F7 $EB ]    ( imul bx    )
	[ $89 $D3 ]    ( mov  bx,dx )
	;

		 MACRO u* 
	( **  multiply AX by BX  ** )
	( * unsigned multiplicat. * )
	( ************************* )
	( arg: AX = n1              )
	(      BX = n2              )
	( out: BX:AX:= n1*n2        )
	( chg: AX,BX                )
	( ************************* )
	[ $F7 $E3 ]    ( mul bx     )
	[ $89 $D3 ]    ( mov  bx,dx )
	;

		 MACRO a*b/d 
	(   signed:  AX * BX / DI   )
	( ************************* )
	( arg: AX = n1              )
	(      BX = n2              )
	(      DI = n3              )
	( out: AX:= n1*n2/n3        )
	(      DI:= rest            )
	( chg: AX,BX                )
	( ************************* )      
	[ $F7 $EB ]    ( imul bx    )
	[ $F7 $FF ]    ( idiv di    )
	[ $89 $D7 ]    ( mov  di,dx )
	;


		 MACRO n>d 
	(  convert word to double   )
	( ************************* )
	( arg: AX = n               )
	( out: BX:AX:= d            )
	( chg: BX                   )
	( ************************* ) 
	[ $99 ]     ( cwd  )
	[ $89 $D3 ] ( mov bx,dx )
	;


	( ** double arithmetic ** )

		MACRO d/neg 
	( * change sign of double * )
	( ************************* )
	( arg: BX:AX =  d           )
	( out: BX:AX:= -d           )
	( chg: AX,BX                )
	( ************************* ) 
	[ $F7 $D0 ]     ( not  ax   )
	[ $F7 $D3 ]     ( not  bx   )
	[ $05 1 0 ]     ( add  ax,1 )
	[ $83 $D3 0 ]   ( adc  bx,0 )
	;

		MACRO d/+ 
	( **** summ of doubles **** )
	( ************************* )
	( arg: BX:AX = d1           )
	(      ES:DI = d2           )
	( out: BX:AX:= d1+d2        )
	( chg: AX,BX                )
	( ************************* ) 
	[ $8C $C2 ]    ( mov  dx,es )
	[ $01 $F8 ]    ( add  ax,di ) 
	[ $11 $D3 ]    ( adc  bx,dx ) 
	;

		MACRO d/-
	( **** diff of doubles **** )
	( ************************* )
	( arg: BX:AX = d1           )
	(      ES:DI = d2           )
	( out: BX:AX:= d1-d2        )
	( chg: AX,BX                )
	( ************************* ) 
	[ $8C $C2 ]    ( mov  dx,es )
	[ $29 $F8 ]    ( sub  ax,di ) 
	[ $19 $D3 ]    ( sbb  bx,dx ) 
	;

		 MACRO d/2* 
	( **  shift double left  ** )
	( ************************* )
	( arg: BX:AX = d            )
	( out: BX:AX:= d*2          )
	( chg: AX,BX                )
	( ************************* ) 
	[ $D1 $E0 ]     ( shl  ax,1 )
	[ $D1 $D3 ]     ( rcl  bx,1 )
	;



		 MACRO d/2 
	( * unsigned double division by 2  )
	( ************************* )
	( arg: BX:AX = i            )
	( out: BX:AX:= i/2          )
	( chg: BX AX                )
	( ************************* )
        
	[ $D1 $EB ]     ( shr  bx,1 )
	[ $D1 $D8 ]     ( rcr  ax,1 )  
	;


	( *** functions *** )

		MACRO and 
	( ****  AND AX with BX **** )
	( ************************* )
	( arg: AX = n               )
	(      BX = n1              )
	( out: AX:= n and n1        )
	( chg: AX                   )
	( ************************* ) 
	[ $21 $D8 ]    ( and  ax,bx )
	;

		  MACRO or 
	( ****  OR AX with BX  **** )
	( ************************* )
	( arg: AX = n               )
	(      BX = n1              )
	( out: AX:= n or n1         )
	( chg: AX                   )
	( ************************* ) 
	[ $09 $D8 ]    ( or   ax,bx )
	;

		 MACRO xor 
	( ****  XOR AX with BX **** )
	( ************************* )
	( arg: AX = n               )
	(      BX = n1              )
	( out: AX:= n xor n1        )
	( chg: AX                   )
	( ************************* ) 
	[ $31 $D8 ]    ( xor  ax,bx )
	;


		MACRO neg 
	( **  change sign of AX  ** )
	( ************************* )
	( arg: AX =  n              )
	( out: AX:= -n              )
	( chg: AX                   )
	( ************************* ) 
	[ $F7 $D8 ]       ( neg  ax )
	;


		 MACRO not 
	( ****  complement AX  **** )
	( ************************* )
	( arg: AX = n               )
	( out: AX:= n'              )
	( chg: AX                   )
	( ************************* ) 
	[ $F7 $D0 ]       ( not  ax )
	;

		 MACRO sp>a 
	( *****  load SP to AX  ***** )
	( *************************** )
	( arg: SP = ret_adr           )
	( out: AX:= SP                )
	( chg: AX                     )
	( *************************** )
	[ $89 $E0 ]       ( mov ax,sp )
	;

		MACRO a>sp 
	( ****  load SP from AX  **** )
	( *************************** )
	( arg: AX = ret_adr           )
	( out: SP:= AX                )
	( chg: SP                     )
	( *************************** )
	[ $FA ]           ( cli       )
	[ $89 $C4 ]       ( mov sp,ax )
	[ $FB ]           ( sti       )
	;

	       MACRO abs 
	( **** AX = abs(AX) **** )
	( ********************** )
	( arg: AX = value n      )
	( out: AX = abs(n)       )
	( chg: AX                )
	( ********************** )
	[ $3D 0 0 ]  ( cmp ax,#0 )
	[ $7d 2   ]  ( jge +2    )
	[ $F7 $D8 ]  ( minus ax  )
	;

	       MACRO shr
	( *** shift AX right *** )
	( ********************** )
	( arg: AX = value n      )
	(      BX = 0<=i<=15     )
	( out: AX = shr ax,i     )
	( chg: AX                )
	( ********************** )
	[ $89 $CA ]  ( mov dx,cx )
	[ $89 $D9 ]  ( mov cx,bx )
	[ $D3 $E8 ]  ( shr ax,cl )
	[ $89 $D1 ]  ( mov cx,dx )
	;

		MACRO shl 
	( *** shift AX left  *** )
	( ********************** )
	( arg: AX = value n      )
	(      BX = 0<=i<=15     )
	( out: AX = shl ax,i     )
	( chg: AX                )
	( ********************** )
	[ $89 $CA ]  ( mov dx,cx )
	[ $89 $D9 ]  ( mov cx,bx )
	[ $D3 $E0 ]  ( shl ax,cl )
	[ $89 $D1 ]  ( mov cx,dx )
	;


	     MACRO combine 
	( ** combine AX=BLAL ** )
	( ********************* )
	( arg: AL = value c1    )
	(      BL = value c2    )
	( out: AX:= c2*256+c1   )
	( chg: AH               )
	( ********************* )
	[ $88 $DC ] ( mov ah,bl )  
	; 

	      MACRO split 
	( ***   split AX    *** )
	( ********************* )
	( arg: AX = value n     )
	( out: AH:= 0           )
	(      BH:=0 BL:=AH     )
	( chg: AH,BX            )
	( ********************* )
	[ $88 $E3 ] ( mov bl,ah )
	[ $30 $FF ] ( xor bh,bh )
	[ $88 $FC ] ( mov ah,bh )
	;
  

	       MACRO getbit 
	( * get bitvalue in AX * )
	( ********************** )
	( arg: AX = value n      )
	(      BX = 0<=pos<=15   )
	( out: AX:= 0|1          )
	( chg: AX,BX             )
	( ********************** )
	[ $87 $D9 ] ( xchg cx,bx )
	[ $D3 $E8 ] ( shr  ax,cl )
	[ $87 $D9 ] ( xchg cx,bx )
	[ $25 1 0 ] ( and  ax,1  ) 
	;

		 MACRO log2 
	( ***    AX:=log2(AX)   *** )
	( ***    discard rest   *** )
	( ** EXAMPLE: 1024 -> 10 ** )
	( ************************* )
	( arg: AX = value n         )
	( out: AX:= log2(n)         )
	( chg: AX                   )
	( ************************* )
	[ $BA $FF $FF ] ( mov dx,-1 )
	BEGIN
	[ $42 ]         ( inc dx    )
	[ $D1 $E8 ]     ( shr ax,1  )
	UNTIL- Z
	[ $89 $D0 ]     ( mov ax,dx )
	;




	( *** memory-operators  *** )

	( *** SEGMENT override bytes *** )

	MACRO CS: [ $2E ] ;
	MACRO DS: [ $3E ] ;
	MACRO SS: [ $36 ] ;
	MACRO ES: [ $26 ] ;


		   MACRO m>a 
	( **  word from mem to AX  ** )
	(  SEGMENT override possible  )
	( *************************** )
	( arg: SI = adr               )
	( out: AL:= n from XS:[SI]    )
	(           default XS: DS    )
	( chg: AX                     )
	( *************************** )
	[ $8B $04 ]    ( mov  ax,[si] )
	;

		   MACRO m>al 
	( **  byte from mem to AL  ** )
	(  SEGMENT override possible  )
	( *************************** )
	( arg: SI = adr               )
	( out: AL:= c from XS:[SI]    )
	(           default XS: DS    )
	( chg: AL,AH                  )
	( *************************** ) 
	[ $8A $04 ]    ( mov  al,[si] )
	[ $B4 $00 ]    ( mov  ah,#0   )
	;

		  MACRO m>ba 
	(  double from mem to BX:AX   )
	( *************************** )
	( arg: SI = adr               )
	( out: BX:AX:= d from DS:[SI] )
	( chg: AX,BX                  )
	( *************************** ) 
	[ $8B $5C 2 ] ( mov bx,[si+2] )
	[ $8B $04   ] ( mov ax,[si]   )
	;

		 MACRO im>a 
	( word from indexed mem to AX )
	( *************************** )
	( arg: SI = adr               )
	(      BX = index i           )
	( out: AX:= n from DS:[SI+BX] )
	( chg: AX                     )
	( *************************** ) 
	[ $D1 $E3 ]  ( shl bx,1       )
	[ $8B $00 ]  ( mov ax,[si+bx] )
	;

		 MACRO im>al 
	( byte from indexed mem to AL )
	(  SEGMENT override possible  )
	( *************************** )
	( arg: SI = base_adr          )
	(      BX = index i           )
	( out: AL:= c from XS:[SI+BX] )
	(           default XS: DS    )
	( chg: AL,AH                  )
	( *************************** ) 
	[ $8A $00 ]  ( mov al,[si+bx] )
	[ $B4 $00 ]  ( mov ah,00      )
	;
 
 
		 MACRO m>adr 
	( copy word from memory to SI )
	(  SEGMENT override possible  )
	( *************************** )
	( arg: SI = adr               )
	( out: SI:= value from XS:SI  )
	(           default XS: DS    )
	( chg: SI                     )
	( *************************** )
	[ $8B $34 ]    ( mov  si,[si] )
	;


		 MACRO m>b 
	( copy word from memory to BX )
	(  SEGMENT override possible  )
	( *************************** )
	( arg: SI = adr               )
	( out: BX:= value from XS:SI  )
	(           default XS: DS    )
	( chg: BX                     )
	( *************************** )
	[ $8B $1C ]     ( mov bx,[si] )
	;

		   MACRO m>bl 
	( **  byte from mem to BL  ** )
	(  SEGMENT override possible  )
	( *************************** )
	( arg: SI = adr               )
	( out: BL:= c from XS:[SI]    )
	(           default XS: DS    )
	( chg: BL,BH                  )
	( *************************** ) 
	[ $8A $1C ]     ( mov bl,[si] )
	[ $30 $FF ]     ( xor bh,bh   )
	;

		   MACRO b/m>d 
	( **  word from mem to DI-L** )
	( *************************** )
	( arg: SI = adr               )
	( out: DI:= n from DS:[SI]    )
	( chg: DI                     )
	( *************************** ) 
	[ $8A $14 ]   ( mov dl,[si]   )
	[ $B6 $00 ]   ( mov dh,0      )
	[ $89 $D7 ]   ( mov di,dx     )
	;

		   MACRO m>d 
	( **  word from mem to AL  ** )
	(  SEGMENT override possible  )
	( *************************** )
	( arg: SI = adr               )
	( out: DI:= n from XS:[SI]    )
	(           default XS: DS    )
	( chg: DI                     )
	( *************************** ) 
	[ $8B $3C ]   ( mov di,[si]   )
	;

		   MACRO m>ed 
	( * double from mem to ES:DI* )
	(  load long_mem_adr_register )
	(  SEGMENT override possible  )
	( *************************** )
	( arg: SI = adr               )
	( out: ES:DI:= d from XS:[SI] )
	(              default XS: DS )
	( chg: ES,DI                  )
	( *************************** ) 
	[ $C4 $3C ]     ( les di,[si] )
	;

		   MACRO m>e 
	( **  word from mem to ES  ** )
	(  SEGMENT override possible  )
	( *************************** )
	( arg: SI = adr               )
	( out: ES:= n from XS:[SI]    )
	(           default XS: DS    )
	( chg: ES                     )
	( *************************** ) 
	[ $8E $04 ]     ( mov es,[si] )
	;

		 MACRO a>m 
	(  store word from AX to mem  )
	(  SEGMENT override possible  )
	( *************************** )
	( arg: SI = mem_adr           )
	( out: -                      )
	(      AX to XS:[SI]          )
	(      default XS: DS         )
	( chg: -                      )
	( *************************** ) 
	[ $89 $04 ]    ( mov  [si],ax )
	;

		 MACRO al>m 
	(  store byte from AL to mem  )
	(  SEGMENT override possible  )
	( *************************** )
	( arg: SI = mem_adr           )
	( out: -                      )
	(      AL to XS:[SI]          )
	(      default XS: DS         )
	( chg: -                      )
	( *************************** )
	[ $88 $04 ]    ( mov  [si],al )
	;

		 MACRO a>im 
	( **  store AX with index   ** )
	( ** at adr = base_adr+2*i  ** )
	( **************************** )
	( arg: AX = value n to store   )
	(      BX = index              )
	(      SI = base_adr           )
	( out: -                       )
	( chg: BX                      )
	( **************************** )
	[ $D1 $E3 ]  ( shl bx,1        )
	[ $89 $00 ]  ( mov [si+bx],ax  )
	;

		MACRO al>im 
	( **  store AL with index   ** )
	( **  at adr = base_adr+i   ** )
	( **************************** )
	( arg: AX = value n to store   )
	(      BX = index              )
	(      SI = base_adr           )
	( out: -                       )
	( chg: BX                      )
	( **************************** )
	[ $88 $00 ]  ( mov [si+bx],al  )
	;

		 MACRO ba>m 
	( *** store BX:AX in mem **** )
	( *************************** )
	( arg: BX:AX = double         )
	(      SI = mem_adr           )
	( out: -                      )
	( chg: -                      )
	( *************************** )
	[ $89 $04 ]   ( mov [si],ax   )
	[ $89 $5C 2 ] ( mov [si+2],bx )
	;

		MACRO b>m 
	( ***  store BX in mem   **** )
	( *************************** )
	( arg: BX = value n           )
	(      SI = mem_adr           )
	( out: -                      )
	( chg: -                      )
	( *************************** )
	[ $89 $1C ]     ( mov [si],bx )
	;

		MACRO bl>m 
	( ***   store BL in mem  **** )
	( *************************** )
	( arg: BL = value c           )
	(      SI = mem_adr           )
	( out: -                      )
	( chg: -                      )
	( *************************** )
	[ $88 $1C ]     ( mov [si],bl )
	;

		 MACRO d>m 
	( ***  store DI in mem   **** )
	( *************************** )
	( arg: DI = value n           )
	(      SI = mem_adr           )
	( out: -                      )
	( chg: -                      )
	( *************************** )
	[ $89 $3C ]     ( mov [si],di )
	;


		MACRO ed>m 
	( *** store ES:DI in mem **** )
	( *************************** )
	( arg: ES:DI = double         )
	(      SI = mem_adr           )
	( out: -                      )
	( chg: -                      )
	( *************************** )
	[ $89 $3C ]    ( mov [si],di   )
	[ $8C $44 2 ]  ( mov [si+2],es )
	;
 
		 MACRO e>m 
	( ***  store ES in mem   **** )
	( *************************** )
	( arg: ES = value n           )
	(      SI = mem_adr           )
	( out: -                      )
	( chg: -                      )
	( *************************** )
	[ $8C $04 ]     ( mov [si],es )
	;


		MACRO mem+n 
	( **  add n to word in mem ** )
	( *************************** )
	( arg: AX = value n           )
	(      SI = mem_adr           )
	( out: -                      )
	(      (mem):=(mem+n)         )
	( chg: -                      )
	( *************************** )
	[ $01 $04 ]    ( add  [si],ax )
	;

		 MACRO b/mem+c 
	( **  add c to byte in mem ** )
	( *************************** )
	( arg: AX = value c           )
	(      SI = mem_adr           )
	( out: -                      )
	(      (mem):=(mem+c)         )
	( chg: -                      )
	( *************************** )
	[ $00 $04 ]     ( add [si],al ) 
	;

		  MACRO mem+ 
	( **  inc word in mem by 1 ** )
	( *************************** )
	( arg: SI = mem_adr           )
	( out: -                      )
	(      (mem):=(mem+1)         )
	( chg: -                      )
	( *************************** )
	[ $FF $04 ]      ( inc  [si]  )
	;

		MACRO b/mem+ 
	( **  inc byte in mem by 1 ** )
	( *************************** )
	( arg: SI = mem_adr           )
	( out: -                      )
	(      (mem):=(mem+1)         )
	( chg: -                      )
	( *************************** )
	[ $FE $04 ]    ( inc  b/[si]  )
	;

		 MACRO mem- 
	( **  dec word in mem by 1 ** )
	( *************************** )
	( arg: SI = mem_adr           )
	( out: -                      )
	(      (mem):=(mem-1)         )
	( chg: -                      )
	( *************************** )
	[ $FF $0C ]      ( dec  [si]  )
	;

		MACRO b/mem- 
	( **  dec byte in mem by 1 ** )
	( *************************** )
	( arg: SI = mem_adr           )
	( out: -                      )
	(      (mem):=(mem-1)         )
	( chg: -                      )
	( *************************** )
	[ $FE $0C ]    ( dec  b/[si]  )
	;


		MACRO b/copy 
	( copy byte from mem to mem )
	( * valid only in DATASEG * )
	( * Syntax: a to b b/copy * )
	( ************************* )
	( arg: SI = source_adr      )
	(      DI = destin_adr      )
	( out: -                    )
	( chg: ES,SI,DI             )
	( ************************* )
	[ $1e ]           ( push ds )
	[ $07 ]           ( pop  es )
	[ $A4 ]           ( movsb   )
	;

		MACRO copy 
	( copy word from mem to mem )
	( ** Syntax: a to b copy ** )
	( ************************* )
	( arg: SI = sourceadr       )
	(      DI = dest_adr        )
	( out: -                    )
	( chg: ES,SI,DI             )
	( ************************* )
	[ $1e ]           ( push ds )
	[ $07 ]           ( pop  es )
	[ $A5 ]           ( movsw   )
	;


		MACRO d/copy 
	( copy double from mem to mem )
	( ** Syntax: a to b d/copy ** )
	( *************************** )
	( arg: SI = sourceadr         )
	(      DI = dest_adr          )
	( out: -                      )
	( chg: ES,SI,DI               )
	( *************************** )
	[ $1e ]             ( push ds )
	[ $07 ]             ( pop  es )
	[ $A5 ]             ( movsw   )
	[ $A5 ]             ( movsw   )
	;

		 MACRO m-on 
	( ** set word in mem to -1 ** )
	( *************************** )
	( arg: SI = mem_adr           )
	( out: -                      )
	(      (mem):=(-1)            )
	( chg: -                      )
	( *************************** )
	[ $C6 $04 $FF ] ( mov [si],-1 )
	;

		  MACRO m-off 
	( **  set word in mem to 0 ** )
	( *************************** )
	( arg: SI = mem_adr           )
	( out: -                      )
	(      (mem):=(0)             )
	( chg: -                      )
	( *************************** )
	[ $C6 $04 0 ]    ( mov [si],0 )
	;



	( ** operators for local variables ** )
	
	MACRO local>a  [ $8B $02 ] ; ( mov ax,[BP+SI] )
	MACRO local>al [ $8A $02 ] ; ( mov al,[BP+SI] )
	MACRO local>b  [ $8B $1A ] ; ( mov bx,[BP+SI] )
	MACRO local>bl [ $8A $1A ] ; ( mov bl,[BP+SI] )
	MACRO local>d  [ $8B $3A ] ; ( mov di,[BP+SI] )
	MACRO local>adr [ $8B $32 ] ; ( mov si,[BP+SI] )        
	MACRO local>e  [ $8E $02 ] ; ( mov es,[BP+SI] )
	
	MACRO a>local  [ $89 $02 ] ; ( mov [BP+SI],ax )
	MACRO al>local [ $88 $02 ] ; ( mov [BP+SI],al )
	MACRO b>local  [ $89 $1A ] ; ( mov [BP+SI],bx )
	MACRO bl>local [ $88 $1A ] ; ( mov [BP+SI],bl )
	MACRO d>local  [ $89 $3A ] ; ( mov [BP+SI],di )
	MACRO e>local  [ $8C $02 ] ; ( mov [BP+SI],es )

	MACRO ba>local [ $89 $02 	 ( mov [BP+SI],ax )
			 $89 $5A $02 ] ; ( mov [BP+SI+02],bx )
	MACRO ed>local [ $89 $3A 	 ( mov [BP+SI],di )
			 $8C $42 $02 ] ; ( mov [BP+SI+02],es )
	MACRO local>ba [ $8B $02 	 ( mov ax,[BP+SI] )
			 $8B $5A $02 ] ; ( mov bx,[BP+SI+02] )
	MACRO local>ed [ $8B $3A 	 ( mov di,[BP+SI] )
			 $8E $42 $02 ] ; ( mov es,[BP+SI+02] )
	
	MACRO local+   [ $FF $02 ] ; ( inc W/ [BP+SI] )
	MACRO local-   [ $FF $0A ] ; ( dec W/ [BP+SI] )
	MACRO b/local+ [ $FE $02 ] ; ( inc B/ [BP+SI] )
	MACRO b/local- [ $FE $0A ] ; ( dec B/ [BP+SI] )


	( ** operators for long memory ** )
	( Before calling the following operators, the ....      )
	( long_mem_adr_register ES:DI must be loaded.           )
	( For this purpose, use the SYNTAX: 'video-ptr m>ed '.  )               
	( Note that following operators are especially useful   )
	( in serial memory access, since the adress in DI is    )
	( adjusted after each call. If in a loop 'ES:DI' is not )
	( changed, the 'm>ed' macro must be applied only once.  )



		  MACRO al>lm 
	( * byte from AL to longmem * )
	( *************************** )
	( arg: ES:DI = longmem_adr    )
	( out: DI:= DI+1              )
	( chg: DI                     )
	( *************************** ) 
	[ $AA ]               ( STOSB )
	;        

		  MACRO a>lm 
	( * word from AX to longmem * )
	( *************************** )
	( arg: ES:DI = longmem_adr    )
	( out: DI:= DI+2              )
	( chg: DI                     )
	( *************************** ) 
	[ $AB ]               ( STOSW )
	;        

		  MACRO ba>lm 
	( * byte from AL to longmem * )
	( *************************** )
	( arg: ES:DI = longmem_adr    )
	( out: DI:= DI+4              )
	( chg: DI                     )
	( *************************** ) 
	[ $AA ]               ( STOSB )
	b>a
	[ $AA ]               ( STOSB )
	;        

		  MACRO lm>al 
	( * byte from longmem to AL * )
	( *************************** )
	( arg: ES:DI = longmem_adr    )
	( out: DI:= DI+1              )
	( chg: DI                     )
	( *************************** )
	[ $87 $F7 ]      ( xchg si,di ) 
	ES: [ $ac ]           ( LODSB )
	[ $87 $F7 ]      ( xchg si,di )
	;

		  MACRO lm>a 
	( * word from longmem to AX * )
	( *************************** )
	( arg: ES:DI = longmem_adr    )
	( out: DI:= DI+2              )
	( chg: DI                     )
	( *************************** )
	[ $87 $F7 ]      ( xchg si,di ) 
	ES: [ $ad ]           ( LODSW )
	[ $87 $F7 ]      ( xchg si,di )
	;

		  MACRO lm>ba 
	( * byte from longmem to AL * )
	( *************************** )
	( arg: ES:DI = longmem_adr    )
	( out: DI:= DI+1              )
	( chg: DI                     )
	( *************************** )
	[ $87 $F7 ]      ( xchg si,di ) 
	ES: [ $ad ]           ( LODSW )
	a>b
	ES: [ $ad ]           ( LODSW )
	[ $87 $F7 ]      ( xchg si,di )
	;


	( *** port input-output *** )

	       MACRO a>p 
	( ***  AX to port   *** )
	( ********************* )
	( arg: AX = value n     )
	(      SI = port_adr    )
	( out: -                )
	( chg: -                )
	( ********************* )
	[ $89 $F2 ] ( mov dx,si )
	[ $EF ]     ( out dx,ax )
	;

	       MACRO p>a 
	( ***  port to AX   *** )
	( ********************* )
	( arg: SI = port_adr    )
	( out: AX:= value n     )
	( chg: AX               )
	( ********************* )
	[ $89 $F2 ] ( mov dx,si )
	[ $ED ]     ( in  ax,dx )
	;

	       MACRO al>p 
	( ***  AL to port   *** )
	( ********************* )
	( arg: AL = value c     )
	(      SI = port_adr    )
	( out: -                )
	( chg: -                )
	( ********************* )
	[ $89 $D8 ] ( mov ax,bx )
	[ $89 $F2 ] ( mov dx,si )
	[ $EE ]     ( out dx,al )
	;

	       MACRO p>al 
	( ***  port to AL   *** )
	( ********************* )
	( arg: SI = port_adr    )
	( out: AL:= value c     )
	( chg: AL               )
	( ********************* )
	[ $89 $F2 ] ( mov dx,si )
	[ $EC ]     ( in al,dx  )
	[ $B4 $00 ] ( mov ah,0  )
	;



	( *** Support of loops *** )


		   MACRO i 
	( ****  loopindex to AX  **** )
	( *************************** )
	( arg: -                      )
	( out: AX:= CX=loopindex      )
	( chg: AX                     )
	( *************************** )
	[ $89 $C8 ]       ( mov ax,cx )
	;

		MACRO i>adr 
	( ****  loopindex to SI  **** )
	( *************************** )
	( arg: -                      )
	( out: SI:= CX=loopindex      )
	( chg: SI                     )
	( *************************** )
	[ $89 $CE ]       ( mov si,cx )
	;

		MACRO i>b 
	( ****  loopindex to BX  **** )
	( *************************** )
	( arg: -                      )
	( out: BX:= CX=loopindex      )
	( chg: BX                     )
	( *************************** )
	[ $89 $CB ]       ( mov bx,cx )
	;

		   MACRO j 
	( ** outer loopindex to AX ** )
	( *************************** )
	( arg: -                      )
	( out: AX:= loopindex         )
	( chg: AX                     )
	( *************************** )
	[ $58 $50 ]  ( pop ax push ax )
	;

		 MACRO j>adr 
	( ** outer loopindex to SI ** )
	( *************************** )
	( arg: -                      )
	( out: SI:= loopindex         )
	( chg: SI                     )
	( *************************** )
	[ $5B $53 ]  ( pop si push si )
	;

		 MACRO leave 
	( * continue to loop and leave * )
	( ****************************** )
	( arg: -                         )
	( out: -                         )
	( chg: -                         )
	( ****************************** )      
	[ $89 $0E *$100 ] ( mov [100],cx )
	;

		 MACRO exit 
	( exit current colon or proc )
	( ************************** )
	( arg: -                     )
	( out: -                     )
	( chg: -                     )
	( ************************** )
	[ $C3 ]                ( ret )
	;



( *** Flagoperators *** )

	    MACRO .T. 
	( ** Flag true ** )
	( *************** )
	( arg: -          )
	( out: CF:=1      )
	( chg: CF         )
	( *************** )
	[ $F9 ]     ( stc )
	;

	    MACRO .F. 
	( ** Flag false ** )
	( **************** )
	( arg: -           )
	( out: CF:=0       )
	( chg: CF          )
	( **************** )
	[ $F8 ]      ( clc )
	;

	    MACRO .not. 
	( Flag complement )
	( *************** )
	( arg: CF         )
	( out: CF:=CF-    )
	( chg: CF         )
	( *************** )
	[ $F5 ]     ( cmc )
	;

	    MACRO flag> 
	( flag to con_stack )
	( ***************** )
	( arg: CF           )
	( out: -            )
	( chg: -            )
	( ***************** )
	[ $D1 $16 $16 0 ]  ( rcl [16],1 )
	;

	      MACRO .odd. 
	( *  CF:=1 if AX odd * )
	( ******************** )
	( arg: AX = value n    )
	( out: CF:=1 if n=odd  )
	(      CF:=0 if n=even )
	( chg: CF              )
	( ******************** )
	[ $D1 $D8 ] ( rcr ax,1 )
	[ $D1 $D0 ] ( rcl ax,1 )
	;

	MACRO .even. 
	( * CF:=1 if AX even * )
	( ******************** )
	( arg: AX = value n    )
	( out: CF:=1 if n=even )
	(      CF:=0 if n=odd  )
	( chg: CF              )
	( ******************** )
	[ $D1 $D8 ] ( rcr ax,1 )
	[ $D1 $D0 ] ( rcl ax,1 )
	[ $F5 ]     ( cmc      )
	; 

	       MACRO .0=. 
	( ** CF:=1 if AX zero ** )
	( ********************** )
	( arg: AX = value n      )
	( out: CF:=1 if n=zero   )
	( chg: CF                )
	( ********************** )
	[ $3D 0 0 ] ( test ax,ax )
	IF- Z
	  [ $F5 ]   ( cmc        )
	ENDIF
	;

	MACRO .FALSE=. .0=. ;

	       MACRO .1=.
	( ********************* )
	( arg: AX= value n      )
	( out: CF:=1 if n=1     )
	(      CF:=0 if n<>1    )
	( chg: CF               )
	( ********************* )
	[ $3D 1 0 ] ( cmp  ax,1 )
	[ $F8 ]     ( clc       )
	IF- Z
	    [ $F5 ] ( cmc       )
	ENDIF
	;

	MACRO .TRUE=. .1=. ;
	
	       MACRO .-1=. 
	( *  CF:=1 if AX =-1 * )
	( ******************** )
	( arg: AX = value n    )
	( out: CF:=1 if n=-1   )
	( chg: CF              )
	( ******************** )
	[ $3D $FF $FF ] ( cmp ax,-1  )
	[ $F8 ]         ( clc        )
	[ $75 1 ]       ( jnz  +1    )
	[ $F5 ]         ( cmc        )
	;


	     MACRO .neg. 
	( **  CF:=1 if AX neg ** )
	( ********************** )
	( arg: AX = value n      )
	( out: CF:=1 if n=neg    )
	( chg: CF                )
	( ********************** )
	[ $3D 0 0 ] ( cmp  ax,#0 )
	[ $F8 ]     ( clc        )
	[ $7D 1 ]   ( jge  +1    )
	[ $F5 ]     ( cmc        )
	;


	      MACRO .0>. 
	( ** CF:=1 if AX odd ** )
	( ********************* )
	( arg: AX = value n     )
	( out: CF:=1 if n>0     )
	( chg: CF               )
	( ********************* )
	[ $3D 0 0 ] ( cmp  ax,0 )
	[ $F8 ]     ( clc       )
	[ $7E 1 ]   ( jle  +1   )
	[ $F5 ]     ( cmc       )
	;

  
	      MACRO .0<>. 
	(  CF:=1 if AX not zero  )
	( ********************** )
	( arg: AX = value n      )
	( out: CF:=1 if n<>0     )
	( chg: CF                )
	( ********************** )
	.0=. .not. ( cmc )
	;

		MACRO .=. 
	( **  CF:=1 if AX=BX  ** )
	( ********************** )
	( arg: AX = value n1     )
	(      BX = value n2     )
	( out: CF:=1 if n1=n2    )
	( chg: CF                )
	( ********************** )
	[ $39 $D8 ] ( cmp  ax,bx )
	[ $F8 ]     ( clc        )
	[ $75 1 ]   ( jnz  +1    )
	[ $F5 ]     ( cmc        )
	;

		MACRO .>.
	( *** CF:=1 if AX>BX *** )
	( *** signed compare *** )
	( ********************** )
	( arg: AX = value n1     )
	(      BX = value n2     )
	( out: CF:=1 if n1>n2    )
	( chg: CF                )
	( ********************** )
	[ $39 $C3 ]  ( cmp bx,ax )
	[ $F8 ]      ( clc       )
	[ $7D $01 ]  ( jge +1    )
	[ $F5 ]      ( cmc       )
	;


		MACRO .<. 
	( *** CF:=1 if AX<BX *** )
	( *** signed compare *** )
	( ********************** )
	( arg: AX = value n1     )
	(      BX = value n2     )
	( out: CF:=1 if n1<n2    )
	( chg: CF                )
	( ********************** )
	[ $39 $C3 ]  ( cmp bx,ax )
	[ $F8 ]      ( clc       )
	[ $7E $01 ]  ( jle +1    )
	[ $F5 ]      ( cmc       ) 
	;

		MACRO .<>. 
	( *** CF:=1 if AX<>BX ** )
	( ********************** )
	( arg: AX = value n1     )
	(      BX = value n2     )
	( out: CF:=1 if n1<>n2   )
	( chg: CF                )
	( ********************** )
	.=. .not.
	;


		MACRO .u>. 
	( *** CF:=1 if AX>BX *** )
	( ** unsigned compare ** )
	( ********************** )
	( arg: AX = value n1     )
	(      BX = value n2     )
	( out: CF:=1 if n1>n2    )
	( chg: CF                )
	( ********************** )
	[ $39 $C3 ] ( cmp  bx,ax )
	;

	       MACRO .u<. 
	( *** CF:=1 if AX<BX *** )
	( ** unsigned compare ** )
	( ********************** )
	( arg: AX = value n1     )
	(      BX = value n2     )
	( out: CF:=1 if n1<n2    )
	( chg: CF                )
	( ********************** )
	[ $39 $D8 ] ( cmp  ax,bx )
	;


	      MACRO .ba0=. 
	( ** CF:=1 if BX:AX=0 ** )
	( ********************** )
	( arg: BX:AX = double d  )
	( out: CF:=1 if d=0      )
	( chg: CF                )
	( ********************** )
	[ $89 $DA ]  ( mov dx,bx )
	[ $09 $C2 ]  ( or  dx,ax )
	[ $F8 ]      ( clc       )
	[ $75 $01 ]  ( jnz +1    )
	[ $F9 ]      ( stc       )
	;



	( ** interruptroutins for MS-DOS and intr ** )


		MACRO dos 
	( ** call interrupt# $21 ** )
	( arg: BL = function number )
	(      AL = subfunction#    )
	( out: AX:= function/subf   )
	(      BL:= $21             )
	( chg: AH,BL                )
	( ************************* )
	[ $88 $DC ]  ( mov ah,bl    )
	[ $B3 $21 ]  ( mov bl,#$21  )
	;


	       MACRO ds>a 
	( ***  dataseg to AX *** )
	( ********************** )
	( arg: -                 )
	( out: AX:= DSEG         )
	( chg: AX                )
	( ********************** )
	[ $8C $D8 ]  ( mov ax,ds )
	;

	       MACRO cs>a 
	( ***  codeseg to AX *** )
	( ********************** )
	( arg: -                 )
	( out: AX:= CSEG         )
	( chg: AX                )
	( ********************** )
	[ $8C $C8 ]  ( mov ax,cs )
	;


	( *** Initialize and errortreatment *** )

	      MACRO v-restor
	( ** restore video-atr ** )
	( *********************** )
	( arg: -                  )
	( out: -                  )
	( chg: AX                 )
	( *********************** ) 
	[ $B0 $1A ]  ( mov al,1A  )
	[ $B4 $00 ]  ( mov ah,00  )
	[ $CD $10 ]  ( int 10     )
	;

	      MACRO ds! 
	( * restore datasegment * )
	( *********************** )
	( arg: -                  )
	( out: DS:= defaultvalue  )
	( chg: DS                 )
	( *********************** ) 
	[ $2E $8E $1E DSEG ] ( mov ds, cs:010E )
	;

	MACRO ss! 
	( * restore stacksegment * )
	( ************************ )
	( arg: -                   )
	( out: SS:= defaultvalue   )
	( chg: SS                  )
	( ************************ ) 
	[ $FA ]              ( cli )
	[ $2E $8E $16 SSEG ] ( mov ss, cs:010E )
	[ $FB ]              ( sti )
	;

		 macro exno! 
	( ** pass c to motherprogram ** )
	( ***************************** )
	( arg: AL = c to pass           )
	( out: -                        )
	( chg: -                        )
	( ***************************** ) 
	[ $a2 EXIT-BYTE ] ( mov [18],al )
	;


		 macro break? 
	( **** is breakflag set? **** )
	( *************************** )
	( arg: -                      )
	( out: CF:=1 if set           )
	(      CF:=0 if clear         )
	(      breakflag:=0           )
	( chg: -                      )
	( *************************** ) 
	[ $D0 6 BREAK-BYTE ]    ( rol [19],1 )
	[ $C6 6 BREAK-BYTE 0 ]  ( mov [19],0 )
	;


macro ipush [ $51 ] ;
macro ipop  [ $59 ] ;
macro a>i   [ $89 $C1 ] ;
macro i>a   [ $89 $C8 ] ;
macro b>i   [ $89 $D9 ] ;
macro m>i   [ $8B $0C ] ;
macro i>m   [ $89 $0C ] ;
macro m>il  [ $8A $0C ] ;
macro il>m  [ $88 $0C ] ;       
