import( macro kern num string mem )

( *** NAXOS System-Vocabulary Version 2.1 *** )

( Name:    file.FTH      )
( Version: 2.1           )
( Datum:   9.11.92       )
( Autor:   Klaus Peper   )
( Neu      2.6.91        )


( ********************* )
( ***** FILE.FTH: ***** )
( ********************* )


        macro ($PTR) 
( * adjust DOS_stringpointer * )
( * string must terminate 0! * )
( **************************** )
( arg: SI = string_adr         )
( out: -                       )
( chg: -                       )
( **************************** )
[ $89 $36 d.dx ] ( mov d.dx,si )
[ $8C $1E d.ds ] ( mov d.ds,ds ) 
;



( *** drive- and directory-functions *** )


          : setdrive 
( **  change aktuell drive  ** )
( **************************** )
( arg: BX = drive A=1 B=2 ..   )
( out: -                       )
( chg: BX                      )
( **************************** )
[ $4B ]          ( dec BX      )
[ $89 $1E d.dx ] ( mov d.dx,bx )
$0E dos intr
;


         : getdrive 
( ****  get aktuell drive  *** )
( **************************** )
( arg: -                       )
( out: AX = drive 1=A 2=B ..   )
( chg: AX,BX                   )
( **************************** )
$19 dos intr
[ $A1 d.ax ]     ( mov ax,d.ax )
ah0 1+ 
;


          : mkdir 
( ****  make new directory *** )
( **************************** )
( arg: SI = dirname_adr        )
( out: CF:=0 if no error       )
( chg: AX,BX,CF                )
( **************************** )
($PTR) $39 dos intr ?doserr
;


          : rmdir 
( ****  delete directory  **** )
( **************************** )
( arg: SI = dirname_adr        )
( out: CF:=0 if no error       )
( chg: AX,BX,CF                )
( **************************** )
($PTR) $3A dos intr ?doserr
;


          : chdir 
( * change current directory * )
( **************************** )
( arg: SI = dirname_adr        )
( out: CF:=0 if no error       )
( chg: AX,BX,CF                )
( **************************** )
($PTR) $3B dos intr ?doserr
;


         : path? 
( copy pathname into buffer )
( ************************* )
( arg: BX = drive           )
(           0 = current     )
(           1 = A, 2 = B    )
(      ES:DI = buffer_adr   )
( out: doserr               )
( chg: ?                    )
( ************************* )
  d.dx bl>m
  d.ds e>m
  d.si d>m
  $47  dos intr ?doserr
;



: me>$$  ( => )
          ( -- )
( ** Programmnamen holen              ** )
( ** nicht dokumentierte DOS-Funktion ** )
  $52 dos intr
;

: parm>$$  ( => )
           ( -- )
( ** Parameterstring nach PAD bringen ** )
( ** dta bei $80, noch nicht verlegt  ** )
(  ADR dta >$$ pad $>DOS     )
;

: ?parm  ( => n )
         ( -- )
( ** Zahl der Kommandozeile-Parameter ** )
( parm>$$         )
(  $20 pad c!      )
(  pad bx> nextscan a>m    )
(  sx 0 begin .parse. while sx+ repeat pop )
;

proc .iparm.  ( i => ) ( f )
            ( -- str )
( ** i.Parameter holen     ** )
( ** f:= 0: nicht gefunden ** )
( ** i:= 0 ergibt Namen    ** )
(  >r
  parm>$$ 
  $20 pad c!  pad bx> nextscan a>m
  r> , 1 do .parse. .not.
  if 1 >tx leave else 0 >tx endif loop
  dx>bx tx> .0=. )
;



( *** file-functions *** )


         : create 
( ****   create new file   *** )
( ****  or empty existing  *** )
( **************************** )
( arg: SI = filename_adr       )
(      BX = 0: read/write      )
(         = 1: read only       )
( out: CF:=0 if no error       )
( chg: AX,BX                   )
( **************************** )
[ $89 $1E d.cx ] ( mov d.cx,bx ) 
($PTR)  $3C  dos  intr  ?doserr
;


         : exist? 
( ***  does file exist?  *** )
( ************************** )
( arg: SI = filename_adr     )
( out: CF:= 1 if file exists )
( chg: AX,BX                 )
( ************************** )
($PTR) , 0 
[ $A3 d.ax ]  ( mov d.ax,ax  )
$3D dos intr  ( try to open  )
IF   .F.      ( not existing )
ELSE          ( yes, close   )
 [ $A1 d.ax ] ( mov ax,d.ax  )
 [ $A3 d.bx ] ( mov d.bx,ax  )
 $3E dos intr .T.
ENDIF  
;


           : open 
( ***  open existing file  *** )
( **************************** )
( arg: SI = filename_adr       )
(      BX = mode               )
(           0: read only       )
(           1: write only      )
(           2: read/write      )
( out: AX:= handle             )
(      CF:= 1 if no error      )
( chg: AX,BX,CF                )
( **************************** )
[ $89 $1E d.ax ] ( mov d.ax,bx )
($PTR)   $3D dos intr   ?doserr
[ $A1 d.ax ]     ( mov ax,d.ax )
;

	            proc L/read? 
	( * read i bytes from file to DS:SI  * )
	(      if EOF, terminate with 0        )
	( ************************************ )
	( arg: BX = filehandle                 )
	(      AX = count i                    )
	(      ES:DI = buffer_adr              )
	( out: CF:= 0 if error -> doserr       )
	(         = 0 if End_Of_File           )
	(      CF:= 1 if no error              )
	( chg: AX,DI,CF and if error: BX       )
	( ************************************ )
	[ $51 ]      ( push cx )
	[ $1E ]      ( push ds )
	[ $06 ]      ( push es )
	[ $1F ]      ( pop ds  ) 
	[ $89 $C1 ]  ( mov  cx,ax  )   ( count )
	[ $89 $FA ]  ( mov  dx,di  )   ( Bufadr )
	[ $B4 $3F ]  ( mov  ah,#3F )   ( read )
	[ $CD $21 ]  ( int  21     )
	[ $1F ]      ( pop  ds )
	  IF- NC
	    [ $39 $C8 ]  ( cmp  ax,cx )
	    [ $59 ]      ( pop  cx )  
	    IF- E
	      [ $F9 ]    ( stc        )	    
	      [ $C3 ]    ( ret        )
	    ELSE
	      [ $89 $FB ]     ( mov bx,di )
	      [ $01 $C3 ]     ( add bx,ax )
	      [ $26 $C6 7 0 ] ( mov es:[bx],00 )
	      [ $F8 ]         ( clc        )	    
	      [ $C3 ]         ( ret        )	      
	    ENDIF
	  ENDIF
	[ $59 ]      ( pop  cx )	  
        ?doserr .F.
	;


	             proc L/write 
	( * write i bytes from DS:SI to file * )
	( arg: BX = filehandle                 )
	(      AX = count i                    )
	(      ES:DI = buffer_adr              )
	( out: CF:= 1 if no error              )
	(      CF:= 0 if error, -> doserror    )
	(      if disk is full, -> doserror    )
	( chg: AX and if error: BX             )
	( ************************************ )
	[ $1E ]         ( push ds )
	[ $51 ]         ( push cx )
	[ $06 ]         ( push es )
	[ $1F ]         ( pop ds  ) 
	[ $89 $C1 ]     ( mov  cx,ax  )   ( count )
	[ $89 $FA ]     ( mov  dx,di  )   ( Bufadr )
	[ $B4 $40 ]     ( mov  ah,#40 ) ( write )
	[ $CD $21 ]     ( int  21     )
	[ $59 ]         ( pop  cx )
	[ $1F ]         ( pop  ds )	
	  IF- NC
	    [ $39 $C8 ]   ( cmp  ax,cx  )
	    IF- E
	      .T. 
	      [ $C3 ]     ( ret         ) ( ok )
	    ELSE
	      -2 , $4000  ( Platte voll )
	    ENDIF
	  ENDIF
	  doserr .F.
	;


            : close? 
( *****    close file     **** )
( **************************** )
( arg: SI = filename_adr       )
(      BX = handle             )
( out: CF:= 1 if no error      )
( chg: AX,BX,CF                )
( **************************** )
[ $80 $FB $04 ] ( cmp bl,04 )
.T.
IF- A
  [ $89 $1E d.bx ] ( mov d.bx,bx ) 
  $3E dos intr ?doserr
ENDIF
;

           : kill 
( ***  kill existing file ** )
( ************************** )
( arg: SI = filename_adr     )
( out: CF:= 0 if no error    )
( chg: AX,BX,CF              )
( ************************** )
exist?
IF
  ($PTR) $41 dos intr ?doserr
ENDIF
;


           : rename 
( *** rename existing file *** )
( **************************** )
( arg: SI = filename_adr old   )
(      DI = filename_adr new   )
( out: CF:=0 if no error       )
( chg: SI,DI,AX,BX,CF          )
( **************************** )
adr+ d+
[ $89 $1E d.dx ] ( mov d.dx,si )
[ $89 $3E d.di ] ( mov d.di,di )
[ $8C $1E d.ds ] ( mov d.ds,ds )
[ $8C $1E d.es ] ( mov d.es,ds )
$56 dos intr ?doserr
;

            : drivespace 
( get total/remaining drive capacity  )
( *********************************** )
( arg: BX: 0= current drive 1=A 2=B.. )
( out: BX:AX = Bytes free on Volume   )	
(      ES:DI = Bytes total on Volume  )
( chg: AX,BX,DI,ES,CF                 )
( *********************************** )

[ $89 $1E d.dx ]
$36 dos intr
d.ax 
( IF- OFF .T. )
  [ $A1 d.ax ]		( mov ax,d.ax  Sec/Cluster )
  [ $8B $1E d.cx ]	( mov bx,d.cx  Byte/Sec )
  u*			( Byte / Cluster )
  apush
  [ $8B $1E d.dx ]	( mov bx,d.dx Total cluster )  
  u*
  b>e a>d
  apop
  [ $8B $1E d.bx ]	( mov bx,d.bx Free Cluster )
  u*
( ELSE .F. )
( ENDIF )
;



          : getdta 
( get adr of disk-transfer-area )
( ***************************** )
( arg: -                        )
( out: ES:DI dta_adr            )
( chg: ES,DI                    )
( ***************************** )
$2F dos intr
[ $8E $06 d.es ]  ( mov es,d.es )
[ $8B $3E d.bx ]  ( mov di,d.bx )
;


: handle-dup  ( n1 => n2 )
              ( => )
( ** zweiten Dateihandle einrichten ** )
(  d.bx a>m $45 ?dos intr d.ax @ )
;


: handle-assgn  ( n1:n2 => ?:? )
                ( => )
( ** Handle n2 an Handle n1 angleichen ** )
(  d.cx a>m d.bx dx>! $46 ?dos intr  )
;


          : get-file-atr
( *****  get file atribut ***** )
( ***************************** )
( arg: SI = filename_adr        )
( out: AX = atribut             )
(         = 0: unlimited access )
(         = 8: name of volume   )
(           else BIT:           )
(           0=1: read only      )
(           1=1: hidden file    )
(           2=1: system file    )
(           4=1: subdirectory   )
(           5=1: changed        )
(      CF:=0 if no error        )
( chg: AX,BX,CF                 )
( ***************************** )
($PTR) , 0 
[ $A3 d.ax ]      ( mov d.ax,ax )
$43 dos intr ?doserr
[ $A1 d.cx ]      ( mov ax,d.cx )
;


          : set-file-atr
( *****  set file atribut ***** )
( ***************************** )
( arg: SI = filename_adr        )
(      BX = atribut             )
(         = 0: unlimited access )
(         = 8: name of volume   )
(           else BIT:           )
(           0=1: read only      )
(           1=1: hidden file    )
(           2=1: system file    )
(           4=1: subdirectory   )
( out: CF:=0 if no error        )
( chg: AX,BX,CF                 )
( ***************************** )
($PTR) 
[ $89 $1E d.cx ]  ( mov d.cx,bx ) 
, 1 
[ $A3 d.ax ]      ( mov d.ax,ax ) 
$43 dos intr ?doserr
;


( ** directory-searchfunctios ** )
var dirbuf string 66 ; ( buffer for filenames )

            : dirfirst? 
( * find first file with atr n  )
( ***************************** )
( arg: SI = searchfilename_adr  )
(           * and ? are valid   )
(      BX = atribut n           )
(         = 0: unlimited access )
(         = 8: name of volume   )
(           else BIT:           )
(           0=1: read only      )
(           1=1: hidden file    )
(           2=1: system file    )
(           4=1: subdirectory   )
(           5=1: changed        )
( out: CF:= 1 if no error       )
(      ES:DI:= found_name_adr   )
( chg: AX,BX,ES,DI              )
( ***************************** )
($PTR)   d.cx b>m   $2F dos intr
[ $8E $06 d.es ]  ( mov es,d.es )
[ $8B $3E d.bx ]  ( mov di,d.bx )
[ $83 $C7 $1E ]   ( add di,1E   )
$4E dos intr .not.
;


           : dirnext? 
( *****  find next file   ***** )
( ***************************** )
( arg: ES:DI found_name_adr     )
( out: CF:= 0 if no error       )
( chg: AX,BX,ES,DI              )
( ***************************** )
$4F dos intr .not.
;

: dirattr 
( * attribute of found file )
( ************************* )
( arg: ES:DI found_name_adr )
( out: AL:= attribute       )
( chg: AX                   )
( ************************* )
ah0
[ $26 $8A $45 $F7 ] ( mov al,es:[di-9] )
;

        : dirtime 
( **  time of found file   ** )
( *************************** )
( arg: ES:DI found_name_adr   )
( out: AX:= hour 0-24         )
(      BX:= minutes 0-59      )
(      SI:= seconds 0-59      )
( chg: -                      )
( *************************** )
[ $26 $8B $45 $F8 ] ( mov ax,es:[di-8] )
a>b a>adr cpush
[ $B1 $0B ]      ( mov cl,11  )
[ $D3 $E8 ]      ( shr ax,cl  )
[ $25 *$1F ]     ( and ax,$1f )
[ $B1 $05 ]      ( mov cl,05  )
[ $D3 $EB ]      ( shr bx,cl  )
[ $81 $E3 *$3F ] ( and bx,$3f )
[ $D1 $E6 ]      ( shl si,1   )
[ $81 $E6 *$1F ] ( and si,$1f )
cpop
;

         : dirdate 
( **  date of found file   ** )
( *************************** )
( arg: ES:DI found_name_adr   )
( out: AX:= year              )
(      BX:= month 1 - 12      )
(      SI:= day   1 - 31      )
( chg: -                      )
( *************************** )
[ $26 $8B $45 $FA ] ( mov ax,es:[di-6] )
a>b a>adr  cpush
[ $B1 $09 ]      ( mov cl,09  )
[ $D3 $E8 ]      ( shr ax,cl  )
[ $25 *$7F ]     ( and ax,$7f )
[ $05 1980 ]    ( add ax,1980 )
[ $B1 $05 ]      ( mov cl,05  )
[ $D3 $EB ]      ( shr bx,cl  )
[ $81 $E3 *$0F ] ( and bx,$0f )
[ $81 $E6 *$1F ] ( and si,$1f )
cpop
;

       : dirsize 
( ** length of found file ** )
( ************************** )
( arg: ES:DI found_name_adr  )
( out: BX:AX:= length        )
( chg: AX,BX                 )
( ************************** )
[ $26 $8B $45 $FC ] ( mov ax,es:[di-4] )
[ $26 $8B $5D $FE ] ( mov al,es:[di-9] )
;


( ** Weitere Systemfunktionen ** )

          : sysdate 
( *****  get systemdate  ***** )
( **************************** )
( arg: -                       )
( out: ES:= weekday 0 = sunday )
(      AX:= day 1 - 31         )
(      BX:= month 1 - 12       )
(      DI:= year 1980 - 2099   )
( chg: ?                       )
( **************************** )
$2a dos intr
d.cx m>d
d.ax m>a ah0 a>e
d.dx m>a split  
; 

: .date 
( **  type date  ** )
( ***************** )
( arg: -            )
( out: -            )
( chg: AX,BX,ES,DI  )
( ***************** )
sysdate dpush bpush
u.d  '.' emit
apop u.d '.' emit
apop u.d
;

: .date+ 
( type date+weekday )
( ***************** )
( arg: -            )
( out: -            )
( chg: AX,BX,ES,DI  )
( ***************** )
 sysdate apush e>a
 case 0 of " Sonntag, "    ;;
      1 of " Montag, "     ;;
      2 of " Dienstag, "   ;;
      3 of " Mittwoch, "   ;;
      4 of " Donnerstag, " ;;
      5 of " Freitag, "    ;;
      6 of " Samstag, "    ;;
  endcase $. apop .date
; 



var fnul " nul" ;  ( nul_filename )

( note: for serial read (typ0) or serial write (typ1) )
( a ping_pong buffer is used. In this case the buflen )
( in the HCB is 256 less than the actual buflength.   )
( This is accounted for in the #buf>hcb routine.      )

typ FILE
    [  *0   ( +$0 handle )
       *0   ( +$2 typ 0:serial_read 1:serial_write 2:random_r/w )
       *0   ( +$4 pointer/maxrec# )
       *1   ( +$6 reclen )
       &0   ( +$8 bufofs bufseg )
       &0   ( +$C filename_adr ofs seg ) 
    ]
    ;

const R/O *$0010 ;
const W/O *$0011 ;
const R/W *$0012 ;

var recsize  [ *$0001 ] ; 
var filemode [ R/W ] ;
var fileattr [ *$0000 ] ;
var fbufsize [ *$0020 ] ; ( Size of filebuffer in paragraphs )

      : fassign
( **  filename to file ** )
( SYNTAX: " fil" to HCB  )
( ********************** )
( arg: SI = filename_adr )
(      DI = HCB_adr      )
( out: -                 )
( chg: -                 )
( ********************** )
[ $89 $75 $0C ] ( mov [di+10],si )
[ $8C $5D $0E ] ( mov [di+12],ds )
recsize  m>b d>adr , 6 adrn+ b>m
filemode m>b d>adr , 2 adrn+ b>m
fbufsize m>b d>adr , 8 adrn+ getfar
;



      : fexist?
( does file exist? )
( arg: SI = HCB_adr   )
( out: CF:= 0 if not  )
( chg: AX,BX          )
( ******************* )
adrpush
[ $8B $74 $0C ] ( mov si,[si+12] )
exist?
adrpop
;


     : fcreate
( create or clear file )
(    always read/write    )
( *********************** )
( arg: SI = HCB_adr       )
( out: CF:= 0 if not      )
( chg: AX,BX              )
( *********************** )
adrpush 0
[ $8B $74 $0C ] ( mov si,[si+12] )
[ $89 $1E d.cx ] ( mov d.cx,bx ) 
($PTR)  $3C  dos  intr  ?doserr
adrpop
;

: firstread
 [ $8B $44 $06 ] ( mov ax,[si+06] reclen)
 $100 +
 [ $8b $1c ]     ( mov bx,[si]    )
 bh0
 [ $8E $44 $0A ] ( mov es,[si+0A] bufseg)
 [ $8B $7C $08 ] ( mov di,[si+08] bufofs )
 [ $89 $7C $02 ] ( mov [si+2],di ] )
 d>adr
 L/read?
;

: nextwrite
;
: lastwrite
;

: readr/w
;
: writer/w
;
: flush
;

: fopen 
( **** open file     **** )
( *********************** )
( arg: SI = HCB_adr       )
( out: CF:= 0 if error    )
(      ES:DI:= buf_adr    )
( chg: AX,BX              )
( *********************** )
( open: )
adrpush
[ $8A $5C 2 ]    ( mov bl,[si+2] )
bh0
[ $8B $74 $0C ]  ( mov si,[si+12] )
[ $89 $1E d.ax ] ( mov d.ax,bx )
($PTR)   $3D dos intr   ?doserr
adrpop

IF               ( no error: handle )
 [ $A1 d.ax ]    ( mov ax,d.ax )
 a>m             ( store handle )
 [ $8A $44 $02 ] ( mov al,[si+2] )
 [ $25 $02 $00 ] ( and ax,0002 )
 case
  0 of firstread ;;
  2 of readr/w   ;;
 endcase
ENDIF
;

: nextread?
( read next buffer         )
( ************************ )
( arg: SI = HCB_adr        )
( out: CF:=0 if terminated )
(      ES:DI buffer_adr    )
( chg: AX                  )
( ************************ )
[ $8B $54 $08 ] ( mov dx,[si+8] ) ( ofs )
[ $03 $54 $06 ] ( add dx,[si+6] ) ( ofs+len )
[ $3B $54 $04 ] ( cmp dx,[si+4] )
IF- B
  bpush
  cpush
[ $1E ]         ( push ds )
[ $8B $7C $08 ] ( mov di,[si+8] )
  dpush
[ $8E $44 $0A ] ( mov es,[si+A] )
  adrpush
[ $89 $D6 ]     ( mov si,dx )
[ $B9 $80 $00 ] ( mov cx,128 )
[ $06 ]         ( push es )
[ $1F ]         ( pop  ds )
[ $F3 $A5 ]     ( rep movsw )
  adrpop
[ $8B $44 $06 ] ( mov ax,[si+6] )
[ $29 $44 $04 ] ( sub [si+4],ax ) ( len )
[ $8B $1C ]     ( mov bx,[si] ) ( handle )
  bh0
  L/read?
  dpop
[ $1F ]         ( pop  ds )
  cpop
  bpop
ENDIF
;  

: readw?
(  read next word   )
( arg: SI = HCB_adr )
( out: CF           )
( chg: ?            )
( ***************** )
nextread?
[ $8B $5C $04 ] ( mov bx,[si+4] )
L/nextword?
[ $89 $5C $04 ] ( mov [si+4],bx )
;
  
: readl?
(  read next line   )
( arg: SI = HCB_adr )
( out: CF           )
( chg: ?            )
( ***************** )
nextread?
[ $8B $5C $04 ] ( mov bx,[si+4] )
L/nextline?
[ $89 $5C $04 ] ( mov [si+4],bx )
;

: reads?
( read to next separator )
;    
  
           : fclose
( *****  close file       **** )
( **************************** )
( arg: SI = HCB_adr            )
( out: CF:= 1 if no error      )
( chg: AX,BX                   )
( **************************** )
adrpush
[ $8A $14 ]      ( mov dl,[si] )
[ $B6 $00 ]      ( mov dh,0    )
[ $80 $FA 0 ]    ( cmp dl,0    )
[ $F9 ]          ( stc         )
IF- NZ          ( file is open )
  ( einsetzen: )
  ( #typ = 1 #writelast )
  ( #typ = 2 #flush     )
  [ $89 $16 d.bx ] ( mov d.bx,dx ) 
  $3E dos intr ?doserr
  adrpop , 8 adrn+ freefar
ELSE
 adrpop  
ENDIF
;



: .fattr
 15 tab -lead0
 dirsize  dpush d= 7  ud.r   dpop  25 tab lead0
 dirdate  
          apush bpush adr>a  2 u.r '.' emit apop  2 u.r
          '.' emit apop  2 u.r 
           36 tab 
 dirtime  bpush  2 u.r ':' emit apop  2 u.r 45 tab 
dirattr   2 u.r
;

var f file ;

memsizes( $10 0 )
: main initnoNPU
  memrelease
  " ABC.ALX" to f fassign
  f fopen
  firstread
  readl?  L/$. 
  f fclose
  wait
;