( Port adresses for SoundBlaster pro )

aconst SBBASE  		$220 ;

aconst FM-left-Ctrl	$220 ;  ( BASE +00 )
aconst FM-left-Data     $221 ;  ( BASE +01 )
aconst FM-right-Ctrl	$222 ;	( BASE +02 )
aconst FM-right-Data	$223 ;  ( BASE +03 )
aconst FM-Ctrl		$228 ;  ( BASE +00 )
aconst FM-Data     	$229 ;  ( BASE +01 )

aconst FM-Reg-Status	$338 ;
aconst FM-Select	$339 ;
aconst FM-Data-Port	$389 ;

aconst MIXER-ADDRESS	$224 ;	( BASE +04 )
aconst MIXER-DATA	$225 ;  ( BASE +05 )

aconst DSP-RESET	$226 ;  ( BASE +06 )
aconst DSP-READ		$22A ;  ( BASE +0A )
aconst DSP-WRITE	$22C ;	( BASE +0C )
aconst DSP-DATA-AVAIL   $22E ;  ( BASE +0E )


( DSP - commands )

const DIR-DAC		$10 ;
const DIR-ADC		$20 ;

const DMA-DAC		$14 ;
const DMA-ADC		$24 ;
const HALT-DMA		$D0 ;
const CONT-DMA		$D4 ;

const TIME-CONST	$40 ;

const SPKR-ON		$D1 ;
const SPKR-OFF		$D3 ;


const sbp-mix-vol	$23 ;
const sbp-mix-cd	$29 ;
const sbp-mix-line	$2E ;
const sbp-mix-fm	$07 ;
const sbp-mix-mic	$0B ;
const sbp-mix-dac	$15 ;

const Mic-src		$01 ;
const CD-src		$03 ;
const Line-src		$07 ;
const FltLow-src	$00 ;
const FltHigh-src	$08 ; 

const FM-off		$71 ;
const FM-right		$51 ;
const FM-left		$31 ;
const FM-both		$11 ;


: sb-reset
  ( in : - )
  ( out: - )
  dsp-reset , 1 al>p
  10 delay
  dsp-reset , 0 al>p  
; 

: get-adc
  ( in:  - )
  ( out: A/D value in al )
  dsp-write , dir-adc al>p
  begin
    dsp-data-avail p>al
  127 .=. .not. 
  until
  dsp-read p>al  
;

: put-dac 
  ( in:  bl value to D/A )
  ( out: - )
  dsp-write , dir-dac al>p
  dsp-write b>a al>p
  begin
    dsp-data-avail p>al
  127 .=. .not. until
;

: sb-sample-rate
  ( in: bx = sampling rate  )
  b>d  &1000000 ba/d ah0 a>b , 255 - a>b
  dsp-write , TIME-CONST al>p
  dsp-write b>a al>p
;

: sb-mixer 
  ( in: bl = Data to write  )
  (	al = Mixer-register )
  ( out: - )
  MIXER-ADDRESS  al>p
  MIXER-DATA b>a al>p
;  

: get-sb-mixer
  ( in:  bl = Mixer-register )
  ( out: al = Value of Mixer-reg. )
  MIXER-ADDRESS b>a al>p
  MIXER-DATA p>al
;  


: sb-set-source
  ( in:  bl = source constant <Mic-src,CD-src or Line-src> )
  (  	 al = filter constant <FltLow-src, FltHigh-src> )
  or a>b
  MIXER-ADDRESS , $1D al>p
  MIXER-DATA b>a al>p  
;

: sb-pos-FM
  MIXER-ADDRESS , $16 al>p
  MIXER-DATA b>a al>p  
;    

