(
        ************************************************************
        *         NAXOS Version 2.13  16-Bit Runtime library       *
        *                                                          *
	*                 dBase (TM) support routines	           *
	*						           *		
        *                         V. 1.00                          *
        * (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
        *                                                          *
        *                      Rev. 13B 25.08.93                   *
        *                                                          *
        ************************************************************
)


const db-fbufsize 1024 ;

var (dbf) file ;
var db-fbuf byte db-fbufsize ;

record DBHEADER
  var dbtype [ 03 ] ;
  var year byte ;
  var month byte ;
  var day byte ;
  var reccount double ;
  var location word ;
  var reclen word ;
  var reserved byte 20 ;
;

record DBFIELD
  var fieldname string 10 ;
  var fieldtype byte ;
  var fieldadress word ;
  var dummy word ;
  var fieldlen byte ;
  var fielddec byte ;
  var reserved byte 14 ;
;

var (dbfld2) dbfield ;
var (dbdate)    " 00000000" ;
var (db!buf) byte 256 ;

: date>dbdate ( date in ba --> result ptr in SI )
  bapush
  leading m>d '0' bl>m
  bapop
  bapush b>a 0 <# # # # # #> m>ba (dbdate) ba>m 
  bapop apush 8 shr 0 <# # # #> m>a (dbdate) adr2+ adr2+ a>m
  apop ah0 0 <# # # #> m>a (dbdate) adr2+ adr2+ adr2+ a>m
  leading d>m
  (dbdate)
;

: dbdate>date ( dbdate ptr in SI --> date in BA )
          m>al '0' - 1000 * apush  
    adr+  m>al '0' -  100 * bpop + apush
    adr+  m>al '0' -   10 * bpop + apush
    adr+  m>al '0' -        bpop + apush

    adr+  m>al '0' -   10 * apush
    adr+  m>al '0' -        bpop + 256 * apush
    adr+  m>al '0' -   10 * bpop + apush
    adr+  m>al '0' -        bpop + bpop
;



: DB-CREATE ( si : name )
  to (dbf) fassign
  sysdate 1900 - dbheader_year al>m 
  sysdate dbheader_month [ $88 $DA $88 $FB $88 $D7 ] b>m
  (dbf) fcreate
  dbheader_dbtype m>bl (dbf)
  &0  dbheader_reccount ba>m
  $21 dbheader_location bl>m 
  1 dbheader_reclen  b>m
  dbheader to (dbf) , 32 fput
  dbheader_location m>a 1- 0 (dbf) fseek
  $1A0D (dbf) fputw  
  (dbf) fclose
;

: DB-USE ( si : name )
  to (dbf) fassign
;

: (WRITEHEADER)
  dbheader_dbtype m>bl (dbf) fputb
  sysdate 1900 - dbheader_year al>m 
  sysdate dbheader_month [ $88 $DA $88 $FB $88 $D7 ] b>m
  &0 (dbf) fseek
  dbheader to (dbf) , 32 fput
;


: DB-ADDFIELD
(  si: Data (String); bx: Type ('C','D','N'); al:Field length; ah:Decimals ) 
( Types are : 'C' Chars , 'D' Date Field , 'N' Numeric Field )

  bapush
  to dbfield_fieldname strcpy
  bapop
  dbfield_fieldtype bl>m
  dbfield_fieldlen  al>m
  dbfield_fielddec  ah>m
  (dbf) fopen
  (dbf) to dbheader , 32 fget 
  dbheader_location m>a 32 - 1- 0
  (dbf) fseek (dbf) to (dbfld2) , 32 fget
  dbheader_reclen m>a dbfield_fieldlen m>bl + dbheader_reclen a>m
  dbheader_location m>a $21 .=. IF 03 dbfield_fieldadress b>m else
   (dbfld2)_fieldadress m>a (dbfld2)_fieldlen m>b +
   dbfield_fieldadress a>m endif
  dbheader_location m>a apush 32 + dbheader_location a>m 0 apop 1-
  (dbf) fseek
  dbfield to (dbf) , 32 fput
  $200D (dbf) fputw
  (writeheader)
  (dbf) fclose
;

: DB-APPEND
  (dbf) fopen
  (dbf) to dbheader , 32 fget 
  dbheader_reccount m>a dbheader_reclen m>b u*
  dbheader_location m>d e= 0 d/+
  (dbf) fseek 
  dbheader_reclen m>a 
  db-fbuf adr2+ to (dbf) fput   
  dbheader_reccount mem+
  (writeheader)   
  (dbf) fclose
;   

: DB-GOTO
(      record# in bx )
  xab 1- xab
  dbheader_reclen m>a u*
  dbheader_location m>d e= 0 d/+
  (dbf) fseek
; 


: DB-PUT
( arg:    record# in BX )
  apush
  (dbf) fopen
  (dbf) to dbheader , 32 fget 
  bpop db-goto
  dbheader_reclen m>a 
  db-fbuf adr2+ to (dbf) fput   
  (dbf) fclose
;   
 

: DB-GET
( arg:     record# in BX )
  bpush
  (dbf) fopen
  (dbf) to dbheader , 32 fget 
  bpop db-goto
  dbheader_reclen m>a
  (dbf) to db-fbuf fget   
  (dbf) fclose
;   

: (DB-SETFIELD1)
(      si=string )
 adrpush strlen apush dbfield_fieldlen m>b - .0<. IF
   apush
   dbfield_fieldadress m>a db-fbuf adrn+ adr>d
   bpop apop adrpop bpush [ $FC $1E $07 $89 $C1 $F3 $A4 ] 
   apop neg 1 do
    , $20 [ $88 $05 $47 ]   
   loop
 else
   dbfield_fieldadress m>a db-fbuf adrn+ adr>d
   dbfield_fieldlen m>al
   apop adrpop
   [ $FC $1E $07 $89 $C1 $F3 $A4 ] 
 endif
 db-fbuf 0 b>m
 adr2+ $20 bl>m
 (dbf) fclose
;

: DB-SETFIELD
( arg: BX= Field#  )
(      SI=Str addr )
(   or BA=Date     )
(   or ST(0)=Float )

ipush
adrpush edpush bpush
 (dbf) fopen
 bpop 
 , 32 * 0 (dbf) fseek (dbf) to dbfield , 32 fget

dbfield_fieldtype m>al
edpop
case
 'C' OF adrpop ;;
 'D' OF adrpop ed>ba date>dbdate ;;
 'N' OF adrpop dbfield_fielddec m>al fdup (db!buf) F>$ (db!buf)
        F0 .F>. IF ELSE adr+ ENDIF ;;
 else *-3 errorptr
endcase
(DB-SETFIELD1)
ipop

;

: DB-GETFIELD
( arg: bx=field# )
(      si=result addr )
( out case fieldtype of )
(         C: SI=str addr + string copied to result addr )
(	  D: BA=date + date in result addr )
(         N: float in result-addr )
ipush
adrpush bpush
 (dbf) fopen
 bpop
 , 32 * 0 (dbf) fseek (dbf) to dbfield , 32 fget
 dbfield_fieldadress m>a db-fbuf adrn+ adr2- adrpush
 dbfield_fieldlen m>al adrpop d= (db!buf)
 [ $FC $1E $07 $89 $C1 $F3 $A4 $C6 $05 $00 ]
 (dbf) fclose

 dbfield_fieldtype m>al
 case 
 'C' OF (db!buf) dpop strcpy ;;
 'D' OF (db!buf) dbdate>date adrpop ba>m ;;
 'N' OF (db!buf) .fnumber. adrpop f>m  ;;
 else *-3 errorptr
 endcase
ipop
;

