(
        ************************************************************
        *         NAXOS Version 2.13  16-Bit Runtime library       *
        *                                                          *
        *       FLOATING POINT PACKAGE for 80x87 support  V. 1.02  *
        *                                                          *
        * (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
        *                                                          *
        *                      Rev. 13B 25.08.93                   *
        *                                                          *
        ************************************************************
)



( ** Constants, Variables ** )

const round    $0000 ; ( Constants for NPU rounding control ) 
const rounddwn $0400 ;
const roundup  $0800 ;
const trunc    $0C00 ;

const dplc '.' ;         ( DecimalPointChar )

typ  FLOAT  Byte 8       ( Floating point var ) ;
typ  BCD    Byte 10      ( BCD-FLOAT var ) ;

var FDPL    word         ( Pointer to decimal point / FLOAT ) ;
var SCALE   float        ( scaling factor / FLOAT ) ;
 
 
( **  fstack operators ** )
MACRO F+     [ $9B $DE $C1 ]   ( FADDP ST(1),ST ) ;
MACRO F-     [ $9B $DE $E9 ]   ( FSUBP ST(1),ST ) ;
MACRO F*     [ $9B $DE $C9 ]   ( FMULP ST(1),ST ) ;
MACRO F/     [ $9B $DE $F9 ]   ( FDIVP ST(1),ST ) ;
MACRO FSQRT  [ $9B $D9 $FA ]   ( FSQRT ) ;
MACRO FABS   [ $9B $D9 $E1 ]   ( FABS ) ;
MACRO FNEG   [ $9B $D9 $E0 ]   ( FCHS ) ;
MACRO FDUP   [ $9B $D9 $C0 ]   ( FLD ST ) ;
MACRO FSWAP  [ $9B $D9 $C9 ]   ( FXCH ) ;
MACRO FOVER  [ $9B $D9 $C1 ]   ( FLD ST(1) ) ;
MACRO FSQR   FDUP F* ;
MACRO F0     [ $9B $D9 $EE ]   ( FLDZ )   ;
MACRO F1     [ $9B $D9 $E8 ]   ( FLD1 ) ;
MACRO FPI    [ $9B $D9 $EB ]   ( FLDPI ) ;
MACRO Fln    [ $D9 $ED $9B $D9 $C9 $9B $D9 $F1 ] ;
MACRO Flog   [ $D9 $EC $9B $D9 $C9 $9B $D9 $F1 ] ;


( ** memory to fstack    ** )
( ** memory_adress in SI ** )
MACRO M>F     [ $9B $DD $04 ]  ( FLD [si] )    ; (  8 bytes )
MACRO W/M>F   [ $9B $DF $04 ]  ( FILD w/[si] ) ; (  2 bytes )
MACRO D/M>F   [ $9B $DB $04 ]  ( FILD d/[si] ) ; (  4 bytes )
MACRO BCD/M>F [ $9B $DF $24 ]  ( FBLD [si] )   ; ( 10 bytes )

( ** fstack to memory    ** )
( ** memory_adress in SI ** )
MACRO F>M     [ $9B $DD $1C ]  ( FSTP [si] )    ; (  8 bytes )
MACRO W/F>M   [ $9B $DF $1C ]  ( FISTP w/[si] ) ; (  2 bytes )
MACRO D/F>M   [ $9B $DB $1C ]  ( FISTP d/[si] ) ; (  4 bytes )
MACRO BCD/F>M [ $9B $DF $34 ]  ( FBSTP [si] )   ; ( 10 bytes )

( ** register AX <-> fstack ** )
MACRO F>A     ( ST --> ax )     FBUF W/F>M m>a  ;
MACRO A>F     ( ax --> ST )     FBUF A>M W/M>F  ;

( ** register BX:AX <-> fstack ** )
: F>BA        ( ST --> bx:ax )  FBUF D/F>M m>ba ;
: BA>F        ( bx:ax --> ST )  FBUF ba>m D/M>F ;


( ** fconditions ** )
( CF:=1 if true, CF:=0 if false )

: .F=. [ $9B $DE $D9 $9B $DD $3E NPUSTAT $9B ]
  [ $50 $A1 NPUSTAT $25 $00 $45 $3D $00 $40 $58 $F8 $75 $01 $F5 ] ;

: .F<. [ $9B $DE $D9 $9B $DD $3E NPUSTAT $9B ]
  [ $50 $A1 NPUSTAT $25 $00 $45 $3D $00 $01 $58 $F8 $75 $00 $F5 ] ;

: .F>. [ $9B $DE $D9 $9B $DD $3E NPUSTAT $9B $50 $A1 NPUSTAT $25 $00 $45 ]
  [ $3D $00 $00 $58 $F8 $75 $01 $F5 ] ;

( *** miscellanelous NPU support functions *** )

: setdecimals 
( number of digits after decpoint )
( ******************************* )
( arg: BX = number of digits      )
( out: -                          )
( chg: AX                         )
( ******************************* )
  bpush
  , 18 - fdpl a>m
  %1 
  apop apush 1 do 
     %10 F*
  loop
  scale F>M
    apop 0 .=. IF %1 scale F>M ENDIF
;

: getdecimals 
( get number of digits after decpoint )
( ************************************* )
( arg: -                                )
( out: AX = number of digits            )
( chg: AX,BX                            )
( ************************************* )
  fdpl m>b , 18 -
;

: NPUMODE  
( set NPU rounding mode )
( ************************************* )
( arg: BX = rounding mode constant      )
( out: -                                )
( ************************************* )
  apush bpush adrpush epush 
  b>e
  [ $9B $D9 $3E NPUSTAT $9B ]
  NPUSTAT m>a $F3FF and e>b or NPUSTAT a>m  
  [ $9B $D9 $2E NPUSTAT $9B ]
  epop adrpop bpop apop
;

: #f  ( FLOAT-Zahl in formatierte Ausgabe )
  scale m>f F*
  FBUF BCD/F>m
  0 , 8 DO
    i FBUF adrn+ m>a $0F and $30 + a>b hold
    i a>b , 8 - 2* 1+ FDPL m>b .=. IF DPLC hold ENDIF
    i FBUF adrn+ m>a u/2 u/2 u/2 u/2 $0f and $30 + a>b hold
    i a>b , 8 - 2* FDPL m>b .=. IF DPLC hold ENDIF
  LOOP
;

: FSIGN
  FBUF BCD/M>F
  F0 .F>. IF '-' hold ELSE bl hold ENDIF  
;

: f.  ( FLOAT-Zahl ausgeben )
  FDUP FDUP
  <# #f fsign #> a>d adr>e m>al apush
  FABS FLOG F>A 0 .<. IF , 0 ENDIF fdpl m>b xab -
  e>adr ADRN+ apop adr- al>m adr>e
  d>a + 1+ a>d fdpl m>b - e>adr 
    F0 .F>. IF ELSE adr+ ENDIF  $.
;
( ** formatted output of floating numbers ** )
var f$TMP word ;

: F>$   
	( FLOAT-2-STRING )
	( arg: ST: Float, SI: Stringaddr, AX: Decimal places. )
	( Number is truncated if it doesn't fit into string )
	
  adrpush
  apush getdecimals f$tmp a>m bpop setdecimals
  FDUP FDUP
  <# #f fsign #> a>d adr>e m>al apush
  FABS FLOG F>A 0 .<. IF , 0 ENDIF fdpl m>b xab -
  e>adr ADRN+ apop adr- al>m adr>e
  d>a + 1+ a>d fdpl m>b - e>adr dpop  F0 .F>. IF ELSE adr+ ENDIF strcpy
  f$tmp m>b setdecimals
;

: NPUERR
  apop 203 errorptr 
;

macro initnoNPU init ;

: finit
  [ $9B $DB $E3 ] ( FINIT )
  %12345 %12345 .F=. IF- NC NPUERR ENDIF
  round NPUMODE  
  3 setdecimals
;

: init overload ( - )
  ( !!! this init overloads the init method imported from KERN !!! )
  ~init
  [ $9B $DB $E3 ] ( FINIT )
  %12345 %12345 .F=. IF- NC NPUERR ENDIF
  round NPUMODE  
  3 setdecimals
;

: .#Fin.
  21 #in BA>F dpl m>al 0 .<>.
  IF dpl m>al 1 do %10 F/ loop
  ENDIF
;

: .Fnumber.
  .number. BA>F dpl m>al 0 .<>.
  IF dpl m>al 1 do %10 F/ loop
  ENDIF
;


( ******************************************* )
( **         iAPX387  NPU EXTENSIONS       ** )
( ** inoperable  on 8087 or iAPX287 NPU's  ** )
( ******************************************* )

: FSIN
  [ $D9 $FE ]
;

: FCOS
  [ $D9 $FF ]   
;

: FTAN
  FDUP FCOS FSWAP FSIN F/
;    