
(
        ************************************************************
        *         NAXOS Version 2.13  16-Bit Runtime library       *
        *                                                          *
	*         HERCULES MONOCHROME GRAPHIC ROUTINES	V1.00	   *
        *                                                          *
        * (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
        *                                                          *
        *                      Rev. 13B 25.08.93                   *
        *                                                          *
        ************************************************************
)



( Standard Modes available on HGC )

( Hercules graphics mode )
(     ModeName     *$nnxx / nn=Devcaps# xx=Mode# in BIOS always 7 on HERC )
const 720x348x2  *$0007 ;

( MDA & HERC textmode )
(     ModeName     *$nnxx / nn=Devcaps# xx=Mode# in BIOS always 7 on HERC )
const 80x24x2    *$0107 ;


(   devcaps x-res y-res pages colors )
var devcaps [ *719 *347 01 001
	       *80 *024 01 001 ] ;

var pix-x-max [ *80 ] ;
var pix-y-max [ *24 ] ;
var page-max  [ 8 ] ;
var color-max [ *16 ] ;

var page      [ 1 ] ;   
var pix-x     [ *0 ] ;
var pix-y     [ *0 ] ;
var pgbase    [ *$B800 ] ;	

var color     [ 0 ] ;

: setmode ( switch to graphics mode specified in bl -> mode constants )
  b>a $10 intr
;

: setmodenc ( as above with no clear screen )
  b>a $80 or $10 intr
;

var (grapht) [ $35 $2D $2E $07 $5B $02     ( CRTC-Reg-Values for Graph )
	       $57 $57 $02 $03 $00 $00 ] ;

var (textt)  [ $61 $50 $52 $0F $19 $06     ( CRTC-REG-Values for TEXT )
	       $19 $19 $02 $0D $0B $0C ] ;


: gfillscr
  b>a
  pgbase m>e
  $8000 FOR
   i>adr es: al>m
  NEXT
;

: gcls
  0 gfillscr
;
: graphmodenc ( switch to graphicsmode / input: mode.const in BX ) 
  720x348x2
  B>a split b>a 6 * devcaps adrn+ to pix-x-max , 6 i/copy
  (GRAPHT)
 [ $B0 $03 ]    ( mov al,00000011b )
 [ $BA *$03BF ] ( mov dx,3BFH )
 [ $EE ]        ( out dx,al )
 [ $B0 $82 ]	( mov al,00000010b )
 [ $BA *$03B8 ] ( mov dx,3B8H )
 [ $EE ]	( out dx,al )
 [ $B9 *$000C ] ( mov cx,12 )
 [ $32 $FF ]	( xor bh,bh )
 ( VCP )
 [ $AC ]	( lodsb )
 [ $8A $E0 ]	( mov ah,al )
 [ $8A $C7 ]	( mov al,bh )
 [ $BA *$03B4 ]	( mov dx,3B4H )
 [ $EF ]	( out dx,ax )
 [ $FE $C7 ]	( inc bh )
 [ $E2 $F3 ]    ( loop vcp )
 [ $B0 $8A ]    ( mov al,00001010b )
 [ $BA *$03B8 ] ( mov dx,3B8H )
 [ $EE ]        ( out dx,al )
 pix-y-max ( this line was added to suit var-usage by optimizing V2.14 compiler )
;

: graphmode
  graphmodenc
  GCLS
;

: textmodenc ( switch to standard 80x25 Textmode )
  80x24x2 B>a split b>a 6 * devcaps adrn+ to pix-x-max , 6 i/copy
    (TEXTT)
 [ $B0 $20 ]	( mov al,00100000b )
 [ $BA *$03B8 ] ( mov dx,3B8H )
 [ $EE ]	( out dx,al )
 [ $B9 *$000C ] ( mov cx,12 )
 [ $32 $FF ]	( xor bh,bh )
 ( VCP )
 [ $AC ]	( lodsb )
 [ $8A $E0 ]	( mov ah,al )
 [ $8A $C7 ]	( mov al,bh )
 [ $BA *$03B4 ]	( mov dx,3B4H )
 [ $EF ]	( out dx,ax )
 [ $FE $C7 ]	( inc bh )
 [ $E2 $F3 ]    ( loop vcp )
 [ $B0 $28 ]	( mov al,00101000b )
 [ $BA *$03B8 ] ( mov dx,3B8H )
 [ $EE ]        ( out dx,al )
 pix-y-max ( this line was added to suit var-usage by optimizing V2.14 compiler )
;

: textmode
  textmodenc
  7 color bl>m
  clrscr
;


: entrymode ( restore initial videomode as on program entry )
  video-byte m>bl setmode
;

: setcolor ( set pixel color as in bx )
  color bl>m
;

: disp-page ( select video page to display as specified in bl )
  bpush 
  pix-x-max m>a 80 .=. if
   bpop , 0 .=. if , $28 adr $3B8 a>p else , $A8 adr $3B8 a>p endif
  else
   bpop , 0 .=. if , $2A adr $3B8 a>p else , $AA adr $3B8 a>p endif
  endif
;

: plot-page ( select video page to plot into as spec. in bl )
  page bl>m 
  , 0 .=. if $B000 pgbase b>m else $B800 pgbase b>m endif
;


VAR (LINBEG) [
*$0000 *$2000 *$4000 *$6000 *$005A *$205A *$405A *$605A 
*$00B4 *$20B4 *$40B4 *$60B4 *$010E *$210E *$410E *$610E 
*$0168 *$2168 *$4168 *$6168 *$01C2 *$21C2 *$41C2 *$61C2 
*$021C *$221C *$421C *$621C *$0276 *$2276 *$4276 *$6276 
*$02D0 *$22D0 *$42D0 *$62D0 *$032A *$232A *$432A *$632A 
*$0384 *$2384 *$4384 *$6384 *$03DE *$23DE *$43DE *$63DE 
*$0438 *$2438 *$4438 *$6438 *$0492 *$2492 *$4492 *$6492 
*$04EC *$24EC *$44EC *$64EC *$0546 *$2546 *$4546 *$6546 
*$05A0 *$25A0 *$45A0 *$65A0 *$05FA *$25FA *$45FA *$65FA 
*$0654 *$2654 *$4654 *$6654 *$06AE *$26AE *$46AE *$66AE 
*$0708 *$2708 *$4708 *$6708 *$0762 *$2762 *$4762 *$6762 
*$07BC *$27BC *$47BC *$67BC *$0816 *$2816 *$4816 *$6816 
*$0870 *$2870 *$4870 *$6870 *$08CA *$28CA *$48CA *$68CA 
*$0924 *$2924 *$4924 *$6924 *$097E *$297E *$497E *$697E 
*$09D8 *$29D8 *$49D8 *$69D8 *$0A32 *$2A32 *$4A32 *$6A32 
*$0A8C *$2A8C *$4A8C *$6A8C *$0AE6 *$2AE6 *$4AE6 *$6AE6 
*$0B40 *$2B40 *$4B40 *$6B40 *$0B9A *$2B9A *$4B9A *$6B9A 
*$0BF4 *$2BF4 *$4BF4 *$6BF4 *$0C4E *$2C4E *$4C4E *$6C4E 
*$0CA8 *$2CA8 *$4CA8 *$6CA8 *$0D02 *$2D02 *$4D02 *$6D02 
*$0D5C *$2D5C *$4D5C *$6D5C *$0DB6 *$2DB6 *$4DB6 *$6DB6 
*$0E10 *$2E10 *$4E10 *$6E10 *$0E6A *$2E6A *$4E6A *$6E6A 
*$0EC4 *$2EC4 *$4EC4 *$6EC4 *$0F1E *$2F1E *$4F1E *$6F1E 
*$0F78 *$2F78 *$4F78 *$6F78 *$0FD2 *$2FD2 *$4FD2 *$6FD2 
*$102C *$302C *$502C *$702C *$1086 *$3086 *$5086 *$7086 
*$10E0 *$30E0 *$50E0 *$70E0 *$113A *$313A *$513A *$713A 
*$1194 *$3194 *$5194 *$7194 *$11EE *$31EE *$51EE *$71EE 
*$1248 *$3248 *$5248 *$7248 *$12A2 *$32A2 *$52A2 *$72A2 
*$12FC *$32FC *$52FC *$72FC *$1356 *$3356 *$5356 *$7356 
*$13B0 *$33B0 *$53B0 *$73B0 *$140A *$340A *$540A *$740A 
*$1464 *$3464 *$5464 *$7464 *$14BE *$34BE *$54BE *$74BE 
*$1518 *$3518 *$5518 *$7518 *$1572 *$3572 *$5572 *$7572 
*$15CC *$35CC *$55CC *$75CC *$1626 *$3626 *$5626 *$7626 
*$1680 *$3680 *$5680 *$7680 *$16DA *$36DA *$56DA *$76DA 
*$1734 *$3734 *$5734 *$7734 *$178E *$378E *$578E *$778E 
*$17E8 *$37E8 *$57E8 *$77E8 *$1842 *$3842 *$5842 *$7842 
*$189C *$389C *$589C *$789C *$18F6 *$38F6 *$58F6 *$78F6 
*$1950 *$3950 *$5950 *$7950 *$19AA *$39AA *$59AA *$79AA 
*$1A04 *$3A04 *$5A04 *$7A04 *$1A5E *$3A5E *$5A5E *$7A5E 
*$1AB8 *$3AB8 *$5AB8 *$7AB8 *$1B12 *$3B12 *$5B12 *$7B12 
*$1B6C *$3B6C *$5B6C *$7B6C *$1BC6 *$3BC6 *$5BC6 *$7BC6 
*$1C20 *$3C20 *$5C20 *$7C20 *$1C7A *$3C7A *$5C7A *$7C7A 
*$1CD4 *$3CD4 *$5CD4 *$7CD4 *$1D2E *$3D2E *$5D2E *$7D2E 
*$1D88 *$3D88 *$5D88 *$7D88 *$1DE2 *$3DE2 *$5DE2 *$7DE2 
*$1E3C *$3E3C *$5E3C *$7E3C ] ;


var (pixval) [ $80 $40 $20 $10 $08 $04 $02 $01 ] ;

: putpixel ( x-coord in bx; y-coord in ax; color is taken from pix-color )
  pgbase m>e
  [ $89 $1E pix-x ]  ( mov pix-x,bx )
  [ $A3 pix-y ]      ( mov pix-y,ax )
  bpush apush b>d
  color m>a  .0=. if
    apop d>b (linbeg) 2* adrn+ m>a xab u/2 u/2 u/2 + a>d
    apop 7 and (pixval) adrn+ m>al d>adr es: m>bl not and es: al>m
  else
    apop d>b (linbeg) 2* adrn+ m>a xab u/2 u/2 u/2 + a>d
    apop 7 and (pixval) adrn+ m>al d>adr es: m>bl or es: al>m
  ENDIF
 ;
  
: getpixel ( x-coord in bx; y-coord in ax; color is returned in al )
  pgbase m>e
  [ $89 $1E pix-x ]  ( mov pix-x,bx )
  [ $A3 pix-y ]      ( mov pix-y,ax )
  bpush apush b>d
  color m>a  .0=. if
    apop d>b (linbeg) 2* adrn+ m>a xab u/2 u/2 u/2 + a>d
    apop 7 and (pixval) adrn+ m>al d>adr es: m>bl not and es: al>m
  else
    apop d>b (linbeg) 2* adrn+ m>a xab u/2 u/2 u/2 + a>d
    apop 7 and (pixval) adrn+ m>al not d>adr es: m>bl and 
    0 .=. IF A= 0 ELSE A= 1 ENDIF
  endif
;

: hline ( x1-coord in bx;y coord in ax; x2-coord in di )
  putpixel
  d>a pix-x m>b - a>b FOR
    pix-x m>b b+ b>m pix-y m>a putpixel
  next
;


: vline ( x1-coord in bx;y coord in ax; y2-coord in di )
  putpixel
  d>a pix-y m>b - a>b FOR
    pix-x m>b pix-y m>a 1+ a>m putpixel
  next
;

var BG-x1 word ;
var BG-y1 word ;
var BG-xd word ;
var BG-yd word ;
var BG-xf word ;




: line  ( input: x1: BX, y1: AX, x2: ES, y2: DI )
	( output: - )
	( CX is modified ! )
	
[ $89 $DA ] d>b
[ $89 $1E BG-y1 $E8 $96 $00 $89 $0E BG-yd $E8 $AE ]
[ $00 $92 ]
e>b
[ $89 $1E BG-x1 $E8 $85 $00 $89 $0E BG-xd $E8 $9D ]
[ $00 $8B $D8 $3B $DA $7E $3C $8B $C2 $03 $C0 $2B $C3 $A3 BG-xf ]
[ $8B $CB $41 $E8 $75 $00 $A1 BG-xf $0B $C0 $7E $15 $03 $C2 $03 ]
[ $C2 $2B $C3 $2B $C3 $A3 BG-xf $A1 BG-yd $01 $06 BG-y1 $EB ]
[ $08 $90 $03 $C2 $03 $C2 $A3 BG-xf $A1 BG-xd $01 $06 BG-x1 ]
[ $E2 $D1 $C3 $8B $C3 $03 $C0 $2B $C2 $A3 BG-xf $8B $CA $41 $E8 ]
[ $39 $00 $A1 BG-xf $0B $C0 $7E $15 $03 $C3 $03 $C3 $2B $C2 $2B ]
[ $C2 $A3 BG-xf $A1 BG-xd $01 $06 BG-x1 $EB $08 $90 $03 $C3 ]
[ $03 $C3 $A3 BG-xf $A1 BG-yd $01 $06 BG-y1 $E2 $D1 $C3 $33 ]
[ $C9 $2B $C3 $74 $05 $78 $02 $41 $C3 $49 $C3 $52 $53 $50 $8B ]
[ $1E BG-x1 $A1 BG-y1 ]
 putpixel
[ $58 $5B $5A $C3 ]
[ $0B $C0 $79 $02 $F7 $D8 $C3 ]
;


: lineto ( x in BX , y in AX )
  [ $06 $51 ] ( push es , push cx )
  bpush apush
  a>d b>e
  pix-x m>b pix-y m>a
  line
  apop pix-y a>m apop pix-x a>m
  [ $59 $07 ] ( pop cx , pop es )
;
