(
        ************************************************************
        *         NAXOS Version 2.13  16-Bit Runtime library       *
        *                                                          *
        *                   MSDOS-XMS Support V1.01                *
        *                                                          *
        * (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
        *                                                          *
        *                      Rev. 13B 25.08.93                   *
        *                                                          *
        ************************************************************
)

var XMS-ID [ *268 ] ;		( 286-Mode )

var XMS-HANDLES [ 32 ] ;	( Number of total XMS-HANDLES )

typ XMS-HANDLE [ *0 		( Handle )
		 &0		( linear 32 Bit-Address )
		] ;


var emmstruc [ 	&0           	( Blocksize )
		*0		( Source-handle )
		&0		( Offset into source )
		*0		( Destination-handle )
		&0		( Offset into destination )
	     ] ;
	     
var xmserror [ 0 ] ; 		( last xms-operation errorcode 00=ok )
var xms-haltonerr [ true ] ;



: xms-errormsg
  xmserror m>al 0 .=. IF EXIT ELSE
    a>b apop apop apop apop errorptr
  ENDIF
;


            proc XMS
( ** general interrupt interface  ** )
( ** ignores arg given back in DS ** )
( ********************************** )
( arg:          		     )
(      AH=  function number          )
(      AL=  subfunction              )
( out: CF:=0 if no error             )
(      CF:=1 if error                )
( chg: CF                            )
( ********************************** )
( push Register auf Returnstack )
  [ $06 $57 $56 $55 $51 $53 $50 $1E  ] 
  (  ES  DI  SI  BP  CX  BX  AX  DS  )

( Register aus Dos-Interface laden )
  [ $8B $1E $02 0 ] ( mov  bx,[02]   )
  [ $8B $0E $04 0 ] ( mov  cx,[04]   )
  [ $8B $16 $06 0 ] ( mov  dx,[06]   )
  [ $8B $2E $08 0 ] ( mov  bp,[08]   )
  [ $8B $36 $0A 0 ] ( mov  si,[0A]   )
  [ $8B $3E $0C 0 ] ( mov  di,[0C]   )
  [ $8E $06 $10 0 ] ( mov  es,[10]   )
  [ $FF $36 $0E 0 ] ( push [0E]      ) ( get DS .. )
  [ $1F ]           ( pop  ds        ) ( and set )
  [ $9A &0 ]	    ( CALL 0000:0000 )
( Register in Dos-Interface retten )
  [ $1F ]              ( pop ds      ) ( restor old DS )
  [ $A3 $00 0 ]        ( mov [00],ax )
  [ $89 $1E $02 0 ]    ( mov [02],bx )
  [ $89 $0E $04 0 ]    ( mov [04],cx )
  [ $89 $16 $06 0 ]    ( mov [06],dx )
  [ $89 $2E $08 0 ]    ( mov [08],bp )
  [ $89 $36 $0A 0 ]    ( mov [0A],si )
  [ $89 $3E $0C 0 ]    ( mov [0C],di )
  [ $8C $06 $10 0 ]    ( mov [10],es )
( pop Register von Returnstack )
  [ $58 $5B $59 $5D $5E $5F $07 ]
  (  AX  BX  CX  BP  SI  DI  ES )
  [ $FC ]              ( cld    )
  d.ax m>a 0 .=. IF 
    d.bx m>al xmserror al>m
  ELSE
    0 xmserror bl>m
  ENDIF
  xms-haltonerr m>al .TRUE=. IF xms-errormsg ENDIF
;


	     
: XMS-INIT  ( out : AX = 0 : no XMS / AX <> 0 : Version )
  $2f , $4300 intr 
  d.ax m>al $80 .=. IF 
    a= $4310 $2F intr
    d.bx m>b adr xms a= 42 adrn+ cs: b>m
    d.es m>b adr xms a= 44 adrn+ cs: b>m 
    a= 0 xms  
    d.ax m>a	
  ELSE 
    a= 0
  ENDIF
;
: XMS-LOCK	( in: 	SI= adr of handle-var )
		( out:	DX:BX 32 bit linear addr )
  adrpush
  m>a d.dx a>m
  a= $0C00 XMS
  d.bx m>a d.dx m>e adrpop adr2+ a>m adr2+ e>m
;  		

: XMS-UNLOCK	( in:	SI= adr of handle-var )
  m>a d.dx a>m
  a= $0D00 XMS
;

: XMS-FREE ( out: 	AX=largest Block in K
		 	BX=total XMS in K      )
		 
  a= $0800 XMS 
  d.ax m>a
  d.dx m>b
;  	

: XMS-ALLOC ( in:	BX=Block size in KB
  	      		SI=ADR OF HANDLE-VAR )
  adrpush
  d.dx b>m
  a= $0900 XMS
  d.dx m>a 
  adrpop a>m
  XMS-LOCK
;

: XMS-RELEASE ( in:	SI=adr of handle-var )
  adrpush
  XMS-UNLOCK
  adrpop
  m>a d.dx a>m
  a= $0A00 XMS
;

: XMS-RESIZE ( in:	SI=adr of handle-var )
	     (		BX=new size in KB )	
  adrpush
  XMS-UNLOCK
  adrpop adrpush
  m>a d.dx a>m
  d.bx b>m
  a= $0F00 XMS
  adrpop
  XMS-LOCK
;

: XMS-HANDLEINFO ( in:	SI= adr of handle-var 	)
		 ( out:	AX= BLOCKSIZE	      	)
		 (	BX= LOCK COUNT	   	)
		 (	DI= HANDLES LEFT	)
  m>a d.dx a>m
  a= $0E00 XMS
  d.bx m>a split a>d
  d.dx m>a
;

: XMS-MOVE   ( data in EMM-Struc )
  ds>a d.ds a>m a= emmstruc d.si a>m
  a= $0B00 XMS
;

: M>XMS   
( ******************************
  * arg: Blockaddress in ES:DI *
  *	 Blocksize in AX:BX    *
  *	 Handleadr in SI       *
  * out: -                     *
  * chg: ?	               *
  ****************************** )
  adrpush
  emmstruc a>m adr2+ b>m
  adr2+ 0 b>m adr2+
  d>m adr2+ e>m adr2+ adr>e
  adrpop m>a e>adr a>m 
  xms-move
;  	  

: XMS>M
( ******************************
  * arg: Blockaddress in ES:DI *
  *	 Blocksize in AX:BX    *
  *	 Handleadr in SI       *
  * out: -                     *
  * chg: ?	               *
  ****************************** )
  adrpush
  emmstruc a>m adr2+ b>m adr2+
  adr>a adrpop m>b a>adr b>m adr2+
  0 b>m adr2+ 0 b>m adr2+ 0 b>m adr2+
  d>m adr2+ e>m
  xms-move
;

: XMS-A20-STATUS
  a= $0700 xms
  d.ax m>a
;  

: XMS-A20-ENABLE
  a= $0500 xms
;

: XMS-A20-DISABLE
  a= $0600 xms
;

: XMS-GETHANDLE1   	( in:	si adr of handle-var )
			( out:	m(si) handle0 )
			(	AX Nr. of open Handles )
  adrpush			
  1 xms-handle xms-alloc
  xms-handle xms-handleinfo
  D>B xms-handles m>al 1- - a>e 10 * a>b xms-handle m>a -
  adrpop a>m
  xms-handle xms-release
  e>a
;	

: XMS-NEXTHANDLE	( in:	si adr of handle-var )
			( out:	m(si) next_handle )
  m>a 10 + a>m
;

: XMS-RELEASEALL
  xms-handle xms-gethandle1
  FOR 
    xms-handle xms-release
    xms-handle xms-nexthandle
  NEXT
;

: UMB-Alloc ( SI=pointer-Var , AX=Size in paras )
  adrpush
  d.dx a>m
  a= $1000 XMS
  d.bx m>a 
  adrpop adr2+ a>m
;


: UMB-Dispose ( SI=pointer-var )
  adrpush
  adr2+ m>a d.dx a>m
  a= $1100 XMS
  adrpop
  &0 ba>m
;
