program dumpdic2;
{$I+,R+,S+}
uses crt,dos;
type
  SYMTAB       = record
                  NAME   : string[12];
                  TYP    : byte;
                  QFA    : word;
                  PAR0,
                  PAR1,
                  PAR2,
                  PAR3   : word;
                  QFALEN : word;
                  QFAHI  : word;
                 end;
   hexstr      = string[8];
const r = '          ';
var buf:symtab;
    qfas : longint;
    v2xx : boolean;
    elsiz,ds : word;
    f,tf  :file ;
    li,pc,dpc :word;
    zptr  : word;
    ch : char;
    fdmp:boolean;
    scratch: array[0..255] of byte;
    gr : longint;

function hex(n, l: longint): HexStr;

{ n in l-stellige Hexzahl wandeln }

var
  i, z: integer;
  s: HexStr;
begin
  s := '';
  for i := 1 to l do
    begin
      z := n and 15; { Ziffer bilden }
      if z > 9 then z := z + 7;
      s := chr(z + 48) + s;
      n := n shr 4; { Division durch 16 }
    end;
  hex := s;
end;


function TYPSTR (nx:byte):string;
var n : string;
begin
   str(nx:3,n);
   nx := nx and $BF ;
   case nx of
    1 : n :='VAR    ';
    2 : n :='CSVAR  ';
    5 : n :='STRING ';
    6 : n :='CSSTRG ';
    7 : n :='OBJECT ';
   10 : n :='CONST  ';
   11 : n :='ACONST ';
   12 : n :=':      ';
   13 : n :='PROC   ';
   14 : n :='VECTOR ';
   15 : n :='DCONST ';
   16 : n :='FCONST ';
   17 : n :='MACRO  ';
   18 : n :='LABEL  ';
   19 : n :='BCONST ';
   else if nx>127 then
        n := 'SYS#'+n;
   end;
   typstr := n;
end;

begin
  clrscr;
  fdmp := false;
  if (paramcount>1) then fdmp := true;
  writeln('NAXOS V2.xx Library contents');
  writeln('(C) 1992 by A.Zissis');
  writeln(#10,#10);
  writeln(paramstr(1)+'.LIB');
  writeln(#10,#10);
  assign(f,paramstr(1)+'.LIB');
  assign(output,'');
  rewrite(output);
  reset(f,1);
  seek(f,68);
  blockread(f,elsiz,2);
  v2xx := false;
  if elsiz=$2020 then begin
    elsiz := sizeof(buf);
    v2xx := true;
  end;
  seek(f,70);
  blockread(f,scratch,15);
  gr := word(scratch[$4]+256*scratch[$5])*16;
  ds := word(scratch[$4]+256*scratch[$5]);
  gr := gr+(scratch[$6]+256*scratch[$7])*16;
  seek(f,gr+70);
  blockread(f,pc,2);
  blockread(f,dpc,2);
  if v2xx then writeln(r,'NAXOS V2.0x Library ',paramstr(1))
          else writeln(r,'NAXOS V2.1x Library ',paramstr(1));
  writeln;
  writeln(r,'PC = $',hex(pc,4));
  writeln(r,'DPC= $',hex(dpc,4));
  writeln;
  if paramcount=1 then begin
    writeln(#13,#10,'Weiter mit Return');
    readln;
  end;

  li := 1;

  repeat
     buf.name := '            ';
     blockread(f,buf,elsiz);
     if buf.typ<128 then begin
      if buf.name[0]>#127 then begin
        buf.name[0] := chr($7F and byte(buf.name[0]));
        write('SEALED ');
      end;
      while buf.name[0]<#12 do buf.name := buf.name+' ';
      write(r,TYPSTR(buf.typ),' ',buf.name);
      case buf.typ of
        2,6,12,13,14,18   : writeln(' CS:',hex(buf.par0,4),' @ $',hex(buf.qfahi,4),hex(buf.qfa,4));
        10,11,15,16,19    : writeln(' Val:',buf.par0,' @ $',hex(buf.qfahi,4),hex(buf.qfa,4));
        17                : writeln(' Len: ',hex(hi(buf.qfalen),2),' @ $',hex(buf.qfahi,4),hex(buf.qfa,4));
        else                writeln(' DS:',hex(buf.par0,4),' @ $',hex(buf.qfahi,4),hex(buf.qfa,4));
      end;
     end;
     inc(li);
     if ((li mod 22)=0) and (paramcount=1) then begin
       writeln(#13,#10,'Weiter mit Return'); ch := readkey;
     end;
  until eof(f);
  close(f);
  close(output);
end.
