{$M 65520,100,655350}
{$N+} {$V-}
{$R-} {$S-} {$I-} {$A+}

program Naxos;
{
        ************************************************************
        *         NAXOS Version 2.14  16-Bit 80x86 Compiler        *
        *                                                          *
        * (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
        *                                                          *
        *                      Rev. 14b 15.04.94                   *
        *                                                          *
        *      NAXOS 2.xx is based on its predecessor programs     *
        *             FCC, MCC, NAXOS 1.xx, NAXOS 2.0x             *
        *   (C) 1989,90,91,92 by K.Peper, A.Zissis, I.Tossounidis  *
        ************************************************************
}

uses crt,dos;

label okmcc ;

const
  VERSION   = '2.14b';{ Versionsnummer  }
  SCRATCH   = $30;   { Gre des resevierten Bereichs im Datensegment }
  INBUFSIZE = $8000; { inputbuffer gre }
  MAXSTACK  = 100;   { Stack-Ebenen    }
  EMPTY     = '';    { leerer String   }
  SPACE     = #32;   { Leerzeichen     }
  NUL       = #0;    { Null-Zeichen    }
  BEL       = #7;    { akust. Signal   }
  CR        = #13;   { Wagenrcklauf   }
  APOST     = #39;   { Hochkomma       }

  wordprefix    = '*';
  doubleprefix  = '&';
  floatprefix   = '%';
  ovrprefix     = '~';
  recdelim      = '_';

  commentchr    = '';

{  Typ-Bezeichner im Wrterbuch        }

  _VAR      = 1;     { Datenvariable in DS }
  _CSVAR    = 2;     { Datenvariable in CS }
  _STRING   = 5;     { String in DS        }
  _CSSTRING = 6;     { String in CS        }
  _OBJECT   = 7;     { Object in DS        }
  _DCONST   = 15;    { Double-Konstante 32 Bit }
  _FCONST   = 16;    { Real-Konst       64 Bit }
  _CONST    = 10;    { Word-Konstante   16 Bit }
  _ACONST   = 11;    { Adresskonstante  16 Bit }
  _BCONST   = 19;    { Byte-Konstante    8 Bit }
  _KOLON    = 12;    { Kolon-Def.      }
  _PROC     = 13;    { Prozedur        }
  _VECTOR   = 14;    { Vektor          }
  _MACRO    = 17;    { Macro           }
  _LABEL    = 18;    { Label           }

  _IF       = 1;     { IF-Flag         }
  _BEGIN    = 2;     { BEGIN-Flag      }
  _WHILE    = 3;     { WHILE-Flag      }
  _DO       = 4;     { DO-Flag         }
  _CASE     = 5;     { CASE-Flag       }
  _FOR      = 5;     { FOR-Flag        }
  _UNTIL    = 6;     { UNTIL-FLAG      }


  MAXZEILE  = 127;   { max. Zeilenlnge}
  MAXPROG   = $FFFE; { Programmgre   }
  MAXDATA   = $FFFE;
  MAXIFB    = $FFFFFFFF; { max Input File Gre =  4 GB ! }
  MAXNAME   = 12;    { Namensgre     }
  MAXLOOP   = $14;   { Adresse der LOOP-Count Variable }
  MAXPTRTO  = $100;  { maximale Anzahl von PointerTo Deklarationen }
type
  Memory       = array[0..$FFFE] of byte; { 64 KByte }
  PMemory      = ^Memory;
  PSYMTAB      = ^SYMTAB;
  SYMTAB       = record
		  NAME : string[12];
		  TYP  : byte;
		  QFA  : word;
		  PAR0,
		  PAR1,
		  PAR2,
		  PAR3 : word;
		  QFAlen:word;
                  QFAHI :word;
		  rlink,
		  llink: PSYMTAB;
		 end;
  infilebuf    = array[0..inbufsize] of char;
  WortTyp      = string[16];
  ZeilenTyp    = string[MAXZEILE];
  HexStr       = string[5];

  StackEintrag = record
		   Wert: integer;
		   Typ : byte;
		   Size: byte;
		 end;

  StackTyp     = array[0..MAXSTACK] of StackEintrag;



var
  actualch : char;  { last read char from input file}
  lnr      : array[0..5000] of record
				 line  :word;
				 adr   :word;
			       end;
  Heapsize,
  mapcs,mapds,mapss,maphs  : word;
  crtreg   : word absolute $0040:$0063;
  dta      : pointer;
  result   : record
	     case boolean of
	     true : ( errorpos:word;
		      errorwort:string[16] );
	     false: ( main,data,stack,heap,zeilen,code : word );
	     end;
  r0,s0,rteadr  : word;
  xfsize : longint; { Inputfilegre }
  ef,optf : text;        { LOG.FILE im Shellmodus }
  QFAs : longint;      { QuellFileAdresse }
  outfile: file;    { compilierter Code }
  Zeile,
  LZ: ZeilenTyp;    { Forth-Textzeile   }
  lasttyp,
  wtyp:byte;        { Worttyp    }
  Wort,             { Forth-Wort }
  VocName,          { Vocabulary }
  Merker,OPTMERKER,
  Merker2: WortTyp; { Merker     }

  f : text;
  ifb    : infilebuf;  { Input File Buffer }
  ifbp,balkpix,
  ifbmax : longint;
  name        : namestr;
  ext         : extstr;
  pfad,syspfad : dirstr;
  dxname      : string;
  DateiName : string[MAXZEILE]; { Zugriffspfad }
  dmerker   : PSYMTAB;
  lpc : integer;
  patchlist : array[0..maxptrto] of word ;
  pc,dpc,
  ppc,             { Programmzhler     }
  adrmerker,       { Merkt Adresse      }
  pcmerker : word; { Merkt pc           }
  qfa:longint;     { Quellfileptradr    }
  par0,            { parameter 0        }
  par1,            { parameter 1 = LEN  }
  par2,            { parameter 2        }
  par3,
  qfalen,
  qfahi,
  felder,          { Feldaccumulator    }
  macro,           { Macrogrenze aktuel }
  macrolim,        { Vorgabe Grenze     }
  sp,              { Stackpointer       }
  Nummer,          { Zeilennummer       }
  Anfang,          { Anfang Dictionary  }
  Ende,            { Ende Dictionary    }
  VocAnfang,       { Start Vocabulary   }
  ofcnt,           { OF-Zhler          }
  i,               { Zhlvariable       }
  mn,              { Main-Adresse       }
  reclen:word;     { Datenlnge         }
  OFIELDPTR,       { Zeiger auf Object-Field }
  FZeiger,         { Zeiger auf gefundenes Wort }
  LZeiger,         { Zeiger auf aktueller lokales Def.wort }
  Zeiger:PSYMTAB;  { Zeiger auf aktuelles Definitionswort }
  M,DSEG: PMemory; { Speicherbereich    }
  S: StackTyp;     { Kontroll-Stack     }
  ROOT,LROOT,
  D,               { Wrterbuch         }
  L: PSYMTAB    ;  { Lokales Wrterbuch }

  regfix,          { RegisterPrfix     }
  structura,       { which structure?   }
  concod,          { conditioncode      }
  caselit:Integer; { Literal vor OF     }

  sys,             { System-Befehl      }
  main,            { Hauptprogramm      }
  scrio,           { screen i/o flag    }
  Optimize,        { Multipass-flag     }
  opterr,          { Multipass-errorflag}
  CaseFlag,        { fr Case-Anweisung }
  CLitflag,        { CaseLiteralflag    }
  Flagstack,       { Bedingungsstack    }
  found,           { fr Wortsuche      }
  NoCodeFlag,      { speichern ein/aus  }
  Includeflag,     { Nur ein Incl.file  }
  ShortFlag,       { Short-Jump ein/aus }
  comment,         { Kommentar          }
  RTEFlag,         { Find Runtime Error Flag }
  recfield,        { Name is recordfield }
  MapFlag: boolean;{ Zur Erzeugung von MAP-Files } { neu 2.1.92 }
  lastobj,
  lastrefobj,
  overloadedp0,
  objcount,        { Object signature counter }
  actobjsig,       { actual Object signature }
  linelen : word;  { Zeilenlnge }
  sif     : file;  { Globales Includefile }
  fparam,          { Function parameter flag : true zw. [ und ] }
  local,           { Local Flag: True zwischen FUNCTION und ; }
  islocal,
  inobj,           { in Object definition }
  isobj,           { preceding word is object identifier }
  overload,
  indef   :boolean;{ In Definition Flag; True zwischen : oder PROC und ; }
  ptrflag,ptrdone : boolean ;



function hex(n, l: longint): HexStr;

{ n in l-stellige Hexzahl wandeln }

var
  i, z: integer;
  s: HexStr;
begin
  s := EMPTY;
  for i := 1 to l do
    begin
      z := n and 15; { Ziffer bilden }
      if z > 9 then z := z + 7;
      s := char(z + 48) + s;
      n := n shr 4; { Division durch 16 }
    end;
  hex := s;
end;


procedure error(nr: byte);
var p1,p2 : psymtab ;
{ Fehlerbehandlung }

begin
if optimize then
begin
  if (nr=4) or (nr=36) then writeln(optf,merker);
  par0 := 0 ;
  par1 := 0 ;
  par2 := 0 ;
  par3 := 0 ;
  wtyp := 1 ;
  opterr := true ;
end
else
begin
  writeln(#13,#10,#10,#10,#10,#10,'                   ERROR: ',nr,' @ ',ifbp,' -->',merker,'<--');
  result.errorpos := word(ifbp);
  result.errorwort:= merker;
  move(result,dta^,19);
  dispose(M);
  dispose(DSEG);
  close(f);
  halt(100+nr);
end;
end;



procedure Hilfe;

begin
  writeln;
  writeln('NAXOS Compiler Version ',Version);
  writeln('(C) 1991,92,93 by Peper,Zissis,Tossounidis');
  writeln;
  writeln('usage: NX sourcename  -m -n -f$xxxx -o -x ');
  writeln;
  writeln('        (Parameters are optional)');
  writeln;
  writeln('    -m      generate MAP-file');
  writeln('    -n      generate NO code');
  writeln('    -f adr  Find source corresponding to address');
  writeln('    -o      Multipass mode');
  writeln('    -x      no screen i/o');
  writeln;
  writeln;
  halt(0);
end;



procedure init;

{ Compiler initialisieren }

var
  p, i: byte;
  option: string[2];
  ch: char;
  okl,okr : boolean;
  x,
  p1,p2 : PSymTab;
  ff :file;
begin
  LZ := EMPTY;
  { Dateinamen holen }

  DateiName := ParamStr(1);
  if (DateiName='?') or (paramcount=0) then Hilfe;
  fsplit (dateiname, pfad, name, ext);
  if ext='' then ext := '.FTH';
  { Options-Voreinstellungen }
  SysPfad := getenv('NAXOS');
  if syspfad<>'' then syspfad := syspfad+'\';
  NoCodeFlag := false;
  inobj := false;
  indef := false;
  local := false;
  fparam := false;
  comment := false;
  ShortFlag := false;  { ** changed in V2.14b now default is (LONG) ** }
  MapFlag := false;    { ** neu 2.1.92 ** }
  RTEFlag := false;
  main := false;
  scrio := true;
  optimize := false;
  merker := '';
  Nummer := 0;
  { Optionen auswerten }

  if ParamCount > 1 then
    for i := 2 to ParamCount do
      begin
	option := ParamStr(i);
	if option[1] in ['/', '-'] then
	  begin
	    ch := UpCase(option[2]);
	    case ch of
              'O': optimize := true;
	      'N': NoCodeFlag := true;
	      'M': MapFlag := true;
              'X': scrio := false;
	      'F': begin
		   RTEFlag := true;
		   Nocodeflag := true;
		   Mapflag := false;
		   val(paramstr(i+1),rteadr,nummer);
		   if nummer<>0 then error(7);
		   i := paramcount;
		   end;
	      else error(18);
	    end; { case }
	  end { if }
	else if option[1] <> '>' then error(18);
      end; { for }

  { Quelltextdatei ffnen }

    assign(f,Pfad+name+ext);
    assign(ff,Pfad+name+ext);
    {$I-} reset(ff,1); {$I+}
    if ioresult<>0 then begin
           ifbp := 0;
           merker := Pfad+name+ext;
           error(19);
    end;
    xfsize := filesize(ff);
    close(ff);
    textrec(f).bufptr := @ifb;
    textrec(f).bufsize := sizeof(ifb);
    reset(f);
    ifbmax := xfsize+1;
    balkpix := xfsize div 36;
    if balkpix=0 then inc(balkpix);
    ifbp := 0;
  if optimize then begin
    assign(optf,Pfad+name+'.OPT');
    rewrite(optf);
  end;
  { verschiedene Einstellungen }
  Zeile := EMPTY;
  Merker := EMPTY;
  Wort := SPACE;
  includeflag := true;
  clitflag := false;
  Flagstack := false;
  ptrflag := false;
  ptrdone := false;
  opterr := false;
  r0    := $FFF;
  sp := 0;
  Nummer := 1;
  objcount := 0;
  actobjsig := $FFFF;
  lnr[0].line := 0;
  pc := $100;
  dpc := scratch;
  Heapsize := 0;
  macrolim := 9;
  regfix := 0;
  macro := MACROLIM;
  VocName := EMPTY;
  ofcnt := 0;
  patchlist[0] := 0;
  caseflag := false;
  VocAnfang := 0;
  linelen := 0;
  QFAs := 0;
  FillChar(M^, SizeOf(M^), $90);
  FillChar(DSEG^, SizeOf(DSEG^), NUL);
  if scrio then begin
     textattr := $70;
     gotoxy(35,11);
     write(name ,ext);
     gotoxy(55,10);write(versioN);
     gotoxy(23,14);
     write('');
     gotoxy(23,15);
     write('0%               50%            100%');
     gotoxy(22,16);
     textattr := $1F;
     write('  Stop:   Control-Break               ');
     textattr := $70;
  end;
  new(ROOT);
  root^.rlink := nil;
  root^.llink := nil;
  root^.name  := 'FFFFFFFFFFFF';
  root^.typ   := 254;
  root^.par0  := 0;
  root^.par1  := 0;
  root^.par2  := 0;
  root^.par3  := 0;
  assign(sif,SysPfad+'NAXOS.LBR');
  {$I-} reset(sif,sizeof(root^)-12); {$I+}
  if IOresult <> 0 then error(55);
  repeat
    new(X);
    blockread(sif,x^,1);
    x^.qfalen := 0;
    x^.rlink := nil;
    x^.llink := nil;
    p1 := root;
    repeat
      p2 := p1;
      if x^.name>p1^.name then p1 := p1^.rlink
			  else p1 := p1^.llink;
    until p1 = nil;
    if x^.name>p2^.name then p2^.rlink := x
			else p2^.llink := x;
  until eof(sif);
  close(sif);
end;


function suche(name:string):boolean; forward;



function HoleZeichen: char;

{ Ein einzelnes Zeichen aus Quelltext holen }

begin
  if ifbp=ifbmax then actualch := ' '
                 else read(f,actualch);
  holezeichen := actualch;
  inc(ifbp);
end;



function HW1: WortTyp;
const balken : string = '';
{ Ein Wort aus Quelltext holen }

var
  p: byte;
  c: char;
  w: string[255];
  mist : boolean;
  tptr : longint ;

begin
  recfield := false;
  repeat
   if ifbp>=ifbmax then
	begin
	  HW1 := EMPTY;
	  exit;
	end
   else begin
     while (actualch in [#$0D,#$0A,#$20,#$09,recdelim]) do
                         begin
			   case actualch of
                           #$0D: begin
			           inc(nummer);
			           if pc<>lnr[lnr[0].line].adr then begin
			             inc(lnr[0].line);
			             lnr[lnr[0].line].line := nummer;
			             lnr[lnr[0].line].adr  := pc;
			           end;
                                   recfield:= false;
			         end;
                           recdelim: recfield := true;
                           else recfield := false;
                           end;
                           c := holezeichen;
			 end;
     tptr := ifbp-2;
     w := c;
     if actualch=commentchr then while (actualch<>#13) do c := holezeichen;
     while not(actualch in [#$0D,#$0A,#$20,#$09,recdelim])and(ifbp<ifbmax) do begin
        w := w+holezeichen ;
     end;
     if byte(w[0])<=12 then
     dec(w[0]) else w[0] := char(12);
    end;
  until w<>'';
  if w[1]<>APOST then for p := 1 to length(w) do w[p] := UpCase(w[p]);
  if (w='(') then wtyp := 178 else
  if (w=')') then wtyp := 179 else
  if recfield then begin
   if length(w)>maxname-2 then w[0] := char(maxname-2);
   w := w+char(lo(lastobj))+char(hi(lastobj));
  end;
  Merker := w;
  HW1 := w;
  if not comment then mist := suche (W);
  case wtyp of
   _object: begin lastobj := par2; lastrefobj := par2; end;
   210: ;
   212: ;
   else lastobj := $FFFF;
  end;
  if (wtyp in [156,159,161,162,163,164,165,166,181,193,200,209]) then begin
     qfas := tptr;
     if scrio then begin
       balken[0]:=char(ifbp div balkpix);
       gotoxy(23,13);
       write(balken);
     end;
  end;
end;



function HoleWort: WortTyp;
var wx:worttyp;
begin
   wx := HW1;
   while (wtyp=178) do begin
      comment := true;
      repeat
	wx := HW1;
      until (wtyp=179);
      comment := false;
      wx := HW1;
   end;
   Holewort :=wx;
   if rteflag and (pc >= rteadr-1) then error(57);
end;




procedure ob(b:byte);

{ Ein Byte im Code ablegen }
begin
  M^[pc] := b;
  inc(pc);
  if pc > MAXPROG then error(3);
end;


procedure ow(w: word);
{ Ein Wort im Code ablegen }
begin
  move(w, M^[pc], 2);
  inc(pc, 2);
  if pc > MAXPROG then error(3);
end;


procedure ot(adr: word; w: integer);
{ Ein Wort an spezifizierter CodeAdresse ablegen }
begin
  move(w, M^[adr], 2);
end;


procedure otb(adr:word; b:Byte);
{ Ein Byte an spezifizierter CodeAdresse ablegen }
begin
  move(b, M^[adr], 1);
end;


procedure os(s: ZeilenTyp);
{ String im Code ablegen }
begin
  for i := 0 to length(s) do ob(ord(s[i]));
end;

procedure obd(b: byte);
{ Ein Byte im Datenseg ablegen }
begin
  DSEG^[dpc] := b;
  inc(dpc);
  if dpc > MAXDATA then error(3);
end;

procedure owd(w: word);
{ Ein Wort im Datenseg ablegen }
begin
  move(w, DSEG^[dpc], 2);
  inc(dpc, 2);
  if dpc > MAXDATA then error(3);
end;

procedure otd(adr: word; w: integer);
{ Ein Wort an spezifizierter DatenAdresse ablegen }
begin
  move(w, DSEG^[adr], 2);
end;

procedure otbd(adr:word; b:Byte);
{ Ein Byte an spezifizierter DatenAdresse ablegen }
begin
  move(b, DSEG^[adr], 1);
end;

procedure osd(s: ZeilenTyp);
{ String im Datenseg ablegen }
begin
  for i := 0 to length(s) do obd(ord(s[i]));
end;


procedure push(p: word; Flag, Short: byte);

{ Adresse und Flag auf Stack ablegen }

begin
  with S[sp] do
    begin
      Wert := p;
      Typ := Flag;
      Size := Short;
    end;
  inc(sp);
  if sp > MaxStack then error(8);
end;



function pop(Flag: byte; var Short: byte): integer;

{ Adresse vom Stack holen, Flag prfen }

begin
  if sp = 0 then error(9);
  dec(sp);
  with S[sp] do
    begin
      Short := Size;
      if Typ = Flag then pop := Wert
      else
	case Flag of
	  _IF   : error(10);
	  _BEGIN: error(13);
	  _WHILE: error(14);
	  _DO   : error(15);
	  _FOR  : error(48);
	  else error(0);
	end; { case }
	end; { with }

end;



function near(Quelle, Ziel: word): integer;

{ Near-Sprungdistanz berechnen }

begin
  near := integer(Ziel-Quelle) - 2;
end;



function short(Quelle, Ziel: word): byte;

{ Short-Sprungdistanz berechnen }

var disp: integer;

begin
  disp := Ziel - Quelle - 1;
  if abs(disp) > 127 then error(11);
  short := lo(disp);
end;


function Suche(Name: string): boolean;

{ Namen in Dictionary suchen }
label ok,xx;
var
  va,er : integer;
  vd    : longint;
  vf    : double ;
  p1,p2 : PSYMTAB;
  n: WortTyp;
  su:boolean;

begin
  n := EMPTY;
  Name := copy(Name, 1, MAXNAME);
  su := false;
  islocal := false;
  if local then begin
  p1 := Lroot;
  repeat
    p2 := p1;
    p1 := p1^.rlink;
  until (name=p2^.name) or (p1=nil);
  if name=p2^.name then begin
                     su := true;
                     islocal := true;
		     FZeiger := p2;
		   end
		   else su := false;
  if su then goto XX;
  end;


    p1 := root;
    repeat
       p2 := p1;
       if name>p1^.name then p1 := p1^.rlink
	                else p1 := p1^.llink;
    until (name=p2^.name) or (p1=nil);
    if name=p2^.name then begin
	  	     su := true;
		     FZeiger := p2;
		   end
		   else su := false;
  XX:
  if su then
    begin
    qfa  := p2^.QFA+p2^.QFAHI shl 16;
    lasttyp := wtyp;
    wtyp := p2^.TYP;
    if wtyp<128 then begin
      par0 := p2^.PAR0;
      par1 := p2^.PAR1;
      par2 := p2^.PAR2;
      par3 := p2^.PAR3;
      qfalen := p2^.QFALEN;
    end;
    end
  else begin
    lasttyp := wtyp;
    wtyp := 255;
    if (name[1]='''') and (name[0]=#3) and (name[3]='''') then begin
      er := 0;
      vd := ord(name[2]);
      wtyp := _BCONST;
      su := true;
    end else val(name,vd,er);
    if er=0 then begin
      if ((vd<$100)and(vd>=0)) or
         ( (vd<0) and (abs(vd)<=128) )
              then wtyp := _BCONST
	      else wtyp := _CONST;
      move(vd,par0,2);
      su := true;
    end;
    if (er<>0) and (name[1]=doubleprefix) then begin
       val(copy(name,2,length(name)-1),vd,er);
       wtyp := _DCONST;
       if er= 0 then begin
	 move(vd,par0,4); { Assumes that declaration is par0,par1 : word }
	 su := true;
       end
    end else begin
      if (er<>0) and (name[1]=floatprefix) then begin
	 val(copy(name,2,length(name)-1),vf,er);
	 if er=0 then begin
	  wtyp := _FCONST;
	  move(vf,par0,8);
	  su := true;
	 end;
	end else begin
	if name[1]=wordprefix then begin
	 val(copy(name,2,length(name)-1),va,er);
	 if er=0 then begin
	  wtyp := _CONST;
	  move(va,par0,2);
	  su := true;
	 end else su := false;
	end;
	end;
      end;
    end;
ok: if not(su) then begin
      lasttyp := wtyp;
      wtyp := 255;  { unbekannter Bezeichner }
    end;
    found := su;
    suche := su;
end;

procedure TueName;

{ Name holen und berprfen, Header bauen }
var
  Name,wxx   : WortTyp;
  newname    : string;
  xqfas      : longint;
  xxzeiger   : psymtab;
  p3,p4,buf,
  pb,swapptr  : PSymTab;
  mist:boolean;

begin
  Name := HoleWort;
  if optimize then begin
      optmerker := '~'+merker;
      if optmerker[0]>#12 then optmerker[0]:=#12;
  end;
  if (inobj) and (not(local)) then begin
     if length(name)>maxname-2 then name[0] := char(maxname-2);
     name := name+char(lo(actobjsig))+char(hi(actobjsig));
     mist := suche(name);
  end;
  pb := Fzeiger;
  overload := false;
  overloadedp0 := $FFFF;
  xqfas := qfas;
  if name[0]>char(maxname) then name[0]:=char(maxname);
  if Name = EMPTY then error(2);
  if (found and not(local)) or (found and islocal) then
  begin
    if islocal then  error(40);
    new(buf);
    buf^:= FZEIGER^;
    overloadedp0 := FZeiger^.par0;
    wxx:=holewort;
    if wtyp=208 then begin
      newname := ovrprefix+buf^.name;
      if suche(newname) then swapptr := fzeiger
                        else swapptr := nil;
      if newname[0]>#12 then newname[0] := #12;
      overload := true;
      new(xxzeiger);
      xxzeiger^ := buf^;
      xxzeiger^.NAME := newname;
      xxzeiger^.rlink := nil;
      xxzeiger^.llink := nil;
    p3 := root;
    repeat
      p4 := p3;
      if xxzeiger^.name>p3^.name then p3 := p3^.rlink
  		    	       else p3 := p3^.llink;
    until p3 = nil;
    if xxzeiger^.name>p4^.name then p4^.rlink := xxzeiger
	  		     else p4^.llink := xxzeiger;
    end else error(40);
    if swapptr<>nil then begin
       buf^:=xxzeiger^;
       xxzeiger^.par0 := swapptr^.par0;
       xxzeiger^.par1 := swapptr^.par1;
       xxzeiger^.par2 := swapptr^.par2;
       xxzeiger^.par3 := swapptr^.par3;
       xxzeiger^.qfa  := swapptr^.qfa;
       xxzeiger^.qfahi := swapptr^.qfahi;
       xxzeiger^.qfalen := swapptr^.qfalen;
       swapptr^.par0  := buf^.par0;
       swapptr^.par1  := buf^.par1;
       swapptr^.par2  := buf^.par2;
       swapptr^.par3  := buf^.par3;
       swapptr^.qfa   := buf^.qfa;
       swapptr^.qfahi  := buf^.qfahi;
       swapptr^.qfalen  := buf^.qfalen;
    end;
    dispose(buf);
  end;
  if local then begin
    new(Lzeiger);
    L^.rlink := LZeiger;
    L := LZeiger;
    Lzeiger^.NAME := name;
    Lzeiger^.QFA  := word(QFAs);
    Lzeiger^.QFAHI := word(QFAs shr 16);
    Lzeiger^.QFAlen := 0;
    Lzeiger^.rlink := nil;
    Lzeiger^.llink := nil;
  end
  else begin
    if overload then begin
     zeiger := pb;
     zeiger^.par0 := 0;
     zeiger^.par1 := 0;
     zeiger^.par2 := 0;
     zeiger^.par3 := 0;
    end
    else begin
      new(zeiger);
      zeiger^.rlink := nil;
      zeiger^.llink := nil;
    end;
    zeiger^.NAME := name;
    zeiger^.QFA  := word(xQFAs);
    zeiger^.QFAHI := word(xQFAs shr 16);
    zeiger^.QFAlen := 0;
    main := Name = 'MAIN';
  end;
end;

procedure tuelink;
var p1,p2  : PSymTab;
begin
if not overload then begin
  if zeiger^.typ <> _MACRO then zeiger^.qfalen := ifbp-(zeiger^.qfa+(zeiger^.qfahi shl 16));
  p1 := root;
    repeat
      p2 := p1;
      if zeiger^.name>p1^.name then p1 := p1^.rlink
	  		       else p1 := p1^.llink;
    until p1 = nil;
    if zeiger^.name>p2^.name then p2^.rlink := zeiger
			     else p2^.llink := zeiger;
end;
overload := false;
end;


procedure TueCode;

{ Inline-Code auswerten }

var
  w: WortTyp;
  pcm,
  Fehler: integer;

begin
  repeat
    w := HoleWort;
    if w = EMPTY then error(7);
    if w <> ']' then
      begin
	case wtyp of
	255     : error(4);
	_ACONST : ow(par0);
	_CONST  : ow(par0);
	_BCONST : ob(par0);
	_DCONST : begin ow(par0); ow(par1); end;
        192     : ow(pc);
        205     :   begin
                       w := holewort;
                       if w=empty then error(7)
                                  else ow(par1);
                    end;
        206     :   begin
                       w := holewort;
                       if w=empty then error(7)
                                  else ow(par2);
                    end;
        207     :   begin
                       w := holewort;
                       if w=empty then error(7)
                                  else ow(par3);
                    end;
        169     : begin
                       w := holewort;
                       if not((wtyp in [_Bconst,_const])) then error(7)
                                  else ow(pc+par0);
                  end;


	else ow(par0);
	end; { case }
      end; { if }
  until w = ']';
end;


procedure TueSeal;

{ Name verstecken }

var
  Name: WortTyp;

begin
  Name := HoleWort;
  if Name = EMPTY then error(2);
  if found then
    begin
      FZeiger^.name := FZeiger^.name+#0;  { #0 an Name anhngen }
    end
  else error(4);
end;


procedure TueLiteral(n:integer);
{ Literalhandler mit Prfix }
begin
  if clitflag then caselit := n
  else
  case regfix of
  1:  begin { AREG }
      ob($B8);ow(n);       { mov ax,n }
      regfix := 0;
      end;
  2:  begin { BREG }
      ob($BB);ow(n);       { mov bx,n }
      regfix := 0;
      end;
  3:  begin { DREG }
      ob($BF); ow(n);      { mov di,n }
      regfix := 0;
      end;
  4:  begin { EREG }
      ob($BA);ow(n);       { mov dx,n }
      ow($C28E);           { mov es,dx }
      regfix := 0;
      end;
  5: begin { ADR }
      ob($BE); ow(n);      { mov si,n }
      regfix := 0;
      end;
  end; { case }
end;

procedure TueDLiteral(n0,n1:word);
{ Literalhandler mit Prfix }
begin
  case regfix of
  1:  begin { AX , BX }
      ob($B8);ow(n0);       { mov ax,n0 }
      ob($BB);ow(n1);       { mov bx,n1 }
      regfix := 0;
      end;
  3:  begin { ES , DI }
      ob($BF);ow(n1);       { mov di,n1 }
      ow($C78E);            { mov es,di }
      ob($BF);ow(n0);       { mov di,n0 }
      regfix := 0;
      end;
  else error(45);
  end; { case }
end;

procedure TueFLiteral(n0,n1,n2,n3:word);
var merk :word;
begin
      merk := dpc;
      owd(n0);owd(n1);owd(n2);owd(n3);owd(0);  { DATENFELD }
      ob($9B);ob($DD);ob($06);ow(merk);        { FLD DATENFELD }
end;


procedure TestSemi;
{ Semikolonabschluss }
var w: worttyp;
begin
W := HoleWort;
if wtyp <> 128 then error(41); { Semikolon erwartet }
end;


procedure TueStringLiteral;

var z: char;
begin
 if odd(dpc) then inc(dpc);
 ob($BE);ow(dpc);   { mov si,adr }
      z := holezeichen;
      while (z <> '"') do
	begin
	  obd(ord(z)); z := HoleZeichen;
	end;
 obd(0);            { Nullbyte }
 z := Holezeichen;
end;


procedure TueCondition;
{ select conditioncode }
label okc;
var nm: Worttyp;

begin
  nm := Holewort;
  if nm = EMPTY then error(2);
     if nm = 'C'   then begin concod := $7273; goto okc; end;
     if nm = 'NC'  then begin concod := $7372; goto okc; end;
     if nm = 'E'   then begin concod := $7475; goto okc; end;
     if nm = 'NE'  then begin concod := $7574; goto okc; end;
     if nm = 'Z'   then begin concod := $7475; goto okc; end;
     if nm = 'NZ'  then begin concod := $7574; goto okc; end;
     if nm = 'O'   then begin concod := $7071; goto okc; end;
     if nm = 'NO'  then begin concod := $7170; goto okc; end;
     if nm = 'S'   then begin concod := $7879; goto okc; end;
     if nm = 'NS'  then begin concod := $7978; goto okc; end;
     if nm = 'PE'  then begin concod := $7a7b; goto okc; end;
     if nm = 'PO'  then begin concod := $7b7a; goto okc; end;
     if nm = 'A'   then begin concod := $7776; goto okc; end;
     if nm = 'NA'  then begin concod := $7677; goto okc; end;
     if nm = 'B'   then begin concod := $7273; goto okc; end;
     if nm = 'NB'  then begin concod := $7372; goto okc; end;
     if nm = 'G'   then begin concod := $7e7f; goto okc; end;
     if nm = 'NG'  then begin concod := $7f7e; goto okc; end;
     if nm = 'L'   then begin concod := $7c7d; goto okc; end;
     if nm = 'NL'  then begin concod := $7d7c; goto okc; end;
     if nm = 'OFF'  then
		   begin
		    concod := $7475;
		    ob($8A); ob($14);          { mov dl,[si] }
		    ob($84); ob($D2);          { test dl,dl  }
		    goto okc;
		   end;
     if nm = 'ON' then
		   begin
		    concod := $7574;
		    ob($8A); ob($14);          { mov dl,[si] }
		    ob($84); ob($D2);          { test dl,dl  }
		   end
		   else error(99);
okc:
end;

procedure Dojumpforw;

BEGIN
     if ShortFlag then
	begin
	 ob(lo(concod));           { jmpncond disp  }
	 push(pc, structura, 1);
	 ob(0);
	end
     else
       begin
	ob(hi(concod)); ob(03);    { jmpcond  +3  }
	ob($e9);                   { jmp  disp  }
	push(pc, structura, 2);
	ow(0);
       end;
end;

procedure Dojumpback;
var adr: word;
var w: WortTyp;
var len: byte;
var lenx: integer;
BEGIN
    adr := pop(_BEGIN, len);
    lenx := near(pc, adr);
     if abs(lenx) < 128 then
	 begin
	   ob(lo(concod)); ob(lenx);   { jmp ncond  disp }
	 end
     else
	 begin
	   ob(hi(concod)); ob(03);     { jmp cond   +3   }
	   ob($e9); ow(lenx-3);        { jmp  disp }
	 end;
end;

procedure memsizes;
var w : worttyp;
begin
   w := holewort;
   if not(wtyp in[_BCONST, _CONST]) then error(7);
   r0 := par0;
   if r0<1 then r0:=1;
   r0 := r0 and $7FFF;
   if r0>$FFF then r0 := $FFF;
   w := holewort;
   if not(wtyp in[_BCONST, _CONST]) then error(7);
   heapsize := par0;
   w := holewort;
   if wtyp <> 179 then error(1);
end;


procedure TueSystem(w: WortTyp);

{ compile SYSTEM-Words in macro, colon or proc }


var
  nn, Fehlern: integer;
  z: char;
  len, dis: byte;
  disp, Fehler,adr, adr1, adr2: word;
  zgr1,zgr2 : PSYMTAB;
  gefunden: boolean;
  lenx : integer;
begin
  sys := true;
  
   if wtyp >127 then
  case wtyp of

  { ; }
  128: begin
       ob($C3);            { ret }
       shortflag := true;
       if sp > 0 then
	 case S[sp-1].typ of
	   _IF   : error(20);
	   _BEGIN: error(21);
	   _WHILE: error(22);
	   _DO   : error(23);
	   _FOR  : error(49);
	   else error(0);
	 end;
       end;

  { [  }
  129: TueCode;

  { IF }
  132: begin
	 structura:=_if;
	 concod:=$7273;
	 Dojumpforw;
       end;

  { IF_ }
  133: begin
	structura:=_if;
	Tuecondition;
	Dojumpforw;
       end;

  { ENDIF, THEN }
  134: begin
	 adr := pop(_IF, len);
	 if len = 1 then
	   M^[adr] := short(adr, pc)
	 else
	   ot(adr, near(adr, pc));
       end;

  { ELSE }
  135: begin
       if clitflag then
	   clitflag := false
       else begin
	  adr := pop(_IF, len);
	  if len = 1 then
	  begin
	     M^[adr] := short(adr, pc + 2);
	     ob($EB);  { jmp disp }
	     push(pc, _IF, 1);
	     ob(0);
	  end
	  else
	  begin
	     ot(adr, near(adr, pc + 3));
	     ob($E9);  { jmp  disp }
	     push(pc, _IF, 2);
	     ow(0);
	  end;
       end;
    end;

  { CASE }
  136: begin
	if caseflag then error(28);
	caseflag := true;
	clitflag := true;
       end;

  { OF }
  137: begin
	 clitflag := false;
	 inc(ofcnt);
	 structura:=_case;
	 concod:=$7475;
	 ob($3D); ow(caselit);   { cmp ax,n    }
	 Dojumpforw;
       end;


  { >OF }
  138: begin
	 clitflag := false;
	 inc(ofcnt);
	 structura:=_case;
	 concod:=$7f7e;
	 ob($3D); ow(caselit);   { cmp ax,n    }
	 Dojumpforw;
       end;


  { <OF }
  139: begin
	 clitflag := false;
	 inc(ofcnt);
	 structura:=_case;
	 concod:=$7c7d;
	 ob($3D); ow(caselit);   { cmp ax,n    }
	 Dojumpforw;
       end;



  { ENDOF, ;; }
  140: begin
	 adr := pop(_CASE, len);
	 if len = 1 then
	 begin
	   M^[adr] := short(adr, pc + 2);
	   ob($EB);  { jmp disp }
	   push(pc, _CASE, 1);
	   ob(0);
	 end
	 else
	 begin
	   ot(adr, near(adr, pc + 3));
	   ob($E9);  { jmp  disp }
	   push(pc, _CASE, 2);
	   ow(0);
	 end;
	 clitflag := true;
       end;

  { ENDCASE }
  141: begin
      for i := 1 to ofcnt do
	begin
	  adr := pop(_CASE, len);
	  if len = 1 then
	    M^[adr] := short(adr, pc)
	  else
	    ot(adr, near(adr, pc));
	end; { for }
      ofcnt := 0;
      caseflag := false;
      clitflag := false;
    end;

  { +MACRO }
  142: macro := 64;

  { -MACRO }
  143: macro := macrolim;

  { FIND }
  144: begin
	 w := HoleWort;
	 if not found then error(4);
	 TueLiteral(par0);
       end;

  { BEGIN }
  145: begin
	 push(pc, _BEGIN, 0);
       end;

  { UNTIL }
  146: begin
	 structura := _until;
	 concod:=$7273;
	 Dojumpback;
       end;

   { UNTIL_ }
  189: begin
       structura := _until;
       Tuecondition;
       Dojumpback;
       end;

  { MEMSIZES }
  190: memsizes ;

  { WHILE }
  147: begin
	 structura := _while;
	 concod:=$7273;
	 Dojumpforw;
       end;

  { WHILE_ }
  188: begin
	 structura:=_while;
	 Tuecondition;
	 Dojumpforw;
       end;

  { REPEAT }
  148: begin
	 adr1 := pop(_WHILE, len);
	 adr := pop(_BEGIN, dis);
	 lenx := near(pc, adr);
	 if shortflag then
	 begin
	   ob($EB); ob(lenx);   { jmp  disp }
	 end
	 else
	 begin
	   ob($E9); ow(lenx-1);   { jmp  disp }
	 end; { if }
	 if len = 1 then
	   M^[adr1] := short(adr1, pc)
	 else
	   ot(adr1, near(adr1, pc));
       end;

  { AGAIN }
  149: begin
	 adr := pop(_BEGIN, dis);
	 lenx := near(pc, adr);
	 if abs(lenx) < 128 then
	 begin
	   ob($EB); ob(lenx);   { jmp  disp }
	 end
	 else
	 begin
	   ob($E9); ow(lenx-1);   { jmp  disp }
	 end; { if }
       end;

  { FOR }
  196: begin
	 ob($51);         { push cx }
	 ob($89);ob($D9); { mov cx,bx }
	 push(pc,_FOR,0);
       end;


  { NEXT }
  197: begin
       adr := pop(_FOR,len);
       nn := near(pc,adr);
       if abs(nn) < 128 then
	   begin
	     ob($E2); ob(nn);   { loop adr   }
	   end
	 else
	 begin
	   ob($49);             { dec cx }
	   ob($74); ob(03);     { jz +03    }
	   ob($e9); ow(nn-4);   { jmp adr   }
	 end; { if }
	 ob($59);               { pop cx    }
       end;
 
  { FOR_ }
  198: begin
	 push(pc,_FOR,0);
       end;

  { NEXT_ }
  199: begin
       adr := pop(_FOR,len);
       nn := near(pc,adr);
       if abs(nn) < 128 then
	   begin
	     ob($E2); ob(nn);   { loop adr   }
	   end
	 else
	 begin
	   ob($49);             { dec cx }
	   ob($74); ob(03);     { jz +03    }
	   ob($e9); ow(nn-4);   { jmp adr   }
	 end; { if }
       end;

   { NEXT_Z }
  202: begin
       adr := pop(_FOR,len);
       nn := near(pc,adr);
       if abs(nn) < 128 then
	   begin
	     ob($E1); ob(nn);   { loopz adr   }
	   end
	 else
	 begin
	   ob($74); ob(06);     { jz +06 }
	   ob($49);             { dec cx }
	   ob($74); ob(03);     { jz +03    }
	   ob($e9); ow(nn-6);   { jmp adr   }
	 end; { if }
       end;

  { NEXT_NZ }
  203: begin
       adr := pop(_FOR,len);
       nn := near(pc,adr);
       if abs(nn) < 128 then
	   begin
	     ob($E0); ob(nn);   { loopnz adr   }
	   end
	 else
	 begin
	   ob($75); ob(06);     { jnz +06 }
	   ob($49);             { dec cx }
	   ob($74); ob(03);     { jz +03    }
	   ob($e9); ow(nn-6);   { jmp adr   }
	 end; { if }
       end;

  { DO }
  150: begin
	 ow($36FF);ow(maxloop);         { push MAXLOOP }
	 ob($51);                       { push cx    }
	 ob($A3); ow(MAXLOOP);          { mov  MAXLOOP,ax }
	 ob($89); ob($D9);              { mov  cx,bx }
	 push(pc, _DO, 0);
       end;

  { LOOP }
  151: begin
	 ob($41);                { inc cx    }
	 ob($3B);ob($0E);ow(MAXLOOP); { cmp cx,[MAXLOOP] }
	 adr := pop(_DO, len);
	 nn := near(pc, adr);
	 if abs(nn) < 128 then  
	   begin
	     ob($7E); ob(nn);   { jle adr   }
	   end
	 else
	 begin
	   ob($7f); ob(03);     { jg  +3    }
	   ob($e9); ow(nn-3);   { jmp adr   } 
	 end; { if }
	 ob($59);               { pop cx    }
	 ow($068F);ow(MAXLOOP); { pop MAXLOOP }
       end;

  { +LOOP }
  152: begin
	 ob($03); ob($C8);        { add cx,ax }
	 ob($3B);ob($0E);ow(MAXLOOP); { cmp cx,[MAXLOOP] }
	 adr := pop(_DO, len);
	 nn := near(pc, adr);
	 if abs(nn) < 128 then   
	 begin
	   ob($7E); ob(nn);       { jle adr   }
	 end
	 else
	 begin
	   ob($7f); ob(03);       { jg  +3    }
	   ob($e9); ow(nn-3);     { jmp adr   }  
	 end; { if }
	 ob($59);                 { pop cx    }
	 ow($068F);ow(MAXLOOP);   { pop MAXLOOP }
       end;


  { -LOOP }
  153: begin
	 ob($29); ob($C1);        { sub cx,ax }
	 ob($3B);ob($0E);ow(MAXLOOP); { cmp cx,[MAXLOOP] }
	 adr := pop(_DO, len);
	 nn := near(pc, adr);
	 if abs(nn) < 128 then  { ** gendert 3.6.89 ** }
	 begin
	    ob($7D); ob(nn);    { jge adr   }
	 end
	 else
	 begin
	   ob($7c); ob(03);     { jl  +3    }
	   ob($e9); ow(nn-3);   { jmp adr   } { KP 12.5.91 }
	 end; { if }
	 ob($59);                 { pop cx    }
	 ow($068F);ow(MAXLOOP);   { pop MAXLOOP }
       end;


  { /LOOP }
  154: begin
	 adr := pop(_DO, len);
	 ob($03); ob($C8);            { add  cx,ax }
	 ob($85); ob($C0);            { test ax,ax }
	 ob($79); ob($07);            { jns  disp  }
	 ob($3B);ob($0E);ow(MAXLOOP); { cmp cx,[MAXLOOP] }
	 ob($7c); ob($0a);            { jl   +10   }
	 ob($e9); ow(near(pc, adr));  { jmp  adr   }
	 ob($3B);ob($0E);ow(MAXLOOP); { cmp cx,[MAXLOOP] }
	 ob($7f); ob(03);             { jg   +3    }
	 ob($e9); ow(near(pc, adr));  { jmp  adr   }
	 ob($59);                     { pop  cx    }
	 ow($068F);ow(MAXLOOP);       { pop MAXLOOP }
       end;

  { " }
  155: TueStringLiteral;

  { RECLEN }
  157: begin
	 ob($B8); ow(reclen);
       end;

  { OFFSET }
  158: begin
	 w := HoleWort;
	 if w = EMPTY then error(7);
	 if not(wtyp in [_CONST,_BCONST])then error(7);
	 ob($81);ob($C6);ow(par0);  { add si,par0 }
       end;


  { LABEL }
  166 : begin
	 w := holewort;
	 if w=empty then error(2);
	 if wtyp <> _LABEL then error(56);
	 Fzeiger^.par0 := pc;
	end;

  { (short) }
  174 : ShortFlag := true;

  { (long) }
  175 : ShortFlag := false;

  { STACK }
  144 : begin
    w := HoleWort;
	 if w = EMPTY then error(7);
	 if not(wtyp in [_CONST,_BCONST]) then error(7);
	 par0 := 2*par0;
	 ob($83);ob($C5);ob(lo(par0));  { add bp,c }
	end;


  { INTERRUPT }
  201 : begin
	  ob($FA);                            { cli             }
	  ob($2E);ob($8C);ob($1E);ow($0122);  { mov cs:[122],ds }
	  ob($2E);ob($A3);ow($0110);          { mov cs:[110],ax }
	  ob($2E);ob($8C);ob($16);ow($0126);  { mov cs:[126],ss }
	  ob($2E);ob($89);ob($26);ow($0118);  { mov cs:[118],sp }
	  ob($2E);ob($8C);ob($06);ow($0124);  { mov cs:[124],es }
	  ob($2E);ob($89);ob($1E);ow($0116);  { mov cs:[116],bx }
	  ob($5B);                            { pop bx   bx=IP  }
	  ob($58);                            { pop ax   ax=CS  }
	  ob($50);                            { push ax         }
	  ob($53);                            { push bx         }
	  ob($2E);ob($A3);ow($0120);          { mov cs:[120],ax }
	  ob($2E);ob($89);ob($0E);ow($0112);  { mov cs:[112],cx }
	  ob($2E);ob($89);ob($16);ow($0114);  { mov cs:[114],dx }
	  ob($2E);ob($89);ob($2E);ow($011A);  { mov cs:[11A],bp }
	  ob($2E);ob($89);ob($36);ow($011C);  { mov cs:[11C],si }
	  ob($2E);ob($89);ob($3E);ow($011E);  { mov cs:[11E],di }
	  ob($9C);                            { pushf           }
	  ob($58);                            { pop ax          }
	  ob($2E);ob($A3);ow($0128);          { mov cs:[128],ax }
	  ob($2E);ob($8E);ob($1E);ow($10C);   { mov ds,cs:[10C] }
	  ob($FC);                            { cld             }
	end;
  { @SELF 210: is handled in DoCompile as data structure }
  { @REF  212: is handled in DoCompile as data structure }
  { MAKE }
  160: begin
	 w := holewort;
	 if w = EMPTY then error(2);
	 if not found then error(4);
	 adr1 := par0;
	 if wtyp <> _VECTOR then error(29);
	 w := holewort;
	 if w = EMPTY then error(2);
	 if not found then error(4);
	 if wtyp <> _PROC then error(30);
	 adr2 := par0;
	 ob($be); ow(adr1);         { mov si,adr1  }
	 ob($2E);ob($c6); ob($04); ob($E9); { mov cs:[si],$E9 }
	 ob($46);                   { inc si       }
	 ob($2e);ob($c7); ob($04);          { mov cs:[si],cfa }
	 ow(near(adr1,adr2) - 1);
       end;
  208 : if optimize then begin
         merker := optmerker;
         error(4);
        end        else error(65);

  { @GLOBAL }
  215 : begin
          ob($1E);                       { PUSH DS }
          ob($2E); ow($1E8E); ow($010C); { mov DS,CS:[DSEG] }
          ptrflag := true;
          ptrdone := false;
        end;
  else sys := false;
  END { case }
 else sys := false;
end;


procedure CopyMacro(strt,len:word);

{ Copiere len Bytes von cfa nach pc }

var i:word;

      begin
	i := 0;
	while i < len  do
	  begin
	    ob(M^[strt]);
	    inc(strt);
	    i := i+1;
	  end;
      end;

procedure CopyMacroD(strt,len:word);

{ Copiere len Bytes von par0 nach dpc }

var i:word;

      begin
	i := 0;
	while i < len  do
	  begin
	    obd(DSEG^[strt]);
	    inc(strt);
	    i := i+1;
	  end;
      end;


procedure DoCompile;

{ Compiliere bis Semikolon }

var len,adr:word; 
    disp,Fehler:Integer;
    w:WortTyp;
    pa,pb,pa1 : word;
label ok;

begin

  repeat
   w := HoleWort;
    if (wtyp=181) or (wtyp=161) then error(44);
    if w = EMPTY then error(2);
    TueSystem(w);
    if sys then regfix := 0;
    if wtyp = 130 then
       begin
	regfix := 2;
	goto ok;
       end;
    if wtyp = 131 then
       begin
	regfix := 3;
	goto ok;
       end;
    if wtyp = 170 then
       begin
	regfix := 1;
	goto ok;
       end;
    if wtyp = 186 then
       begin
	regfix := 4;
	goto ok;
       end;
    if wtyp = 194 then
       begin
	regfix := 5;
	goto ok;
       end;
    if sys then goto ok;

    { in Dictionary suchen }

    if not found then error(4);

    if regfix <> 0 then
    begin
       case wtyp of
	 _CONST  :Tueliteral(par0);
	 _BCONST :Tueliteral(par0);
	 _ACONST :Tueliteral(par0);
	 _DCONST :TueDliteral(par0,par1);
	 _FCONST :TueFLiteral(par0,par1,par2,par3);
	 else TueLiteral(par0)
       end;
    goto ok;
    end;


    { Konstante? }

    if (wtyp in [ _CONST,_BCONST]) then
       begin
       regfix := 2;
       TueLiteral(par0);
       goto ok;
       end;

    if wtyp = _DCONST then
       begin
       regfix := 1;
       TueDLiteral(par0,par1);
       goto ok;
       end;

    if wtyp = _FCONST then
       begin
       TueFLiteral(par0,par1,par2,par3);
       goto ok;
       end;

    { ? Adresskonstante }

    if wtyp = _ACONST then
       begin
       regfix := 5;
       TueLiteral(par0);
       goto ok;
       end;


    regfix := 0;

    { KOLON ? }

    if (wtyp = _KOLON) and (PAR1 < macro) then
      begin
	CopyMacro(par0,par1-1);
	goto ok;
      end;

    if wtyp = _MACRO then begin
      move(par0,M^[pc],(qfalen and $FF00) shr 8);
      pc := pc+(qfalen and $FF00) shr 8;
    goto ok;
    end;

    { ^ }
    if wtyp=216 then begin
      wtyp := lasttyp;
      lastobj := lastrefobj;
      ow($34C5); { lds si,[si] }
      ob($2E);ow($3689);ow($0182); { mov cs:[0182],si = set @self-ptr }
      goto ok;
    end;
     { DATENSTRUKTUR? }

     { @SELF }
     if wtyp=210 then begin
         pb := pc;
         ob($2E);ow($368B);ow($0182);  { mov si,cs:[0182] = @self-ptr }
         lastobj := actobjsig;
         pa := pc;
         goto ok;
     end;

     { @REF }
     if wtyp=212 then begin
         w := holewort;
         if wtyp=255 then error(4);
         if wtyp<>_object then error(67);
         goto ok;
     end;
     
     if wtyp < 10 then
       begin
       reclen := par1;
       if wtyp=_object then begin
         ow($F289); { mov dx,si }
         ob($BE); ow(par0);  { mov si,adr }
         goto ok;
       end else begin
         ob($BE); ow(par0);  { mov si,adr }
       end;
       if wtyp > 4 then goto ok;
       if par2 = 0 then goto ok;
       CopyMacro(par2,par3-1);
       goto ok;
     end;

    { Object field }
    if (wtyp and $40) <>0 then begin
      wtyp := wtyp and $BF;
      case wtyp of
      _proc       : begin
                         ob($2E);ow($36FF);ow($0182); { push cs:[0182] @self}
                         ob($2E);ow($3689);ow($0182); { mov cs:[0182],si = set @self-ptr }
                         ow($C681);  { add si,par0 }
                         ow(par0);
                         ob($52);    { push dx }
                         ow($148B);  { mov dx,[si] }
                         ob($5E);    { pop si }
                         ow($D2FF);  { call dx }
                         ob($2E);ow($068F);ow($0182); { push cs:[0182] @self}
               	         ow($8E2E);ob($1E);ow($10C); { mov ds, cs:010C (DS) }
                    end;
      _var,_string: if par0<>0 then begin
                      ow($C681);  { add si,par0 }
                      ow(par0);
                      if ptrflag then ptrdone := false;
                    end;
      else error(68);
      end;
      goto ok;
    end;
    { sonst Vector oder Prozedur oder Label }

    ob($BA); ow(par0); { mov dx,cfa }
    ob($FF); ob($D2);  { call dx    }
    ok:
    if ptrflag and ptrdone then begin
       ptrflag := false; ptrdone := false;
       ob($1F);
    end;
    if ptrflag and not(ptrdone) then ptrdone := true;
  until wtyp = 128;
end;


procedure TueKolon;

{ Colon-Definition compilieren }

var
  w: WortTyp;
  Fehler: integer;
  cfa1:word;
  merker : PSYMTAB;
begin
  TueName;        { Header bauen }
  indef := true;
  Zeiger^.TYP := _KOLON;
  merker := zeiger;
  if main then
    begin
      ot($0102, pc);
      mn := pc;
    end;

  pcmerker := pc;
  DoCompile;
  merker^.par0 := pcmerker;  { cfa }
  merker^.par1 := pc-pcmerker; { LEN eintragen }
  tuelink;
  indef := false;
end;


procedure TueMACRO;

{ MACRO-Definition compilieren }

var
  w: WortTyp;
  Fehler: integer;
  cfa1:word;
  merker : PSYMTAB;
begin
  TueName;        { Header bauen }
  indef := true;
  Zeiger^.TYP := _MACRO;
  merker := zeiger;
  pcmerker := pc;
  DoCompile;
  if (pc-pcmerker)>10 then error(50);
  merker^.qfalen  := (byte(pc-pcmerker-1) shl 8) ;
  move(M^[pcmerker],merker^.par0,pc-pcmerker-1);
  tuelink;
  pc := pcmerker;
  indef := false;
end;


procedure TueLabel;

{ Label compilieren }

var
  w: WortTyp;

begin
  TueName;         { Header bauen }
  zeiger^.typ := _LABEL;
  zeiger^.par0 := pc;
  testsemi;
  tuelink;
end;

procedure TueProc;

{ Prozedur compilieren }

var
  w: WortTyp;
  Fehler: integer;
  cfa1:word;
  merker : PSYMTAB;

begin
  if odd(pc) then inc(pc);
  TueName;        { Header bauen }
  ofieldptr := Zeiger;
  indef := true;
  zeiger^.typ := _PROC;
  merker := zeiger;
  if main then
    begin
      ot($0102, pc);
      mn := pc;
    end;
  pcmerker := pc;
  DoCompile;
  merker^.par0 := pcmerker;  { CFA-eintragen }
  merker^.par1 := pc-pcmerker; { LEN eintragen }
  tuelink;
  indef := false;
end;



procedure TueVariable;

{ Baue Datenstruktur auf }
label ok;
var
  w              : WortTyp;
  n, Fehler,opa0,
  opa1,opa2      : integer;
  dmerker        : PSymTab;
  tst            : longint;
  xx             : word;
  xzeiger        : psymtab;
  xtyp           : byte;

procedure TueString;

{ String-Definition compilieren }

var
  z: char;
  n, Fehler: integer;
  w: Worttyp;
begin
  xzeiger^.typ := _STRING;
  dmerker := xzeiger;
  if odd(dpc) then inc(dpc);
  pcmerker := dpc;
  if local then pcmerker := lpc;
  if fparam then pcmerker := ppc;
  if merker = 'STRING' then
   begin
    w := HoleWort;
    if wtyp=255 then error(4);
    if not(wtyp in [_CONST,_BCONST]) then error(7);   { Zahl erwartet }
    n := par0;
    if not local then dpc := dpc +par0 +1
                 else if not fparam then lpc := lpc -par0 -1
                                    else ppc := ppc +par0+ 1;
   end else begin                 { Stringliteral }
    if local then error(60);
    z := HoleZeichen;
    if z = EMPTY then error(43);  { Stringende fehlt }
    n := 0;
    while (z<>'"') do
     begin
      obd(ord(z));
      z := Holezeichen;
      inc(n);
     end;
     obd(0);   { Abschlussbyte }
     z := holezeichen;
   end;
  dmerker^.par0 := pcmerker;
  if (local) and not(fparam) then dmerker^.par0 := lpc;
  dmerker^.par1 := n;
end;

procedure TueVarInit ;

{ Initialisiere Datenstruktur }

var 
 w:worttyp;
 Fehler,count:word;

begin
  if local then error(60);
  dmerker^.par2 := 0; { cfa }
  dmerker^.par3 := 0; { codlen }
  { if odd(dpc) then dpc := dpc+1; }
  dmerker^.par0 := dpc;
  w := holewort;
  if w = EMPTY then error(7);
  count := 0;
  repeat
	case wtyp of
        255     : error(4);
	_BCONST : begin obd(par0);inc(count); end;
	_DCONST : begin owd(par0); owd(par1);inc(count,4); end;
	_FCONST : begin owd(par0);owd(par1);owd(par2);owd(par3);inc(count,8);end;
	else begin owd(par0);inc(count,2); end;
	end;
	w := holewort;
  until w=']';
  dmerker^.par1 := count;
end;


procedure TuePointer;
begin
  w := holewort;
  if local then error(60);
  if not(wtyp in [_VAR,_STRING,_OBJECT]) then error(36);
  dmerker^.typ := wtyp;
  dmerker^.par2 := par2;
  dmerker^.par3 := par3;
  if odd(dpc) then dpc := dpc+1;
  dmerker^.par0 := dpc;
  owd(0);owd(0);
  owd(par1+1);owd(par0);
  dmerker^.par1 := 8;
end;

procedure addpatchlist(n:word);
begin
  inc(patchlist[0]);
  patchlist[patchlist[0]] := n;
end;

procedure TuePointerTo;
begin
  w := holewort;
  if local then error(60);
  if not(wtyp in [_VAR,_STRING,_OBJECT]) then error(36);
  dmerker^.typ := wtyp;
  dmerker^.par2 := par2;
  dmerker^.par3 := par3;
  if odd(dpc) then dpc := dpc+1;
  dmerker^.par0 := dpc;
  owd(par0);
  addpatchlist(dpc);
  owd($FFFF);
  owd(par1+1);owd(par0);
  dmerker^.par1 := 8;
end;

procedure TueVarDo;

{ Compiliere DO: code in VAR }

begin
if local then error(60);
pcmerker := pc;
dmerker^.par2 := pc;          { cfa }
if opa2<>0 then begin
    ob($BA); ow(opa2); { mov DX,cfa }
    ob($FF); ob($D2);  { call DX    }
end;
DoCompile;
dmerker^.par3 := pc-pcmerker; { codlen }
end;



begin  { Hauptteil von TueVariable }
  TueName;
  Ofieldptr := Zeiger;
  if local then xzeiger := LZeiger
           else xzeiger := Zeiger;
  tst := dpc;
  if local then tst := lpc;
  if fparam then tst := ppc;
  xzeiger^.typ := _VAR;
  dmerker := xzeiger;
  w := HoleWort;
  if w = EMPTY then error(7);
  if (wtyp=155) or (wtyp=164) then
     begin
      merker := w;
      Tuestring;
      TestSemi;
      goto ok;
     end;
  if wtyp = 129 then
     begin
      TueVarInit;
      TestSemi;
      goto ok;
     end;
  if wtyp = 213 then
     begin
       TuePointer;
       TestSemi;
       goto ok;
     end;
  if wtyp = 214 then
     begin
       TuePointerTo;
       TestSemi;
       goto ok;
     end;
  if not (wtyp in [_VAR,_String,_Object]) then error(36);
  xtyp := wtyp;
  dmerker^.par0 := 0;
  dmerker^.par1 := par1;
  dmerker^.par2 := par2;
  dmerker^.par3 := par3;

  {  if (odd(dpc)) and ( not(local)) then dpc := dpc+1; }
  opa0 := par0;
  opa1 := par1;
  opa2 := par2;
  w := HoleWort;
  dmerker^.par0 := dpc;
  if (w = ';') or (w = 'DO:') then
   begin
    if not local then begin

      case xtyp of
      _string : begin
                  CopyMacroD(opa0-2,opa1+3);
                  inc(dmerker^.par0,2);
                  dmerker^.typ := _string;
                end;
      _object : begin
                  CopyMacroD(opa0,opa1);
                  dmerker^.typ := _object;
                end;
      else CopyMacroD(opa0,opa1);  { Datenzellen bertragen }
      end;
    end;
    if local and not(fparam) then begin
       dec(lpc,dmerker^.par1);
       dmerker^.par0 := lpc;
    end;
    if fparam then begin
       dmerker^.par0 := ppc;
       inc(ppc,dmerker^.par1);
    end;
   end
  else
   begin
     n := par0;
     if wtyp=255 then error(4);
     if not(wtyp in[ _CONST,_BCONST]) then error(7); { Zahl erwartet }
     dmerker^.par1 := opa1*n;
     if not local then dpc := dpc + opa1*n;
     if local and not(fparam) then begin
       dec(lpc,dmerker^.par1);
       dmerker^.par0 := lpc;
     end;
     if fparam then begin
       dmerker^.par0 := ppc;
       inc(ppc,dmerker^.par1);
     end;
     w := HoleWort;
   end;
  if w = 'DO:' then
   begin
    TueVarDo;
    goto ok; 
   end;
  if wtyp <> 128 then error(41);
  oK:
  tst := (dpc-tst) and $7FFFFFFF;
  if tst>$FFFF then error(51);
  if not local then tuelink;
end;



procedure TueFunc;

{ Funktion compilieren }

var
  w: WortTyp;
  Fehler: integer;
  params,locals : word;
  cfa1:word;
  xmerker,merker : PSYMTAB;
  pcmerker : word ;

begin
  new(LROOT);
  L := LROOT;
  L^.name :='';
  L^.rlink := nil;
  TueName;        { Header bauen }
  ofieldptr := zeiger;
  indef := true;
  local := true;
  fparam := true;
  lpc   := 0;
  ppc   := 4;
  zeiger^.typ := _PROC;
  xmerker := zeiger;
  pcmerker := pc;
   if main then
   begin
     ot($0102, pc);
     mn := pc;
   end;
   w := holewort;
  if wtyp <> 129 then error(59);
  while not(wtyp=180) do begin
   w := holewort; if not(wtyp in [163,180]) then error(36);
   if wtyp<> 180 then tuevariable;
  end;
  params := ppc-4;
  fparam := false;
  w := holewort;
  while wtyp=163 do begin
    tuevariable;
    w := holewort;
  end;
  if w<>'BEGIN' then error(61);
  locals := -lpc;
  { Prolog }
  ob($55);     { PUSH BP }
  ow($E589);   { MOV BP,SP }
  ow($EC81);
  ow(locals);   { SUB SP,locals }
  DoCompile;
  dec(pc);
  { Epilog }
  ow($EC89);   { MOV SP,BP }
  ob($5D);     { POP BP }
  ob($C2);
  ow(params);   { RET nnnn }
  xmerker^.par0 := pcmerker;  { CFA-eintragen }
  xmerker^.par1 := pc-pcmerker; { LEN eintragen }
  zeiger := xmerker;
  indef := false;
  local := false;
  tuelink;
  merker := LROOT ;
  repeat
    L := merker^.rlink;
    dispose(merker);
    merker := L;
  until merker=nil;
end;



procedure TueCSVariable;

{ Baue Datenstruktur auf }
label ok;
var
  w              : WortTyp;
  n, Fehler,opa0,
  opa1,opa2      : integer;
  dmerker        : PSymTab;
  tst            : longint;
  xx             : word;
  WT             : byte;

procedure TueString;

{ String-Definition compilieren }

var
  z: char;
  n, Fehler: integer;
  w: Worttyp;
begin
  zeiger^.typ := _CSSTRING;
  dmerker := zeiger;
  { in Codebereich: }
  pcmerker := pc;
  dmerker^.par0 := pcmerker;     { par0 }
  if merker = 'STRING' then
   begin
    w := HoleWort;
    if wtyp = 255 then error(4);
    if not(wtyp in [_CONST,_BCONST]) then error(7);   { Zahl erwartet }
    n := par0;
    pc := pc +par0 +1;
   end else begin                 { Stringliteral }
    z := HoleZeichen;
    if z = EMPTY then error(43);  { Stringende fehlt }
    n := 0;
    while (z<>'"') and (z<>EMPTY) do
     begin
      ob(ord(z));
      z := Holezeichen;
      inc(n);
     end;
   ob(0);   { Abschlussbyte }
   end;
   z := holezeichen;
 dmerker^.par1 := n;
end;




procedure TueVarInit ;

{ Initialisiere Datenstruktur }

var 
 w:worttyp;
 Fehler,count:word;

begin
  if odd(pc) then inc(pc);
  dmerker^.par2 := 0; { cfa }
  dmerker^.par3 := 0; { codlen }
  dmerker^.par0 := pc;
  w := holewort;
  if w = EMPTY then error(7);
  count := 0;
  repeat
	case wtyp of
        255     : error(4);
	_BCONST : begin ob(par0);inc(count); end;
	_DCONST : begin ow(par0); ow(par1);inc(count,4); end;
	_FCONST : begin ow(par0);ow(par1);ow(par2);ow(par3);inc(count,8);end;
	else begin ow(par0);inc(count,2); end;
	end;
	w := holewort;
  until w=']';
  dmerker^.par1 := count;
end;


begin  { Hauptteil von TueCSVariable }
  TueName;
  tst := dpc;
  zeiger^.typ := _CSVAR;
  dmerker := zeiger;
  w := HoleWort;
  if w = EMPTY then error(7);
  if (wtyp=155) or (wtyp=164) then
     begin
      merker := w;
      Tuestring;
      TestSemi;
      goto ok;
     end;
  if wtyp = 129 then
     begin
      TueVarInit;
      TestSemi;
      goto ok;
     end;

  if not ((wtyp=_VAR)or(wtyp=_CSVAR)) then error(36);
  wt := wtyp;
  dmerker^.par0 := 0;
  dmerker^.par1 := par1;
  dmerker^.par2 := par2;
  dmerker^.par3 := par3;

  if odd(pc) then inc(pc);
  opa0 := par0;
  opa1 := par1;
  opa2 := par2;
  w := HoleWort;
  dmerker^.par0 := pc;
  if (w = ';') then
   begin
    if wt=_VAR then CopyMacroD(opa0,opa1)  { Datenzellen bertragen }
	       else CopyMacro(opa0,opa1);
  end
  else
   begin
     n := par0;
     if not(wtyp in[ _CONST,_BCONST]) then error(7); { Zahl erwartet }
     dmerker^.par1 := opa1*n;
     pc := pc + opa1*n;
     w := HoleWort;
   end;
  if wtyp <> 128 then error(41);
  oK:
  tuelink;
end;




procedure TueKonstante;

{ Konstanten-Definition compilieren }

var
  w: WortTyp;
  z:psymtab;
begin
  TueName;         { Header bauen }
  w := HoleWort;
  case wtyp of
    255            : error(4);
    _CONST,_ACONST : begin
			zeiger^.typ := _CONST;
			zeiger^.par0 := par0;
		     end;
    _BCONST: begin
			zeiger^.typ := _BCONST;
			zeiger^.par0 := par0;
		     end;
    _DCONST: begin
			zeiger^.typ := _DCONST;
			zeiger^.par0 := par0;
			zeiger^.par1 := par1;
		     end;
    _FCONST: begin
			zeiger^.typ := _FCONST;
			zeiger^.par0 := par0;
			zeiger^.par1 := par1;
			zeiger^.par2 := par2;
			zeiger^.par3 := par3;

		     end;
  else error(7);
  end;
  testsemi;
  tuelink;
end;

procedure TueAKonstante;

{ Adresskonstanten-Definition compilieren }

var
  w: WortTyp;

begin
  TueName;         { Header bauen }
  zeiger^.typ := _ACONST;
  w := HoleWort;
  if wtyp=255 then error(4);
  if not(wtyp in [_CONST,_ACONST,_BCONST]) then error(7);
  zeiger^.par0 := par0;
  testsemi;
  tuelink;
end;

procedure TueVektor;

{ Vector-Definition compilieren }
var
w:worttyp;

begin
  TueName;          { Header bauen }
  zeiger^.typ  := _VECTOR;
  zeiger^.par0 := pc; { cfa }
  zeiger^.par1 := 5;  { len }
  ob($c3);          { ret , Initialwert fr Dummy Wort }
  ow($9090);        { Dummy fr Jump-Adresse }
  testsemi;
  tuelink;
end;


procedure TueMake;

var
  w : worttyp;
  adr1,
  adr2,
  typ : integer;
  gefunden : boolean;

begin
    w := holewort;
    if w = EMPTY then error(4);
    if not found then error(4);
    adr1 := par0;
    if wtyp <> _VECTOR then error(29);
    w := holewort;
    if w = EMPTY then error(4);
    if not found then error(4);
    adr2 := par0;
    if wtyp <> _PROC then error(30);
    otb(adr1,$E9);     { jmp disp }
    ot(succ(adr1), pred(near(adr1, adr2)));
end;


procedure TueMlimit;

var
 w : worttyp;

begin
 w := HoleWort;
    if wtyp=255 then error(4);
    if not(wtyp in [_CONST,_BCONST]) then error(7);
    if par0 < 7 then par0 := 7;
    if par0 >64 then par0 := 64;
    macrolim := par0;
    macro := par0;
end;

procedure TueObject;
var omerker : psymtab;
    wx      : worttyp;
    offs    : word;
    opc,odpc : word;
    xtyp : byte;

begin
  inc(objcount);
  inobj := false;
  TueName;
  omerker := zeiger;
  omerker^.typ := _object;
  if odd(dpc) then inc(dpc);
  omerker^.par0 := dpc;
  omerker^.par2 := objcount;
  tuelink;
  wx := holewort;
  if wtyp = 211 then begin
    wx := holewort;
    if wtyp=255 then error(4);
    if wtyp <> _object then error(67);
    copyMacroD(fZeiger^.par0,FZeiger^.Par1); { inherit obj_data }
    dec(objcount);
    omerker^.par2 := FZeiger^.par2; { inherit obj_signature too }
    wx := holewort;
  end;
  actobjsig := omerker^.par2;
  repeat
    opc := pc;

    odpc := dpc;
    xtyp := wtyp;
    inobj := true;
    case wtyp of
      161 : TueProc;
      156 : TueFunc;
      163 : TueVariable;
      else error(66);
    end; {case}
    inobj := false;
    Ofieldptr^.typ  := Ofieldptr^.typ or $40;
    case xtyp of
    161,156 : begin
              if overloadedp0=$FFFF then begin
                owd(OFieldPtr^.par0);
                OFieldPtr^.par0 := dpc-2-omerker^.par0;
                OFieldPtr^.par2 := objcount;
                OFieldPtr^.par3 := omerker^.par0;
              end else begin
                otd(omerker^.par0+overloadedp0,OFieldPtr^.par0);
                OFieldPtr^.par0 := overloadedp0;
                OFieldPtr^.par2 := objcount;
                OFieldPtr^.par3 := omerker^.par0;
              end;
              end;
    163:begin
          OFieldptr^.par0 := OFieldptr^.par0- omerker^.par0;
          OFieldptr^.par2 := objcount;
          OFieldPtr^.par3 := omerker^.par0;
        end;
    end;
    wx := holewort;
  until wtyp = 128 ;
  actobjsig := $FFFF;
  omerker^.par1 := dpc-omerker^.par0;
end;



procedure SichereVoc;
{ aktuelles Vocabulary sichern }
var
  v: file;
  nam:worttyp;
  gri,i,j : word;
  crs:string[80];

  procedure sv(ptr:PSYMTAB);
  begin
    blockwrite(v,ptr^,gri);
    if ptr^.llink<>nil then sv(ptr^.llink);
    if ptr^.rlink<>nil then sv(ptr^.rlink);
  end;

begin
  gri := sizeof(root^)-8;
  Nam := Name + '.LIB';
  assign(v,Pfad+Nam);
  rewrite(v,1);
  crs:='NAXOS V2.1x Library '+name+#13+#10+
     '(C) 1992 by K.Peper & A.Zissis'+#13+#10+#$1A+
     '                                  ';
  blockwrite(v,crs[1],68);
  blockwrite(v,gri,2);
  i := pc+(16-(pc mod 16))-$100;
  j := dpc+(16-(dpc mod 16));
  ot($104,(i div 16));
  ot($106,(j div 16));
  ot($108,r0);
  ot($10A,heapsize);
  blockWrite(v,M^[$100],i);
  blockwrite(v,DSEG^[0],j);
  blockwrite(v,pc,2);
  blockwrite(v,dpc,2);
  sv(root);
  close(v);
end;

procedure TueInclude;

{ Vocabulary einbinden }

var
  Name,Nam: WortTyp;
  v: file;
  x,p1,p2: psymtab;
  gr,gri,grd  : word;

begin
  if includeflag = false then error(38); { nur ein include }
  includeflag := false;
  Nam := HoleWort;
  if Nam = EMPTY then error(2);
  Name := nam+'.LIB';
  assign(v,SYSPfad+name);
  {$I-} reset(v,1);
  if ioresult <>0 then error(25);
  blockread(v,M^[$100],68); { dummy read fr Copyright }
  blockread(v,gri,2);       { Symtab element size      }
  if gri=$2020 then gri := sizeof(root^)-10;   { Ver 2.xx LIB }
  blockread(v,M^[$100],6);
  if ioresult<>0 then error(25);
  gr := (m^[$104]+256*m^[$105])*16;
  blockread(v,M^[$106],gr-6);
  if ioresult<>0 then error(25);
  seek(v,((M^[$104]+256*M^[$105])*16)+70);
  blockread(v,DSEG^[0],(M^[$106]+256*M^[$107])*16);
  if ioresult<>0 then error(25);
  blockread(v,gr,2);
  blockread(v,grd,2);
  repeat
    new(X);
    x^.qfahi := 0; { falls Ver 2.xx LIB QFA Hiword immer = 0 }
    blockread(v,x^,gri);
    if ioresult<>0 then error(25);
    x^.rlink := nil;
    x^.llink := nil;
    p1 := root;
    repeat
      p2 := p1;
      if x^.name>p1^.name then p1 := p1^.rlink
			  else p1 := p1^.llink;
    until p1 = nil;
    if x^.name>p2^.name then p2^.rlink := x
			else p2^.llink := x;
  until eof(v);
  dpc := grd;
  pc := gr;
  if rteflag and (rteadr<pc) then error(58);
  {$I+}
end;



procedure import;
var
  Nam,wx: WortTyp;
  v: file;
  x,p1,p2: psymtab;
  gr,gri,grd  : word;


begin
   comment := true;
   repeat
     wx := HW1;
   until (wtyp=179);
   comment := false;

  Nam := name+'.LIB';
  assign(v,Pfad+nam);
  {$I-} reset(v,1);
  if ioresult <>0 then error(63);
  blockread(v,M^[$100],68); { dummy read fr Copyright }
  blockread(v,gri,2);       { Symtab element size      }
  if gri=$2020 then gri := sizeof(root^)-10;   { Ver 2.xx LIB }
  blockread(v,M^[$100],6);
  if ioresult<>0 then error(63);
  gr := (m^[$104]+256*m^[$105])*16;
  blockread(v,M^[$106],gr-6);
  if ioresult<>0 then error(63);
  seek(v,((M^[$104]+256*M^[$105])*16)+70);
  blockread(v,DSEG^[0],(M^[$106]+256*M^[$107])*16);
  if ioresult<>0 then error(63);
  blockread(v,gr,2);
  blockread(v,grd,2);
  repeat
    new(X);
    x^.qfahi := 0; { falls Ver 2.xx LIB QFA Hiword immer = 0 }
    blockread(v,x^,gri);
    if ioresult<>0 then error(63);
    x^.rlink := nil;
    x^.llink := nil;
    p1 := root;
    repeat
      p2 := p1;
      if x^.name>p1^.name then p1 := p1^.rlink
			  else p1 := p1^.llink;
    until p1 = nil;
    if x^.name>p2^.name then p2^.rlink := x
			else p2^.llink := x;
  until eof(v);
  dpc := grd;
  pc := gr;
  if rteflag and (rteadr<pc) then error(58);
  {$I+}
end;

procedure compile(w: WortTyp);
{ defining_words and compiler_directives }

begin
  case wtyp of
  181 : TueKolon;
  161 : TueProc;
  156 : TueFunc;
  200 : TueMacro;
  162 : TueKonstante;
  193 : TueAKonstante;
  159 : TueCSVariable;
  163 : TueVariable;
  165 : TueVektor;
  166 : TueLabel;
  167 : TueInclude;
  168 : TueSeal;
  160 : TueMake;
  173 : SichereVoc;
  174 : ShortFlag := true;
  175 : ShortFlag := false;
  209 : TueObject;
  190 : memsizes;
  191 : IMPORT;
  else error(1);
  end; {case}
end;



procedure domap(ptr:psymtab);
var p1     : psymtab;
    n      : string;
    typ    : byte;
    adr    : word;
    used   : byte;
    sg : word;
    ofld   : boolean;
begin
  sg := mapcs ;
  if ptr^.llink<>nil then domap(ptr^.llink);
  if (ptr^.typ and $40) <> 0 then begin
    ofld := true;
    dec(ptr^.name[0],2);
    ptr^.typ := (ptr^.typ and $BF) ;
  end else ofld := false;
    if ((ptr^.typ<15) and (ptr^.typ>11))or(ptr^.typ=_LABEL)
     or(ptr^.typ=_CSVAR)or(ptr^.typ=_CSSTRING)then begin
     write(ef,' ',hex(sg,4),':',hex(ptr^.par0,4),'       ',ptr^.name);
     if ofld then write(ef,'_',hex(ptr^.par2,3));
     writeln(ef);
  end;
  if ptr^.rlink<>nil then domap(ptr^.rlink);
end;

procedure domapd(ptr:psymtab);
var p1     : psymtab;
    n      : string;
    typ    : byte;
    adr    : word;
    used   : byte;
    sg : word;
    ofld : boolean;
begin
  sg := mapds;
  if ptr^.llink<>nil then domapd(ptr^.llink);
  if (ptr^.typ and $40) <> 0 then begin
    ofld := true;
    dec(ptr^.name[0],2);
    ptr^.typ := (ptr^.typ and $BF) ;
  end else ofld := false;
  if (ptr^.typ<12) and (ptr^.typ<>10)and(ptr^.typ<>_CSVAR)
     and(ptr^.typ<>_CSSTRING) then begin
     write(ef,' ',hex(sg,4),':',hex(ptr^.par0,4),'       ',ptr^.name);
     if ptr^.typ=_object then write(ef,'_',hex(ptr^.par2,4));
     if ofld then write(ef,'_',hex(ptr^.par2,3));
     writeln(ef);
  end;
  if ptr^.rlink<>nil then domapd(ptr^.rlink);
end;

procedure dolinmap;
var I:word;
begin
   for i:=1 to lnr[0].line do begin
     write(ef,' ',lnr[i].line:5,' 0000:',hex(lnr[i].adr,4));
     if (i mod 4)=0 then writeln(ef);
   end;
end;


{ Hauptprogramm NAXOS }


begin
  dta := ptr($B800,140); { Start Bildspeicher CGA,EGA,MCGA,VGA }
  if crtreg=$03B4 then dta := ptr($B000,140); { dito bei MDA,HGC }
  new(M);
  new(DSEG);
  init;


  { Startcode }
 
  ob($EB); ob($2E);        { jmp 130            }

  { Compiler-Bereich }

  ow($0000);     { adr $102: MAIN }
  ow($0000);     { adr $104: CS Size in Paragraphs }
  ow($0000);     { adr $106: DS Size in Paragraphs }
  ow($0000);     { adr $108: SS Size in Paragraphs }
  ow($0000);     { adr $10A: Heap Size in Paragraphs }
  ow($0000);     { adr $10C: DS }
  ob($00);       { adr $10E: SS }

  { Copyright-Notiz }

  os('(C)PEPER,ZISSIS,TOSSOUNIDIS');
  ot($10E,0);
  ob(26);
  otd($106,0);                        { Video+MouseByte  init     }
  pc := $12D;                         { Codeanfang      }

  { Debug- und Overlay-Einsprung pc =$12D }
  ob($FF);ob($D2);                    { call dx         }
  ob($CB);                            { retf            }

  { pc =$130: Segmente einrichten }

  ob($FA);                            { cli             }
  ob($8C);ob($C8);                    { mov ax,cs        }
  ob($2E);ow($0603);ow($0104);        { add ax,CS:[0104] }
  ob($05);ow($0010);                  { add ax,0010      }
  ob($8E);ob($D8);                    { mov ds,ax        }
  ob($2E);ow($0603);ow($0106);        { add ax,CS:[0106] }
  ob($8E);ob($D0);                    { mov ss,ax        }
  ob($2E);ow($0603);ow($0108);        { add ax,CS:[0108] }
  ob($40);                            { inc ax           }
  ob($A3);ow($0022);                  { mov [22],ax      }
  ob($2E);ob($8C);ob($1E);ow($010C);  { mov cs:[10C],ds  }
  ob($2E);ob($8C);ob($16);ow($010E);  { mov cs:[10E],ss  }
  ob($2E);ob($A1);ow($0108);          { mov ax,cs:[108]  }
  ow($E0D1);ow($E0D1);                { shl ax,1; shl ax,1 }
  ow($E0D1);ow($E0D1);                { shl ax,1; shl ax,1 }
  ow($0E0C);                          { or  al,0E        }
  ob($A3);ow($0024);                  { mov [24],ax  }
  ow($C489);                          { mov sp,ax        }
  ob($FB);                            { sti              }

  { Videomode retten }
  ob($B4);ob($0F);                    { mov ah,0F       }
  ob($CD);ob($10);                    { int 10          }
  ob($A2);ow($1A);                    { mov [1A],al     }

  ob($FC);                            { cld             }

  { SYSINIT --> MAIN aufrufen }
  { pc := $173 }
  ob($BA);ow($0000);                  { mov dx,0000     }
  ob($FF);ob($D2);                    { call dx         }
  ow($9090);                          { Nop nop }

  { EXIT-Code: }

  ot($102,pc);                        { IF NO MAIN      }

  { Exit }
  ob($B4);ob($4C);                    { mov ah,4C       }
  ob($A0);ow($18);                    { mov al,[18]     }
  ob($CD);ob($21);                    { int 21          }

  ob($00);
  { PC = $182 }
  ow($0000);                           { Buffer for Object Base address }

  { Haupt-Programm verabschiedet }

  { Compilieren }
  actualch := ' ';
  Wort := HoleWort;
  if Wort = EMPTY then goto okmcc;
    while (Wort <> EMPTY)  do
    begin
      Compile(Wort);
      Wort := HoleWort;
    end;
  okmcc:


  { SYSINIT }
  ot($174,pc);
  for i := 1 to patchlist[0] do begin
    ow($1E8C);ow(patchlist[i]);
  end;
  ob($2E);ob($8B);ob($16);ow($0102);  { mov dx,cs:[102]    }
  ob($FF);ob($D2);                    { call dx         }
  ob($C3);                            { ret }

  { Compiler-Variablen setzen }

  if odd(pc) then inc(pc);
  ot($108, r0);
  { COM-File erzeugen }
  i := pc+(16-(pc mod 16))-$100;
  ot($104,(i div 16));
  i := dpc+(16-(dpc mod 16));
  dpc := i;
  ot($106,(i div 16));
  ot($10A,heapsize);
  if NoCodeFlag = false then
    begin
      assign(outfile,Pfad+Name + '.com');
      rewrite(outfile, 1);
      i := pc+(16-(pc mod 16));
      BlockWrite(outfile, M^[256], i-256);
      blockwrite(outfile, DSEG^[0], DPC);
      close(outfile);  
  end;

  if rteflag then error(58);
  if MapFlag then begin
     dxname := name;
     mapcs := 0;
     mapds := i div 16;
     mapss := (i+dpc+(16-(dpc mod 16))) div 16;
     maphs := mapss+M^[$104]+256*M^[$105]+1;
     assign(ef,pfad+name+'.MAP');
     rewrite(ef);
     while (length(dxname)<19) do dxname := dxname+' ';
     writeln(ef,' Start  Stop   Length Name               Class');
     writeln(ef);
     writeln(ef,' 00000H 0',hex(pc,4),'H 0',hex(pc-$FF,4),'H ',dxname,'CODE');
     writeln(ef,' ',hex(mapds,4),'0H ',hex(16*mapds+dpc,5),'H 0',hex(dpc,4),'H ',dxname,'DATA');
     writeln(ef,' ',hex(mapss,4),'0H ',hex((mapss+word(M^[$104]+256*M^[$105]))*16,5),
     'H ',hex((M^[$104]+256*M^[$105])*16,5),'H ',dxname,'STACK');
     writeln(ef,' ',hex(maphs,4),'0H ',hex(16*maphs+word(M^[$10C]+256*M^[$10D]),5),
     'H 0',hex(word(M^[$10C]+256*M^[$10D]),4),'H ',dxname,'HEAP');
     for i := 1 to length(name) do name[i] := upcase(name[i]);
     writeln(ef);
     writeln(ef,'  Address         Publics by Value');
     writeln(ef);
     domap(root);
     domapd(root);
     writeln(ef);
     writeln(ef,'Line numbers for ',name,'(',name,'.FTH) segment ',name);
     writeln(ef);
     dolinmap;
     writeln(ef);writeln(ef);
     writeln(ef,'Program entry point at 0000:0100');
     close(ef);
  end;
  result.main := word(M^[$102]+256*M^[$103]);
  result.data := word(dpc);
  result.stack:= word(M^[$108]+256*M^[$109]);
  result.heap := word(M^[$10A]+256*M^[$10B]);
  result.code := word(pc-$100);
  result.zeilen:=word(nummer);
  move(result,dta^,19);
  dispose(M);
  dispose(DSEG);
  close(f);
  if optimize then begin
    close(optf);
    if opterr then halt(254);
  end;
end.
