{$M 2048,0,0}
{$N+}
program NXO ;
{
        ************************************************************
        *         NAXOS Version 2.14  Optimizing Compiler Driver   *
        *                                                          *
        * (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
        *                                                          *
        *                      Rev. 14  30.11.93                   *
        *                                                          *
        *      NAXOS 2.xx is based on its predecessor programs     *
        *             FCC, MCC, NAXOS 1.xx, NAXOS 2.0x             *
        *   (C) 1989,90,91,92 by K.Peper, A.Zissis, I.Tossounidis  *
        ************************************************************
}

uses crt,dos;
var
  pass : word;
  fname: string;
  f    : file ;
  n : byte;
  cmpt,strt,ende : double;
  h,m,s,xs : word;
  build : boolean;
  crtreg   : word absolute $0040:$0063;
  dta      : pointer;
  result   : record
	     case boolean of
	     true : ( errorpos:word;
		      errorwort:string[16] );
	     false: ( main,data,stack,heap,zeilen,code : word );
	     end;


function hex(n, l: longint): String;

{ n in l-stellige Hexzahl wandeln }

var
  i, z: integer;
  s: String;
begin
  s := '';
  for i := 1 to l do
    begin
      z := n and 15; { Ziffer bilden }
      if z > 9 then z := z + 7;
      s := char(z + 48) + s;
      n := n shr 4; { Division durch 16 }
    end;
  hex := s;
end;


begin
  if paramcount<1 then begin
     writeln('NAXOS V2.14 Optimizing compiler driver');
     writeln('(C) 1993 by A.Zissis');
     writeln('usage: NXO sourcename [x]');
     halt(0);
  end;
  dta := ptr($B800,140); { Start Bildspeicher CGA,EGA,MCGA,VGA }
  if crtreg=$03B4 then dta := ptr($B000,140); { dito bei MDA,HGC }
  pass := 0;
  writeln('NAXOS V2.14 optimizing compiler driver');
  writeln('(C) 1993 by A.Zissis');
  writeln('Release 1.0 / 05-Dec-1993');
  writeln;writeln;
  fname := paramstr(1);
  writeln('compiling ',fname,'.FTH');
  writeln;writeln;
  if paramcount=1 then build:=true else build := false;
  if pos('.',fname)<>0 then fname := copy(fname,1,pos('.',fname)-1);
  gettime(h,m,s,xs);
  strt := 36000*h+600*m+10*s+xs div 10;
if build then begin
  write('PASS 0 (building library)',#13);
  exec('NXMAKE.EXE',fname+' 1');
  exec('NX.EXE',fname+'.$$1 -n -x');
  pass := 1;
  exec('NXMAKE.EXE',fname+' 2');
  write('                             ',#13);
end;
  repeat
    write('PASS ',pass:3,' (compiling/linking)',#13);
    exec('NX.EXE',fname+'.$$1 -n -o -x');
    n := dosexitcode;
    case n of
    0:;
    254: exec('UNCOM.EXE',fname+'.$$1');
    else begin
      gotoxy(1,22);
      writeln('NXO 2.14 --> Unexpected Error #',n-100);
      halt(1);
    end;
    end;
    inc(pass);
  until n=0;
  exec('NX.EXE',fname+'.$$1 -m -x');
  move(dta^,result,19);
  gettime(h,m,s,xs);
  ende := 36000*h+600*m+10*s+xs div 10;
  cmpt := (ende-strt) / 10 ;
  writeln;writeln;
  writeln(result.zeilen,' lines, ',cmpt:5:1,' seconds, ',result.code,' bytes code, ',result.data,' bytes data');
  writeln(result.stack,' bytes stack, ',result.heap,' bytes heap, MAIN starts at: ',hex(result.main,4),'H');
  assign(f,fname+'.$$$');
  erase(f);
  assign(f,fname+'.OPT');
  erase(f);
  assign(f,fname+'.LIB');
  erase(f);

end.



