program uncomment ;

{
**********************************************************************
*                                                                    *
*                 NAXOS Version 2.14 UNCOMMENT-utility               *
*                                                                    *
*                      (C) 1993 by A.Zissis                          *
*                                                                    *
*                     Rev. 14/01  30-Nov-1993                        *
*                                                                    *
**********************************************************************
}

uses crt,dos;
  type
  PSYMTAB      = ^SYMTAB;
  SYMTAB       = record
		  NAME : string[12];
		  TYP  : byte;
		  QFA  : word;
		  PAR0,
		  PAR1,
		  PAR2,
		  PAR3 : word;
		  QFAlen:word;
                  QFAHI :word;
		  rlink,
		  llink: PSYMTAB;
		 end;
  WortTyp      = string[16];

const uncomchar = ' ';

var
  dateiname   : string;
  name        : namestr;
  ext         : extstr;
  pfad,syspfad : dirstr;
  scratch: array[0..255] of byte;
  ds       : word;
  root         : PSymtab;
  qfa          : longint ;
  wtyp         : byte ;
  found        : boolean;
  fl           : file;
  ofl          : text ;
  wort         : worttyp;
  crtreg   : word absolute $0040:$0063;
  dta      : pointer;
  result   : record
	     case boolean of
	     true : ( errorpos:word;
		      errorwort:string[16] );
	     false: ( main,data,stack,heap,zeilen,code : word );
	     end;

procedure error(n:byte);
begin
 write('UNCOM ERROR#',n);
 case n of
   1: writeln(', can''t open ',name,'.lib');
   2: writeln(', disk read error');
   3: writeln(', ',wort,' not found.');
   else writeln;
 end;
 halt(1);
end;


procedure TueInclude(nam:string);

{ Vocabulary einbinden }

var
  Name: WortTyp;
  v: file;
  x,p1,p2: psymtab;
  gr,gri,grd  : word;

begin
  Name := nam+'.LIB';
  assign(v,name);
  {$i-} reset(v,1);
  if ioresult <>0 then error(1);
  seek(v,68);
  blockread(v,gri,2);       { Symtab element size      }
  if gri=$2020 then gri := sizeof(root^)-10;   { Ver 2.xx LIB }
  seek(v,70);
  blockread(v,scratch,15);
  gr := word(scratch[$4]+256*scratch[$5])*16;
  ds := word(scratch[$4]+256*scratch[$5]);
  gr := gr+(scratch[$6]+256*scratch[$7])*16;
  seek(v,gr+70);
  blockread(v,gr,2);
  blockread(v,grd,2);
  repeat
    new(X);
    x^.qfahi := 0; { falls Ver 2.xx LIB QFA Hiword immer = 0 }
    blockread(v,x^,gri);
    if ioresult<>0 then error(2);
    x^.rlink := nil;
    x^.llink := nil;
    p1 := root;
    repeat
      p2 := p1;
      if x^.name>p1^.name then p1 := p1^.rlink
			  else p1 := p1^.llink;
    until p1 = nil;
    if x^.name>p2^.name then p2^.rlink := x
			else p2^.llink := x;
  until eof(v);
  close(v);
  {$I+}
end;


function Suche(Name: string): boolean;

{ Namen in Dictionary suchen }
label ok,xx;
var
  va,er : integer;
  vd    : longint;
  vf    : double ;
  p1,p2 : PSYMTAB;
  n: WortTyp;
  su:boolean;

begin
  n := '';
  Name := copy(Name, 1, 12);
  su := false;

    p1 := root;
    repeat
       p2 := p1;
       if name>p1^.name then p1 := p1^.rlink
	                else p1 := p1^.llink;
    until (name=p2^.name) or (p1=nil);
    if name=p2^.name then begin
	  	     su := true;
		   end
		   else su := false;
  if su then
    begin
      qfa  := p2^.QFA+p2^.QFAHI shl 16;
      wtyp := p2^.TYP;
    end else if not(su) then  wtyp := 255;  { unbekannter Bezeichner }
    found := su;
    suche := su;
end;


procedure init;
begin
  if paramcount<1 then begin
    writeln('UNCOMMENT utility V.1.0');
    writeln('NAXOS 2.14 optimizing compiler module ');
    writeln('(C) 1993 by A.Zissis');
    halt(0);
  end;
  new(root);
  root^.rlink := nil;
  root^.llink := nil;
  root^.name  := 'FFFFFFFFFFFF';
  root^.typ   := 254;
  root^.par0  := 0;
  root^.par1  := 0;
  root^.par2  := 0;
  root^.par3  := 0;
  dta := ptr($B800,140); { Start Bildspeicher CGA,EGA,MCGA,VGA }
  if crtreg=$03B4 then dta := ptr($B000,140); { dito bei MDA,HGC }
  dateiname := paramstr(1);
  fsplit (dateiname, pfad, name, ext);
  if ext='' then ext := '.$$1';
  { Options-Voreinstellungen }
  SysPfad := getenv('NAXOS');
  if syspfad<>'' then syspfad := syspfad+'\';
  assign(fl,name+ext);
  assign(ofl,name+'.OPT');
  tueinclude(name);
end;


procedure uncom(wort:string);
var s : char ;
   xff : longint ;
begin
   s := uncomchar;
   if suche(wort) then begin
    reset(fl,1);
    xff := qfa ;
    seek(fl,qfa);
    blockread(fl,s,1);
    if wort[1] = '~' then begin
      seek(fl,qfa);
      s := uncomchar;
      blockwrite(fl,s,1);
      delete(wort,1,1);
      if suche(wort) then begin
         seek(fl,qfa);
         s := uncomchar;
         blockwrite(fl,s,1);
      end;
    end;
    if s=uncomchar then begin
      wort := '~'+wort; if wort[0]>#12 then wort[0]:=#12;
      if suche(wort) then seek(fl,qfa) else begin
        qfa := xff;
        seek(fl,qfa);
      end;
    end else seek(fl,qfa);
    s := uncomchar;
    blockwrite(fl,s,1);
    close(fl);
   end;
end;


begin
  init;
  reset(ofl);
  repeat
    readln(ofl,wort);
    uncom(wort);
  until eof(ofl);
  close(ofl);
end.
